/* A Bison parser, made by GNU Bison 3.3.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2019 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Undocumented macros, especially those whose name start with YY_,
   are private implementation details.  Do not rely on them.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.3.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* First part of user prologue.  */
#line 79 "cfg.y" /* yacc.c:337  */


#include <stdlib.h>
#include <stdio.h>
#include <sys/socket.h>
#include <unistd.h>
#include <netinet/in.h>
#include <netinet/in_systm.h>
#include <netinet/ip.h>
#include <arpa/inet.h>
#include <string.h>
#include <errno.h>
#include "route_struct.h"
#include "globals.h"
#include "route.h"
#include "dprint.h"
#include "cfg_pp.h"
#include "sr_module.h"
#include "modparam.h"
#include "ip_addr.h"
#include "resolve.h"
#include "socket_info.h"
#include "name_alias.h"
#include "ut.h"
#include "pt_scaling.h"
#include "dset.h"
#include "pvar.h"
#include "blacklists.h"
#include "xlog.h"
#include "db/db_insertq.h"
#include "bin_interface.h"
#include "net/trans.h"
#include "config.h"
#include "mem/rpm_mem.h"

#ifdef SHM_EXTRA_STATS
#include "mem/module_info.h"
#endif

#ifdef DEBUG_DMALLOC
#include <dmalloc.h>
#endif

/* hack to avoid alloca usage in the generated C file (needed for compiler
 with no built in alloca, like icc*/
#undef _ALLOCA_H


extern int yylex();
static void yyerror(char* s);
static void yyerrorf(char* fmt, ...);
static char* tmp;
static int i_tmp, rc;
static void* cmd_tmp;
static struct socket_id* lst_tmp;
static int rt;  /* Type of route block for find_export */
static str s_tmp;
static str tstr;
static struct net* net_tmp;
static pv_spec_t *spec;
static pv_elem_t *pvmodel;
static struct bl_rule *bl_head = 0;
static struct bl_rule *bl_tail = 0;

action_elem_t elems[MAX_ACTION_ELEMS];
static action_elem_t route_elems[MAX_ACTION_ELEMS];
action_elem_t *a_tmp;

static inline void warn(char* s);
static struct socket_id* mk_listen_id(char*, enum sip_protos, int);
static struct socket_id* set_listen_id_adv(struct socket_id *, char *, int);
static struct multi_str *new_string(char *s);
static int parse_ipnet(char *in, int len, struct net **ipnet);

extern int line;
extern int column;
extern int startcolumn;
extern char *finame;

struct listen_param {
	enum si_flags flags;
	int workers;
	struct socket_id *socket;
	char *tag;
	char *auto_scaling_profile;
} p_tmp;
static void fill_socket_id(struct listen_param *param, struct socket_id *s);

#ifndef SHM_EXTRA_STATS
struct multi_str{
	char *s;
	struct multi_str* next;
};
#else 
static struct multi_str *tmp_mod;
#endif

#define get_cfg_file_name \
	((finame) ? finame : cfg_file ? cfg_file : "default")



#define mk_action_(_res, _type, _no, _elems) \
	do { \
		_res = mk_action(_type, _no, _elems, line, get_cfg_file_name); \
	} while(0)
#define mk_action0(_res, _type, _p1_type, _p2_type, _p1, _p2) \
	do { \
		_res = mk_action(_type, 0, 0, line, get_cfg_file_name); \
	} while(0)
#define mk_action1(_res, _type, _p1_type, _p1) \
	do { \
		elems[0].type = _p1_type; \
		elems[0].u.data = _p1; \
		_res = mk_action(_type, 1, elems, line, get_cfg_file_name); \
	} while(0)
#define	mk_action2(_res, _type, _p1_type, _p2_type, _p1, _p2) \
	do { \
		elems[0].type = _p1_type; \
		elems[0].u.data = _p1; \
		elems[1].type = _p2_type; \
		elems[1].u.data = _p2; \
		_res = mk_action(_type, 2, elems, line, get_cfg_file_name); \
	} while(0)
#define mk_action3(_res, _type, _p1_type, _p2_type, _p3_type, _p1, _p2, _p3) \
	do { \
		elems[0].type = _p1_type; \
		elems[0].u.data = _p1; \
		elems[1].type = _p2_type; \
		elems[1].u.data = _p2; \
		elems[2].type = _p3_type; \
		elems[2].u.data = _p3; \
		_res = mk_action(_type, 3, elems, line, get_cfg_file_name); \
	} while(0)

extern int cfg_parse_only_routes;
#define IFOR(_instr) \
	if (cfg_parse_only_routes==1) {_instr;break;}


#line 211 "cfg.tab.c" /* yacc.c:337  */
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "cfg.tab.h".  */
#ifndef YY_YY_CFG_TAB_H_INCLUDED
# define YY_YY_CFG_TAB_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    FORWARD = 258,
    SEND = 259,
    DROP = 260,
    ASSERT = 261,
    EXIT = 262,
    RETURN = 263,
    LOG_TOK = 264,
    ERROR = 265,
    ROUTE = 266,
    ROUTE_FAILURE = 267,
    ROUTE_ONREPLY = 268,
    ROUTE_BRANCH = 269,
    ROUTE_ERROR = 270,
    ROUTE_LOCAL = 271,
    ROUTE_STARTUP = 272,
    ROUTE_TIMER = 273,
    ROUTE_EVENT = 274,
    SET_HOST = 275,
    SET_HOSTPORT = 276,
    PREFIX = 277,
    STRIP = 278,
    STRIP_TAIL = 279,
    APPEND_BRANCH = 280,
    REMOVE_BRANCH = 281,
    PV_PRINTF = 282,
    SET_USER = 283,
    SET_USERPASS = 284,
    SET_PORT = 285,
    SET_URI = 286,
    REVERT_URI = 287,
    SET_DSTURI = 288,
    RESET_DSTURI = 289,
    ISDSTURISET = 290,
    FORCE_RPORT = 291,
    FORCE_LOCAL_RPORT = 292,
    FORCE_TCP_ALIAS = 293,
    IF = 294,
    ELSE = 295,
    SWITCH = 296,
    CASE = 297,
    DEFAULT = 298,
    SBREAK = 299,
    WHILE = 300,
    FOR = 301,
    IN = 302,
    SET_ADV_ADDRESS = 303,
    SET_ADV_PORT = 304,
    FORCE_SEND_SOCKET = 305,
    SERIALIZE_BRANCHES = 306,
    NEXT_BRANCHES = 307,
    USE_BLACKLIST = 308,
    UNUSE_BLACKLIST = 309,
    SETFLAG = 310,
    RESETFLAG = 311,
    ISFLAGSET = 312,
    SETBFLAG = 313,
    RESETBFLAG = 314,
    ISBFLAGSET = 315,
    METHOD = 316,
    PROTO = 317,
    AF = 318,
    IS_MYSELF = 319,
    MSGLEN = 320,
    NULLV = 321,
    CACHE_STORE = 322,
    CACHE_FETCH = 323,
    CACHE_COUNTER_FETCH = 324,
    CACHE_REMOVE = 325,
    CACHE_ADD = 326,
    CACHE_SUB = 327,
    CACHE_RAW_QUERY = 328,
    XDBG = 329,
    XLOG = 330,
    XLOG_BUF_SIZE = 331,
    XLOG_FORCE_COLOR = 332,
    XLOG_PRINT_LEVEL = 333,
    XLOG_LEVEL = 334,
    PV_PRINT_BUF_SIZE = 335,
    RAISE_EVENT = 336,
    SUBSCRIBE_EVENT = 337,
    CONSTRUCT_URI = 338,
    GET_TIMESTAMP = 339,
    SCRIPT_TRACE = 340,
    FORK = 341,
    DEBUG_MODE = 342,
    DEBUG = 343,
    ENABLE_ASSERTS = 344,
    ABORT_ON_ASSERT = 345,
    LOGLEVEL = 346,
    LOGSTDERROR = 347,
    LOGFACILITY = 348,
    LOGNAME = 349,
    AVP_ALIASES = 350,
    LISTEN = 351,
    MEMGROUP = 352,
    ALIAS = 353,
    AUTO_ALIASES = 354,
    TAG = 355,
    DNS = 356,
    REV_DNS = 357,
    DNS_TRY_IPV6 = 358,
    DNS_TRY_NAPTR = 359,
    DNS_RETR_TIME = 360,
    DNS_RETR_NO = 361,
    DNS_SERVERS_NO = 362,
    DNS_USE_SEARCH = 363,
    MAX_WHILE_LOOPS = 364,
    CHILDREN = 365,
    UDP_WORKERS = 366,
    CHECK_VIA = 367,
    SHM_HASH_SPLIT_PERCENTAGE = 368,
    SHM_SECONDARY_HASH_SIZE = 369,
    MEM_WARMING_ENABLED = 370,
    MEM_WARMING_PATTERN_FILE = 371,
    MEM_WARMING_PERCENTAGE = 372,
    RPM_MEM_FILE = 373,
    RPM_MEM_SIZE = 374,
    MEMLOG = 375,
    MEMDUMP = 376,
    EXECMSGTHRESHOLD = 377,
    EXECDNSTHRESHOLD = 378,
    TCPTHRESHOLD = 379,
    EVENT_SHM_THRESHOLD = 380,
    EVENT_PKG_THRESHOLD = 381,
    QUERYBUFFERSIZE = 382,
    QUERYFLUSHTIME = 383,
    SIP_WARNING = 384,
    SERVER_SIGNATURE = 385,
    SERVER_HEADER = 386,
    USER_AGENT_HEADER = 387,
    LOADMODULE = 388,
    MPATH = 389,
    MODPARAM = 390,
    MAXBUFFER = 391,
    CHROOT = 392,
    WDIR = 393,
    MHOMED = 394,
    POLL_METHOD = 395,
    TCP_ACCEPT_ALIASES = 396,
    TCP_CHILDREN = 397,
    TCP_WORKERS = 398,
    TCP_CONNECT_TIMEOUT = 399,
    TCP_CON_LIFETIME = 400,
    TCP_LISTEN_BACKLOG = 401,
    TCP_MAX_CONNECTIONS = 402,
    TCP_NO_NEW_CONN_BFLAG = 403,
    TCP_NO_NEW_CONN_RPLFLAG = 404,
    TCP_KEEPALIVE = 405,
    TCP_KEEPCOUNT = 406,
    TCP_KEEPIDLE = 407,
    TCP_KEEPINTERVAL = 408,
    TCP_MAX_MSG_TIME = 409,
    ADVERTISED_ADDRESS = 410,
    ADVERTISED_PORT = 411,
    DISABLE_CORE = 412,
    OPEN_FD_LIMIT = 413,
    MCAST_LOOPBACK = 414,
    MCAST_TTL = 415,
    TOS = 416,
    DISABLE_DNS_FAILOVER = 417,
    DISABLE_DNS_BLACKLIST = 418,
    DST_BLACKLIST = 419,
    DISABLE_STATELESS_FWD = 420,
    DB_VERSION_TABLE = 421,
    DB_DEFAULT_URL = 422,
    DB_MAX_ASYNC_CONNECTIONS = 423,
    DISABLE_503_TRANSLATION = 424,
    SYNC_TOKEN = 425,
    ASYNC_TOKEN = 426,
    LAUNCH_TOKEN = 427,
    AUTO_SCALING_PROFILE = 428,
    AUTO_SCALING_CYCLE = 429,
    TIMER_WORKERS = 430,
    EQUAL = 431,
    EQUAL_T = 432,
    GT = 433,
    LT = 434,
    GTE = 435,
    LTE = 436,
    DIFF = 437,
    MATCH = 438,
    NOTMATCH = 439,
    COLONEQ = 440,
    PLUSEQ = 441,
    MINUSEQ = 442,
    SLASHEQ = 443,
    MULTEQ = 444,
    MODULOEQ = 445,
    BANDEQ = 446,
    BOREQ = 447,
    BXOREQ = 448,
    OR = 449,
    AND = 450,
    BOR = 451,
    BAND = 452,
    BXOR = 453,
    BLSHIFT = 454,
    BRSHIFT = 455,
    PLUS = 456,
    MINUS = 457,
    SLASH = 458,
    MULT = 459,
    MODULO = 460,
    NOT = 461,
    BNOT = 462,
    NUMBER = 463,
    ZERO = 464,
    ID = 465,
    STRING = 466,
    SCRIPTVAR = 467,
    IPV6ADDR = 468,
    IPV4ADDR = 469,
    IPNET = 470,
    COMMA = 471,
    SEMICOLON = 472,
    RPAREN = 473,
    LPAREN = 474,
    LBRACE = 475,
    RBRACE = 476,
    LBRACK = 477,
    RBRACK = 478,
    AS = 479,
    USE_CHILDREN = 480,
    USE_WORKERS = 481,
    USE_AUTO_SCALING_PROFILE = 482,
    MAX = 483,
    MIN = 484,
    DOT = 485,
    CR = 486,
    COLON = 487,
    ANY = 488,
    ANYCAST = 489,
    SCRIPTVARERR = 490,
    SCALE_UP_TO = 491,
    SCALE_DOWN_TO = 492,
    ON = 493,
    CYCLES = 494,
    CYCLES_WITHIN = 495,
    PERCENTAGE = 496
  };
#endif

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED

union YYSTYPE
{
#line 221 "cfg.y" /* yacc.c:352  */

	long intval;
	unsigned long uval;
	char* strval;
	struct expr* expr;
	struct action* action;
	struct net* ipnet;
	struct ip_addr* ipaddr;
	struct socket_id* sockid;
	struct listen_param* listen_param;
	struct _pv_spec *specval;
	struct multi_str* multistr;

#line 510 "cfg.tab.c" /* yacc.c:352  */
};

typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE yylval;

int yyparse (void);

#endif /* !YY_YY_CFG_TAB_H_INCLUDED  */



#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && ! defined __ICC && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  208
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   4897

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  242
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  80
/* YYNRULES -- Number of rules.  */
#define YYNRULES  589
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  1261

#define YYUNDEFTOK  2
#define YYMAXUTOK   496

/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                                \
  ((unsigned) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   519,   519,   522,   523,   524,   527,   528,   529,   529,
     530,   530,   531,   531,   532,   532,   533,   533,   534,   534,
     535,   535,   536,   536,   537,   537,   539,   542,   557,   566,
     581,   582,   585,   586,   600,   605,   615,   616,   619,   620,
     621,   625,   627,   629,   634,   640,   642,   646,   648,   650,
     652,   656,   659,   660,   663,   665,   667,   673,   676,   681,
     684,   687,   690,   695,   696,   699,   700,   701,   701,   706,
     706,   713,   714,   716,   717,   720,   728,   739,   740,   741,
     745,   753,   761,   767,   775,   777,   779,   783,   784,   785,
     786,   787,   791,   793,   797,   798,   804,   805,   806,   807,
     808,   809,   810,   811,   812,   813,   814,   815,   816,   817,
     818,   819,   820,   821,   822,   823,   824,   825,   826,   827,
     831,   832,   833,   837,   838,   841,   845,   846,   847,   855,
     863,   871,   879,   887,   895,   903,   911,   919,   927,   930,
     931,   934,   935,   936,   937,   938,   939,   940,   941,   942,
     943,   944,   945,   955,   956,   970,   971,   972,   973,   974,
     975,   976,   977,   978,   979,   980,   981,   982,   983,   984,
     985,   995,  1005,  1006,  1009,  1010,  1015,  1016,  1019,  1023,
    1024,  1027,  1028,  1031,  1032,  1035,  1036,  1039,  1040,  1049,
    1056,  1057,  1064,  1066,  1069,  1070,  1073,  1074,  1081,  1082,
    1089,  1090,  1097,  1098,  1100,  1101,  1105,  1106,  1109,  1110,
    1112,  1113,  1115,  1117,  1119,  1120,  1121,  1122,  1124,  1125,
    1132,  1135,  1179,  1180,  1185,  1187,  1189,  1190,  1196,  1198,
    1212,  1214,  1217,  1218,  1221,  1222,  1229,  1230,  1237,  1238,
    1242,  1270,  1271,  1273,  1274,  1277,  1278,  1281,  1282,  1292,
    1294,  1296,  1297,  1299,  1300,  1302,  1305,  1307,  1310,  1311,
    1314,  1316,  1319,  1322,  1326,  1327,  1333,  1339,  1343,  1344,
    1347,  1363,  1379,  1380,  1383,  1389,  1399,  1409,  1420,  1423,
    1432,  1437,  1445,  1461,  1464,  1470,  1473,  1481,  1487,  1490,
    1496,  1499,  1507,  1510,  1518,  1521,  1529,  1532,  1544,  1547,
    1553,  1558,  1559,  1560,  1561,  1562,  1563,  1566,  1567,  1570,
    1571,  1572,  1573,  1575,  1576,  1579,  1580,  1583,  1584,  1585,
    1588,  1604,  1609,  1610,  1611,  1613,  1618,  1621,  1624,  1627,
    1630,  1636,  1637,  1638,  1639,  1640,  1641,  1642,  1643,  1644,
    1645,  1649,  1650,  1651,  1652,  1653,  1654,  1657,  1660,  1663,
    1666,  1669,  1672,  1675,  1678,  1681,  1684,  1687,  1690,  1703,
    1716,  1738,  1739,  1740,  1741,  1742,  1745,  1746,  1747,  1750,
    1751,  1752,  1755,  1756,  1757,  1758,  1759,  1760,  1761,  1762,
    1765,  1773,  1783,  1791,  1809,  1818,  1819,  1821,  1822,  1825,
    1834,  1843,  1851,  1859,  1868,  1877,  1885,  1896,  1902,  1910,
    1915,  1925,  1932,  1939,  1949,  1954,  1961,  1971,  1976,  1983,
    1995,  2000,  2005,  2010,  2015,  2025,  2035,  2045,  2057,  2075,
    2106,  2110,  2116,  2122,  2129,  2130,  2133,  2139,  2145,  2146,
    2148,  2151,  2152,  2153,  2154,  2155,  2161,  2167,  2173,  2179,
    2182,  2188,  2189,  2191,  2194,  2196,  2197,  2199,  2201,  2202,
    2204,  2206,  2207,  2211,  2215,  2218,  2221,  2222,  2226,  2230,
    2234,  2238,  2239,  2243,  2247,  2251,  2255,  2256,  2262,  2263,
    2265,  2273,  2295,  2296,  2298,  2300,  2301,  2304,  2306,  2307,
    2309,  2311,  2312,  2315,  2317,  2318,  2320,  2333,  2335,  2337,
    2339,  2341,  2343,  2366,  2381,  2383,  2384,  2386,  2388,  2389,
    2391,  2393,  2394,  2396,  2398,  2399,  2401,  2403,  2404,  2406,
    2407,  2408,  2410,  2411,  2413,  2415,  2416,  2417,  2418,  2420,
    2421,  2423,  2425,  2429,  2432,  2435,  2438,  2442,  2444,  2445,
    2458,  2463,  2465,  2466,  2470,  2473,  2474,  2478,  2483,  2486,
    2487,  2490,  2493,  2494,  2498,  2501,  2502,  2506,  2509,  2510,
    2519,  2531,  2544,  2551,  2560,  2569,  2580,  2591,  2604,  2617,
    2628,  2639,  2652,  2665,  2674,  2681,  2704,  2740,  2742,  2745,
    2747,  2749,  2751,  2753,  2755,  2757,  2759,  2761,  2764,  2766,
    2769,  2783,  2789,  2791,  2799,  2807,  2813,  2819,  2823,  2826
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "FORWARD", "SEND", "DROP", "ASSERT",
  "EXIT", "RETURN", "LOG_TOK", "ERROR", "ROUTE", "ROUTE_FAILURE",
  "ROUTE_ONREPLY", "ROUTE_BRANCH", "ROUTE_ERROR", "ROUTE_LOCAL",
  "ROUTE_STARTUP", "ROUTE_TIMER", "ROUTE_EVENT", "SET_HOST",
  "SET_HOSTPORT", "PREFIX", "STRIP", "STRIP_TAIL", "APPEND_BRANCH",
  "REMOVE_BRANCH", "PV_PRINTF", "SET_USER", "SET_USERPASS", "SET_PORT",
  "SET_URI", "REVERT_URI", "SET_DSTURI", "RESET_DSTURI", "ISDSTURISET",
  "FORCE_RPORT", "FORCE_LOCAL_RPORT", "FORCE_TCP_ALIAS", "IF", "ELSE",
  "SWITCH", "CASE", "DEFAULT", "SBREAK", "WHILE", "FOR", "IN",
  "SET_ADV_ADDRESS", "SET_ADV_PORT", "FORCE_SEND_SOCKET",
  "SERIALIZE_BRANCHES", "NEXT_BRANCHES", "USE_BLACKLIST",
  "UNUSE_BLACKLIST", "SETFLAG", "RESETFLAG", "ISFLAGSET", "SETBFLAG",
  "RESETBFLAG", "ISBFLAGSET", "METHOD", "PROTO", "AF", "IS_MYSELF",
  "MSGLEN", "NULLV", "CACHE_STORE", "CACHE_FETCH", "CACHE_COUNTER_FETCH",
  "CACHE_REMOVE", "CACHE_ADD", "CACHE_SUB", "CACHE_RAW_QUERY", "XDBG",
  "XLOG", "XLOG_BUF_SIZE", "XLOG_FORCE_COLOR", "XLOG_PRINT_LEVEL",
  "XLOG_LEVEL", "PV_PRINT_BUF_SIZE", "RAISE_EVENT", "SUBSCRIBE_EVENT",
  "CONSTRUCT_URI", "GET_TIMESTAMP", "SCRIPT_TRACE", "FORK", "DEBUG_MODE",
  "DEBUG", "ENABLE_ASSERTS", "ABORT_ON_ASSERT", "LOGLEVEL", "LOGSTDERROR",
  "LOGFACILITY", "LOGNAME", "AVP_ALIASES", "LISTEN", "MEMGROUP", "ALIAS",
  "AUTO_ALIASES", "TAG", "DNS", "REV_DNS", "DNS_TRY_IPV6", "DNS_TRY_NAPTR",
  "DNS_RETR_TIME", "DNS_RETR_NO", "DNS_SERVERS_NO", "DNS_USE_SEARCH",
  "MAX_WHILE_LOOPS", "CHILDREN", "UDP_WORKERS", "CHECK_VIA",
  "SHM_HASH_SPLIT_PERCENTAGE", "SHM_SECONDARY_HASH_SIZE",
  "MEM_WARMING_ENABLED", "MEM_WARMING_PATTERN_FILE",
  "MEM_WARMING_PERCENTAGE", "RPM_MEM_FILE", "RPM_MEM_SIZE", "MEMLOG",
  "MEMDUMP", "EXECMSGTHRESHOLD", "EXECDNSTHRESHOLD", "TCPTHRESHOLD",
  "EVENT_SHM_THRESHOLD", "EVENT_PKG_THRESHOLD", "QUERYBUFFERSIZE",
  "QUERYFLUSHTIME", "SIP_WARNING", "SERVER_SIGNATURE", "SERVER_HEADER",
  "USER_AGENT_HEADER", "LOADMODULE", "MPATH", "MODPARAM", "MAXBUFFER",
  "CHROOT", "WDIR", "MHOMED", "POLL_METHOD", "TCP_ACCEPT_ALIASES",
  "TCP_CHILDREN", "TCP_WORKERS", "TCP_CONNECT_TIMEOUT", "TCP_CON_LIFETIME",
  "TCP_LISTEN_BACKLOG", "TCP_MAX_CONNECTIONS", "TCP_NO_NEW_CONN_BFLAG",
  "TCP_NO_NEW_CONN_RPLFLAG", "TCP_KEEPALIVE", "TCP_KEEPCOUNT",
  "TCP_KEEPIDLE", "TCP_KEEPINTERVAL", "TCP_MAX_MSG_TIME",
  "ADVERTISED_ADDRESS", "ADVERTISED_PORT", "DISABLE_CORE", "OPEN_FD_LIMIT",
  "MCAST_LOOPBACK", "MCAST_TTL", "TOS", "DISABLE_DNS_FAILOVER",
  "DISABLE_DNS_BLACKLIST", "DST_BLACKLIST", "DISABLE_STATELESS_FWD",
  "DB_VERSION_TABLE", "DB_DEFAULT_URL", "DB_MAX_ASYNC_CONNECTIONS",
  "DISABLE_503_TRANSLATION", "SYNC_TOKEN", "ASYNC_TOKEN", "LAUNCH_TOKEN",
  "AUTO_SCALING_PROFILE", "AUTO_SCALING_CYCLE", "TIMER_WORKERS", "EQUAL",
  "EQUAL_T", "GT", "LT", "GTE", "LTE", "DIFF", "MATCH", "NOTMATCH",
  "COLONEQ", "PLUSEQ", "MINUSEQ", "SLASHEQ", "MULTEQ", "MODULOEQ",
  "BANDEQ", "BOREQ", "BXOREQ", "OR", "AND", "BOR", "BAND", "BXOR",
  "BLSHIFT", "BRSHIFT", "PLUS", "MINUS", "SLASH", "MULT", "MODULO", "NOT",
  "BNOT", "NUMBER", "ZERO", "ID", "STRING", "SCRIPTVAR", "IPV6ADDR",
  "IPV4ADDR", "IPNET", "COMMA", "SEMICOLON", "RPAREN", "LPAREN", "LBRACE",
  "RBRACE", "LBRACK", "RBRACK", "AS", "USE_CHILDREN", "USE_WORKERS",
  "USE_AUTO_SCALING_PROFILE", "MAX", "MIN", "DOT", "CR", "COLON", "ANY",
  "ANYCAST", "SCRIPTVARERR", "SCALE_UP_TO", "SCALE_DOWN_TO", "ON",
  "CYCLES", "CYCLES_WITHIN", "PERCENTAGE", "$accept", "cfg", "statements",
  "statement", "$@1", "$@2", "$@3", "$@4", "$@5", "$@6", "$@7", "$@8",
  "$@9", "listen_id", "host_sep", "host", "proto", "port", "snumber",
  "phostport", "panyhostport", "alias_def", "id_lst", "listen_id_def",
  "listen_def_param", "listen_def_params", "listen_def", "$@10", "$@11",
  "any_proto", "multi_string", "blst_elem", "blst_elem_list",
  "auto_scale_profile_def", "assign_stm", "module_stm", "ip", "ipv4",
  "ipv6addr", "ipv6", "ipnet", "folded_string", "route_name", "route_stm",
  "failure_route_stm", "onreply_route_stm", "branch_route_stm",
  "error_route_stm", "local_route_stm", "startup_route_stm",
  "timer_route_stm", "event_route_stm", "exp", "equalop", "compop",
  "matchop", "intop", "strop", "script_var", "exp_elem", "exp_cond",
  "assignop", "assignexp", "assign_cmd", "exp_stm", "stm", "actions",
  "action", "if_cmd", "while_cmd", "foreach_cmd", "switch_cmd",
  "switch_stm", "case_stms", "case_stm", "default_stm",
  "module_func_param", "route_param", "async_func", "cmd", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496
};
# endif

#define YYPACT_NINF -986

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-986)))

#define YYTABLE_NINF -398

#define yytable_value_is_error(Yytable_value) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
    4666,  -127,  -123,  -106,   -98,   -70,   -69,   -59,   -56,   -55,
     -23,   -20,     4,    23,    29,    44,   298,   358,   374,   382,
     386,   389,    50,    53,    66,    67,   398,   475,   394,   418,
     423,   427,   455,   456,   466,   483,   504,   535,   551,   552,
     562,   567,   572,   602,   603,   624,   631,   646,   650,   671,
     709,   716,   107,   731,    33,   749,   757,   768,   781,   800,
     803,   806,   838,   839,   873,   875,   876,   877,   878,   880,
     882,   883,   884,   885,   887,   888,   900,   901,   902,   903,
     905,   525,   532,   906,   907,   928,   930,   931,   932,   935,
     949,   950,  -986,   209,  4497,  -986,   233,   308,   594,   599,
     199,   606,   508,   609,   634,  -986,  -986,  -986,   125,   167,
     171,   221,   224,   320,   229,   371,   235,   236,   371,   238,
     170,   157,   210,   439,   114,   240,   339,   344,  -986,   467,
    -986,   480,  -986,   481,  -986,   484,  -986,   702,  -986,   703,
     347,   348,   349,   352,   353,   355,   372,   161,   402,   172,
     409,   232,   234,   437,   438,   440,   444,   446,   465,   468,
     469,   470,   174,   185,  -986,  -986,   186,  -986,   463,   471,
     180,   182,   474,   184,   477,   490,   492,   494,   495,   496,
     497,   211,   216,   498,   499,   502,   507,   509,    61,   510,
     511,   512,   513,   514,   214,  -986,   746,  -986,   759,   506,
     763,   187,   189,   515,   516,   217,   517,   796,  -986,  -127,
    -986,    18,  -986,    51,  -986,    56,  -986,    57,  -986,    68,
    -986,    75,  -986,    76,  -986,    64,  -986,    65,  -986,  -986,
    -986,  -986,  -986,  -986,  -986,  -986,  -986,  -986,  -986,  -986,
    -986,  -986,   797,   919,  -986,  -986,  -986,  -986,  -986,  -986,
    -986,  -986,  -986,  -986,  -986,  -986,  -986,  -986,  1128,  -986,
     500,   431,   520,  -986,   898,  -986,   908,  -986,  -986,  -986,
     929,   909,  -986,  -155,   911,  -986,   401,  -986,  -986,  -986,
    -986,  -986,  -986,  -986,  -986,  -986,  -986,  -986,  -986,  -986,
    -986,  -986,  -986,  -986,  -986,  -986,  -986,  -986,  -986,   917,
    -986,  -986,  -986,  -986,  -986,  -986,  -986,  -986,  -986,  -986,
    -986,  -986,  -986,  -986,  -986,  -986,  -986,  -986,  -986,  -986,
    -986,  -986,  -986,  -986,  -986,  -986,  -986,  -986,  -986,  -986,
    -986,  -986,  -986,  -986,  -986,  -986,  -986,  -986,  -986,  -986,
    -986,  -986,  -986,  -986,   945,  -986,  -986,  -986,  -986,  -986,
    -986,  -986,  -986,  -986,  -986,  -986,  -986,  -986,  -986,  -986,
    -986,  -986,  -986,   924,  -986,  -986,  -986,  -986,  -986,  -986,
    -986,  -986,  -986,  -986,  -986,  -986,  -986,  -986,  -986,  -986,
    -986,  -986,  -986,  -986,  -986,  -986,  -986,  -986,  -986,  -986,
    -986,  -986,  -986,  -986,  -986,  -986,  -986,  -986,  -986,  -986,
    -986,  -986,  -986,  -986,  -986,   933,  -986,  -986,  -986,  -986,
    -986,  -986,  -986,  -986,  -986,  -986,   926,  -986,  -986,  -986,
     936,  -986,  4347,   523,  -986,   523,  -986,  4347,   523,  -986,
     523,  -986,  4347,  -986,  4347,  -986,  4347,  -986,   523,  -986,
     523,  -986,  -986,  -986,   425,   721,   721,   190,   941,   450,
    -986,   218,   956,   450,  -986,   957,   978,   958,   971,   984,
     983,    38,    40,   977,   991,   992,   993,    72,    78,    81,
      83,    84,    93,    94,    95,   995,   996,  1006,    97,    98,
     112,   113,  1007,   118,  1008,  1009,  1010,  1018,  1019,  3192,
    1020,  3192,  1021,   122,   123,   124,   127,   132,   133,   136,
     139,   140,   142,   144,   145,   146,  1022,  1023,  1024,  1025,
    1026,  1027,  1028,  1029,  1030,  1031,  1032,  1033,  1034,  1035,
    1036,  1037,  1038,   147,  -986,  -986,  -986,   773,  1041,  1064,
    -986,  -986,  -986,  -986,  -986,   102,  -986,  -986,  -986,  1039,
    1040,  1149,  1042,  1043,  1368,  1453,  1672,  1044,  1045,  1046,
    1047,  1049,   450,  1053,  1056,  1057,  -986,   721,  -986,  -986,
    -986,  1058,  -986,  -986,  1048,  -986,  -986,  -986,  1054,  -986,
    -101,  1050,  -986,  -986,   151,  -986,   191,  1055,  3192,  1059,
     336,  -986,   176,  -986,   193,  -986,   178,  -986,   194,  -986,
     195,  -986,   196,  -986,   518,  -986,   521,  -130,   324,  -148,
    -986,   197,  -986,   200,  -986,   201,  -986,   202,  1065,  -986,
     203,  1066,  1068,  1069,  1071,   163,  3192,  3192,  3493,  3576,
    -986,  3275,   842,  -986,  -986,  -986,  -986,  -986,  -986,  -126,
    3275,  -126,  -986,    71,  -986,   149,  -986,   215,  -986,   522,
    -986,    91,  -986,   205,  -986,   206,  -986,     0,  -986,    39,
    -986,   269,  -986,   458,  -986,   485,  -986,   489,  1060,  1061,
    1079,  1080,  1081,  1082,  1083,  1084,  1085,  1086,  1087,  1089,
    1090,  -126,  -147,  1072,  1072,  -986,    16,  1209,  1236,  -986,
    -986,  -986,  -986,  -986,  -986,  -986,  -986,  3576,  -986,  -986,
    -986,  -986,  -986,  -986,  1088,  1091,  -986,  1092,  1093,  -986,
    -986,  -986,  1095,  1094,  -153,    13,  -986,  1073,  -986,  -986,
    -986,  -986,  -986,  -986,    15,   767,  1096,   -51,  -986,    73,
    1098,  1099,  1100,  -986,  1101,   524,  -986,   335,  -986,  -986,
    1104,  1105,  1106,  1107,  1110,  1109,  1112,  1111,   539,  1113,
    1114,  1115,  1116,  1117,  1118,  1119,  1120,  1121,  1122,   540,
    -986,  1123,  1124,  1127,  1129,  1126,  1130,  1131,  1132,  1133,
    1134,  1135,  1136,  -986,  1137,  1138,  -986,  -986,  -986,  -986,
    1139,  1140,  -986,  -986,   346,  -986,  1757,  3576,  -986,  3576,
    -986,   680,  -986,   385,  -986,  3192,  3192,  3793,  1264,  -986,
    -986,  -986,  -986,  -986,  -986,  -986,  -986,  -986,   538,   366,
    -986,   371,   381,  1142,  -986,  1260,  1144,  1145,  1146,  1147,
    1150,  1162,  1163,  1164,   556,  1165,  -986,  1167,  1168,  1169,
    1190,  1192,  1193,  1194,  1197,  1211,  1212,   607,  1213,   690,
    1215,   705,  1216,   706,  1151,  1228,  1229,  1230,  1231,  1232,
    1239,   -44,   357,   451,   380,   734,  1249,  1250,  1251,  1252,
    -986,   148,  1253,   735,  1254,  -986,  -986,  -152,  -986,  -986,
     778,  -986,  -986,   788,  4347,  4347,  4347,  4347,  1247,  4347,
    -986,  -986,  -986,  -986,  -986,    47,  -986,  -986,  1275,  1277,
     -51,  -986,  -986,  1255,  -986,  -101,  -986,  1125,  -986,  -986,
    -986,  1285,  -986,  1286,  -986,  -986,  -986,  -986,  1289,  -986,
    1303,  -986,   479,  -986,  -986,  -986,  -986,  -986,  -986,  -986,
    -986,  -986,  -986,  -986,  1304,  -986,  -986,  -986,  1305,  1307,
    -986,  -986,  -986,  -986,  -986,  -986,  -986,  -986,  -986,  -986,
    -986,  -986,  -986,  -986,  -986,   738,  3576,  3576,  3576,  3576,
    3576,  3576,  3576,  3576,  3576,  3576,  -986,  -986,  -986,  -986,
    1976,  3876,  -986,  -986,  -986,  -986,  -986,  -986,  -986,  1299,
    -126,  -986,  -986,  -986,  -986,  -986,  -986,  -986,  -986,  1102,
    -986,  -986,  -986,  -986,  -986,  -986,  -986,  -986,  -986,  -986,
    -986,  -986,   789,  -986,  -986,   792,  -986,  -986,   793,  -986,
    -986,  1318,  -986,  1319,  1320,  1321,  1322,  1330,  1331,  1332,
    -986,  -986,  -986,  -986,  1333,  -986,  -986,  -126,  -986,  1334,
    1335,  -126,  1336,  -986,    42,   523,   523,  -986,  -986,  -986,
    -986,  -986,   -57,  -986,  2061,  2280,  2365,  2584,  1328,  2669,
    -986,  -986,  -986,  -986,  1337,   411,  -986,  1263,  1338,  1339,
    1340,  1341,  -986,  -986,  -986,  -986,   790,  1342,  1343,  1344,
    -986,   635,   635,   635,   635,   635,  -986,  -986,  -986,  -986,
    -986,  -986,  -986,  1274,  1345,  1346,  1347,  1348,  1349,  1350,
    1351,  1352,  1353,  1356,  1357,  1358,  1359,  1360,  1363,   791,
     384,   419,   794,   795,  1365,  1364,   820,  1366,  -986,   821,
    1369,  1370,  -986,  -986,  -986,  -986,  -986,  -986,  -986,  4347,
    -986,   411,  1367,  1378,  -986,  -986,  -986,  -986,   501,  -986,
    -986,  -986,  -986,   772,  1329,   576,  -986,  3876,  -986,  -986,
    -986,  -986,  -986,  -986,  -986,  -986,  1379,  -126,  -126,  -986,
     331,   334,  1380,  -986,  -986,  -986,  -126,  -986,  1384,  -986,
    1382,  -986,  1383,  -986,  -986,  -986,  -986,  -986,  2888,  1381,
    -153,  -150,  -986,  -986,  -986,  -986,  1317,  1323,  -986,  1372,
    -986,  -986,  -986,   824,  1377,  1387,  1385,  1386,  1390,  1391,
    1392,  1393,  1394,  1397,  1396,  -986,  -153,  1399,  1314,  1388,
    4094,  4177,  4347,   341,  -986,  -986,  -986,  1400,  1401,  1408,
    1409,  -986,  -986,  -986,  1389,  -986,  1402,  1410,  1411,  1315,
    1403,   760,  1405,   845,  2973,  1412,  1413,   825,   828,   829,
     832,  1407,  1415,  1414,  1108,  1419,  -986,  1416,  -986,  1417,
    -986,  -986,  -126,  -986,  -126,  -986,  -126,  -986,  -126,  -986,
    1418,  1420,  -986,  1427,  1316,  -986,  -986,  1421,  1422,  1423,
    1424,  1428,  -986,  1431,  1429,  -986,  -986,  -986,  -986,  -126,
    1301,  1438,  1430,  1437,  1529,  -986,  1425,  1439,  -986,  1432,
    -986
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    26,     0,     0,     4,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     6,     7,   262,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   104,     0,
     106,     0,   108,     0,   110,     0,   112,     0,   114,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   264,   263,     0,   267,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   245,     0,   247,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     1,     5,
       3,     0,     9,     0,    11,     0,    13,     0,    15,     0,
      17,     0,    19,     0,    21,     0,    23,     0,    25,   214,
     211,   215,   212,   216,   213,   218,   217,   210,   209,    85,
      92,    91,     0,     0,    38,    84,    88,    87,    90,    89,
      86,    94,    93,    96,    95,    98,    97,   220,     0,    35,
       0,    66,    65,   219,     0,   224,    32,    28,   271,   270,
       0,     0,    47,    29,     0,    51,    52,   223,    27,   268,
     272,   269,   226,   225,   100,    99,   102,   101,   103,   105,
     107,   109,   111,   113,   116,   115,   120,   119,   123,   121,
     127,   126,   129,   128,   131,   130,   133,   132,   135,   134,
     137,   136,   139,   138,   141,   140,   143,   142,   145,   144,
     147,   146,   149,   148,   151,   150,   153,   152,   155,   154,
     157,   156,   159,   158,   161,   160,   204,   203,   206,   205,
     208,   207,   243,   242,     0,   118,   117,   164,   163,   162,
     167,   166,   165,   169,   168,   172,   170,   171,   174,   173,
     176,   175,   179,   177,   181,   180,   183,   182,   185,   184,
     187,   186,   190,   188,   189,   192,   191,   194,   193,   198,
     197,   200,   199,   202,   201,   196,   195,   228,    32,   227,
     230,   229,   232,   231,   234,   233,   236,   235,   238,   237,
     241,   239,   240,   244,   246,     0,   249,   251,   250,   253,
     252,   255,   254,   257,   256,   259,     0,   258,   261,   260,
     124,   283,     0,     0,   285,     0,   288,     0,     0,   290,
       0,   292,     0,   294,     0,   296,     0,   298,     0,   300,
       0,    39,    40,    44,     0,     0,     0,     0,     0,     0,
      31,     0,     0,     0,    53,     0,     0,     0,     0,     0,
       0,     0,     0,   432,     0,   434,   438,     0,     0,     0,
       0,     0,     0,     0,     0,   489,     0,     0,     0,     0,
       0,     0,   510,     0,   515,   517,   519,   521,   524,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   320,   378,   321,     0,     0,     0,
     370,   373,   374,   375,   376,     0,   279,   278,   280,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    45,
      41,     0,     0,     0,     0,     0,    57,    63,    70,    68,
     222,    73,   221,   273,    48,    34,    33,   122,     0,   178,
       0,     0,   125,   424,     0,   428,     0,     0,     0,     0,
       0,   441,     0,   468,     0,   472,     0,   475,     0,   495,
       0,   478,     0,   484,     0,   481,     0,     0,     0,     0,
     501,     0,   504,     0,   498,     0,   507,     0,     0,   512,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     324,     0,   325,   306,   322,   363,   323,   362,   361,     0,
       0,     0,   528,     0,   532,     0,   535,     0,   539,     0,
     542,     0,   545,     0,   548,     0,   445,     0,   448,     0,
     451,     0,   456,     0,   461,     0,   466,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   568,     0,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,     0,   377,   371,
     281,   369,   379,   372,     0,     0,   286,     0,     0,   291,
     293,   295,     0,     0,     0,     0,    61,    54,    60,    58,
      59,    62,    64,    74,     0,     0,     0,     0,    78,     0,
       0,     0,     0,   423,     0,     0,   431,     0,   433,   437,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     488,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   509,     0,     0,   514,   516,   518,   520,
       0,     0,   523,   303,     0,   365,     0,     0,   342,     0,
     341,   343,   344,     0,   345,     0,     0,     0,   380,   366,
     307,   309,   310,   311,   312,   308,   313,   314,   315,   316,
     319,     0,     0,     0,   382,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   540,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     582,     0,     0,     0,     0,   404,   399,   401,   565,   407,
       0,   359,   360,   358,     0,     0,     0,     0,     0,     0,
      36,    37,    46,    43,    42,     0,    50,    49,     0,     0,
       0,    71,    72,     0,    79,     0,   248,     0,   425,   422,
     429,     0,   426,     0,   435,   436,   442,   439,     0,   469,
       0,   473,     0,   470,   476,   474,   496,   494,   479,   477,
     485,   483,   482,   480,     0,   487,   490,   491,     0,     0,
     502,   500,   505,   503,   499,   497,   508,   506,   513,   511,
     525,   522,   304,   364,   356,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   305,   302,   301,   368,
       0,     0,   329,   274,   275,   330,   328,   327,   326,     0,
       0,   527,   526,   531,   529,   530,   534,   533,   538,     0,
     536,   541,   544,   543,   547,   546,   443,   444,   446,   447,
     449,   450,     0,   454,   455,     0,   459,   460,     0,   464,
     465,     0,   588,     0,     0,     0,     0,     0,     0,     0,
     276,   569,   277,   570,     0,   571,   572,     0,   575,     0,
       0,     0,     0,   421,     0,     0,     0,   587,   567,   405,
     402,   408,   403,   566,     0,     0,     0,     0,     0,     0,
      56,    55,   265,   266,     0,     0,    77,     0,     0,     0,
       0,     0,   412,   411,   410,   413,     0,     0,     0,     0,
     357,   352,   351,   353,   354,   355,   346,   347,   349,   348,
     350,   367,   381,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   418,     0,
       0,     0,   406,   400,   409,   282,   284,   287,   289,     0,
     299,     0,     0,     0,   427,   430,   440,   467,     0,   471,
     486,   492,   493,     0,     0,   386,   388,     0,   537,   452,
     453,   457,   458,   462,   463,   589,     0,     0,     0,   552,
       0,     0,     0,   564,   573,   574,     0,   576,     0,   578,
       0,   581,     0,   583,   420,   419,   585,   586,     0,     0,
       0,     0,   417,   415,   414,   416,     0,     0,   384,     0,
     387,   385,   383,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   297,     0,     0,    83,     0,
     396,   392,   398,     0,   549,   553,   554,     0,     0,     0,
       0,   563,   577,   579,     0,   584,     0,     0,     0,    82,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   394,     0,   390,     0,
     550,   551,     0,   555,     0,   556,     0,   559,     0,   560,
       0,     0,    75,     0,     0,   393,   389,     0,     0,     0,
       0,     0,    76,     0,     0,   557,   558,   561,   562,     0,
       0,     0,     0,     0,     0,   580,     0,     0,    81,     0,
      80
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -986,  -986,  -986,  1504,  -986,  -986,  -986,  -986,  -986,  -986,
    -986,  -986,  -986,  -143,  -986,  -986,  -121,  -682,  -115,  -116,
    -986,  -986,  1373,  -986,  -986,  -400,  -986,  -986,  -986,   719,
    1067,   761,  -986,  -986,  -986,  -986,  -790,  -986,  1398,  -986,
    -985,  -660,  -410,  -986,  -986,  -986,  -986,  -986,  -986,  -986,
    -986,  -986,  -481,  -986,  -986,  -986,  -986,  -986,  -487,  -986,
    -478,  -986,  -675,  -451,  -986,  -625,  -405,  -520,  -447,  -986,
    -986,  -986,  -986,  -986,   536,  -986,   636,  -986,   979,  -456
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   272,   452,   273,   274,   872,   780,   275,
     262,   276,   277,   708,   557,   558,   263,   446,   445,   883,
     562,   718,   719,   417,   105,   106,   278,   279,   280,   281,
     955,   842,   539,   212,   214,   216,   218,   220,   222,   224,
     226,   228,   621,   798,   799,   800,   801,   802,   527,   623,
     782,   687,   783,   528,   626,   788,   529,   530,   531,   532,
     533,   534,  1114,  1115,  1116,  1161,   860,  1046,   852,   535
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     245,   260,   622,   250,   622,   804,   261,   844,   954,   691,
     630,   624,   863,   624,   873,   540,   876,   854,   542,   421,
     543,   691,   541,   874,   691,   691,   691,   544,   547,   545,
     548,   546,   877,   628,   167,   628,   317,   319,   625,   573,
     625,   575,   627,  1087,   627,   389,   559,   450,  1030,   107,
    1102,   128,   424,   108,   130,   870,  1019,   426,   429,  1020,
     524,   849,   387,   753,   524,   437,   439,   132,   134,   431,
     109,   850,   806,   581,   884,   451,   433,   435,   110,   583,
     871,   749,   585,   526,   587,   589,   524,   526,   750,  1178,
    1179,   622,   815,   731,   591,   593,   595,   727,   600,   602,
     624,   789,   934,   692,   935,   716,   111,   112,   164,   526,
     789,   752,   754,   604,   606,   265,  1149,   113,   717,   609,
     114,   115,   628,   632,   634,   636,   229,   625,   638,   622,
     622,   627,   781,   640,   642,   773,   774,   644,   624,   624,
     646,   648,   803,   650,   805,   652,   654,   656,   675,  1013,
     808,  1092,   721,   116,  1093,   524,   117,   712,   255,   259,
     628,   628,   308,   784,   770,   625,   625,  1000,   231,   627,
     627,   253,   233,   312,  1001,   338,   738,   732,   526,   737,
     118,   347,   881,   350,   848,   355,   340,   342,   407,   859,
     409,   560,   724,  1031,   735,   739,   741,   743,   755,   119,
     781,   757,   759,   761,   764,   120,   817,   819,   821,   208,
     822,   257,   372,   776,   219,   400,   811,   375,   415,   565,
     121,   870,   235,   870,   855,   237,   129,   856,   524,   131,
     240,   784,   857,   316,   858,   318,   246,   248,   422,   251,
     423,   282,   133,   135,   211,   954,   871,   823,   871,   824,
     855,   526,   168,   856,   524,   870,   691,   574,   857,   576,
    1088,  1051,  1052,  1053,  1054,  1055,  1056,  1057,  1058,  1059,
    1060,   388,   267,   425,   268,   269,   427,   526,   428,   430,
     871,   388,   267,   270,   268,   269,   438,   440,   432,   885,
     781,   582,   781,   270,   886,   434,   436,   584,   622,   622,
     586,   550,   588,   590,   947,   948,   564,   624,   624,   816,
     550,   954,   592,   594,   596,   958,   601,   603,   165,   693,
     213,   784,   258,   784,   266,   267,  1062,   268,   269,   628,
     628,   605,   607,   230,   625,   625,   270,   610,   627,   627,
     284,   633,   635,   637,  1081,   286,   639,   271,   294,   296,
     298,   641,   643,   300,   302,   645,   304,   809,   647,   649,
     810,   651,   722,   653,   655,   657,   676,  1014,   256,   723,
    1021,   771,   309,   306,   620,   232,   620,   242,   243,   234,
     254,   772,   950,   313,   244,   339,   536,   733,   537,   538,
     348,   349,   351,   352,   356,   357,   341,   343,   408,   136,
     410,   561,   725,   310,   736,   740,   742,   744,   756,   707,
     314,   758,   760,   762,   765,  1045,   818,   820,   258,   373,
     259,   374,   401,   258,   402,   259,   376,   416,   -30,   236,
     691,   789,   238,   242,   243,   242,   243,   241,   320,   322,
     244,   324,   244,   247,   249,   326,   252,   328,   283,   781,
     781,   781,   781,   781,   781,   781,   781,   781,   781,  1024,
    1025,  1026,  1027,   620,  1029,   730,   330,   734,  1177,   332,
     334,   336,   345,  1064,   122,   353,   138,   825,   358,   826,
     784,   784,   784,   784,   784,   784,   784,   784,   784,   784,
     807,   360,  1162,   362,  1196,   364,   366,   368,   370,   377,
     379,   620,   620,   381,   691,   691,   691,   691,   383,   691,
     385,   390,   392,   394,   396,   398,   411,   413,   418,   745,
    1082,   812,   747,   813,  1085,   223,   195,   859,   239,   785,
     786,   -69,   751,   197,   123,  1094,   524,   242,   243,  1166,
     785,   786,  1168,   524,   244,  1042,   524,   285,   524,  1205,
     124,   893,   287,   524,   729,   295,   297,   299,   125,   526,
     301,   303,   126,   305,   932,   127,   526,  1152,  1002,   526,
     140,   526,   242,   243,   137,  1003,   526,  -318,  -318,   244,
     307,   936,   937,   938,   939,   940,   941,   942,   943,   944,
     945,  1002,   957,   524,   141,  1000,   882,   789,  1006,   142,
     879,  -318,  1134,   143,   952,  1090,  1091,   215,   946,   258,
     311,   266,   267,   217,   268,   269,   526,   315,  1113,  1159,
     -67,  1155,   221,   270,   268,   269,   953,   225,   691,   549,
    1002,   144,   145,   270,   271,   388,   267,  1135,   268,   269,
    1164,  1165,   146,  1167,  1169,   321,   323,   270,   325,  1171,
     264,   139,   327,   227,   329,   -69,   -69,   -69,   -69,   147,
     388,   267,  1000,   268,   269,   -69,   827,  1004,   828,  1005,
     620,   620,   270,   331,   344,   288,   333,   335,   337,   346,
     148,   691,   354,   691,   691,   359,   956,  1043,   289,   290,
    1044,   524,   291,   829,  1148,   830,  1206,   831,   361,   832,
     363,   196,   365,   367,   369,   371,   378,   380,   198,  1153,
     382,   149,  1154,   524,   526,   384,   405,   386,   391,   393,
     395,   397,   399,   412,   414,   419,   746,   150,   151,   748,
     814,   536,   444,   537,   538,  1237,   526,  1238,   152,  1239,
     891,  1240,   892,   153,   -67,   -67,   -67,   -67,   154,  -317,
    -317,   268,   269,   953,   -67,   902,   914,   903,   915,   882,
     270,   689,  1252,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   969,  -317,   970,  1201,  1203,  1204,   155,   156,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     157,   490,  -395,  -395,  1217,   491,   492,   158,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   551,   159,   982,   506,   983,   160,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   941,   942,   943,   944,
     945,   516,   517,   518,   519,   520,   689,   161,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   790,   791,   792,
     793,   794,   795,   796,   797,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   162,   490,  -391,  -391,  1219,
     491,   492,   163,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   985,   166,   986,   506,
     292,   293,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   988,   991,   989,   992,   169,   516,   517,   518,   519,
     520,   521,   522,   170,   936,   937,   938,   939,   940,   941,
     942,   943,   944,   945,   171,   552,   553,   554,   555,   677,
    1007,  1016,  1008,  1017,   403,   556,  1050,   172,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   404,   242,   243,
     523,   406,   524,   242,   243,   244,   173,   525,   878,   174,
     244,  -395,   175,  1156,   936,   937,   938,   939,   940,   941,
     942,   943,   944,   945,  1022,   526,  1023,  1066,  1157,  1067,
    1068,  1070,  1069,  1071,   420,   441,  1108,  1132,  1109,  1133,
    1136,  1138,  1137,  1139,   176,   177,   521,   522,   677,   790,
     791,   792,   793,   794,   795,   796,   797,   678,   679,   680,
     681,   682,   683,   684,   685,   686,  1142,  1022,  1143,  1145,
    1183,  1222,  1184,  1223,  1224,  1226,  1225,  1227,  1228,   178,
    1229,   179,   180,   181,   182,   523,   183,   524,   184,   185,
     186,   187,   525,   188,   189,   689,  -391,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   190,   191,   192,   193,
     526,   194,   199,   200,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   201,   490,   202,   203,   204,   491,
     492,   205,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   206,   207,   442,   506,   443,
     447,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     -35,   449,   268,   453,   455,   516,   517,   518,   519,   520,
     689,   457,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   456,   459,   460,   563,   458,   566,   567,   569,   470,
     471,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   568,
     490,   570,   571,   572,   491,   492,   577,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     578,   579,   580,   506,   597,   598,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   599,   608,   611,   612,   613,
     516,   517,   518,   519,   520,   521,   522,   614,   615,   629,
     631,   658,   659,   660,   661,   662,   663,   664,   665,   666,
     667,   668,   669,   670,   671,   672,   673,   674,   688,   706,
     702,   709,   694,   695,   710,   697,   698,   711,   703,   561,
     715,   833,   834,   726,   523,   861,   524,   728,   704,   705,
     714,   525,   851,   763,   766,   690,   767,   768,   720,   769,
     835,   836,   837,   838,   839,   840,   841,   843,   845,   526,
     846,   847,   862,   868,   951,   875,   887,   960,   864,  1103,
    1065,   865,   866,   867,   869,   880,  1113,   888,   889,   890,
     521,   522,   894,   895,   896,   897,   898,   899,   900,   901,
    1037,   904,   905,   906,   907,   908,   909,   910,   911,   912,
     913,   916,   917,   918,   920,   919,  1233,  1253,   921,   922,
     923,   924,   925,   926,   927,   928,   929,   930,   931,   523,
     959,   524,   961,   962,   963,   964,   525,   993,   965,   689,
     696,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     966,   967,   968,   971,   526,   972,   973,   974,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   975,   490,
     976,   977,   978,   491,   492,   979,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   980,
     981,   984,   506,   987,   990,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   994,   995,   996,   997,   998,   516,
     517,   518,   519,   520,   689,   999,   461,   462,   463,   464,
     465,   466,   467,   468,   469,  1009,  1010,  1011,  1012,  1015,
    1028,  1035,  1018,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,  1032,   490,  1033,  1038,  1039,   491,   492,
    1040,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,  1041,  1047,  1048,   506,  1049,  1063,
     507,   508,   509,   510,   511,   512,   513,   514,   515,  1072,
    1073,  1074,  1075,  1076,   516,   517,   518,   519,   520,   521,
     522,  1077,  1078,  1079,  1080,  1083,  1084,  1086,  1099,  1180,
    1158,  1198,  1215,  1101,  1244,  1181,  1104,  1105,  1106,  1107,
    1110,  1111,  1112,  1117,  1118,  1119,  1120,  1121,  1122,  1123,
    1124,  1125,  1126,  1127,  1128,  1257,  1130,  1129,   523,  1131,
     524,  1140,  1141,  1150,  1144,   525,  1151,  1146,  1147,   699,
    1163,  1170,  1172,  1173,  1174,  1185,  1199,  1176,   210,  1034,
    1211,  1187,  1188,   526,  1182,  1186,  1189,  1190,  1207,  1208,
    1191,  1192,  1193,  1194,  1195,  1197,  1209,  1210,  1212,  1214,
    1216,  1213,  1218,  1230,   521,   522,  1231,  1234,   713,  1241,
    1220,  1221,  1232,  1235,  1236,  1243,  1250,  1251,  1242,  1245,
    1246,  1247,  1248,  1254,  1249,  1256,  1036,  1259,  1255,   454,
    1089,  1160,     0,   853,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   523,  1258,   524,     0,     0,   448,     0,
     525,  1260,     0,   689,   700,   461,   462,   463,   464,   465,
     466,   467,   468,   469,     0,     0,     0,     0,   526,     0,
       0,     0,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,     0,   490,     0,     0,     0,   491,   492,     0,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,     0,     0,     0,   506,     0,     0,   507,
     508,   509,   510,   511,   512,   513,   514,   515,     0,     0,
       0,     0,     0,   516,   517,   518,   519,   520,   689,     0,
     461,   462,   463,   464,   465,   466,   467,   468,   469,     0,
       0,     0,     0,     0,     0,     0,     0,   470,   471,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,     0,   490,     0,
       0,     0,   491,   492,     0,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,     0,     0,
       0,   506,     0,     0,   507,   508,   509,   510,   511,   512,
     513,   514,   515,     0,     0,     0,     0,     0,   516,   517,
     518,   519,   520,   521,   522,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   523,     0,   524,     0,     0,     0,     0,   525,
       0,     0,     0,   701,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   526,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   521,   522,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   523,     0,   524,
       0,     0,     0,     0,   525,     0,     0,   689,   933,   461,
     462,   463,   464,   465,   466,   467,   468,   469,     0,     0,
       0,     0,   526,     0,     0,     0,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,     0,   490,     0,     0,
       0,   491,   492,     0,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,     0,     0,     0,
     506,     0,     0,   507,   508,   509,   510,   511,   512,   513,
     514,   515,     0,     0,     0,     0,     0,   516,   517,   518,
     519,   520,   689,     0,   461,   462,   463,   464,   465,   466,
     467,   468,   469,     0,     0,     0,     0,     0,     0,     0,
       0,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,     0,   490,     0,     0,     0,   491,   492,     0,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,     0,     0,     0,   506,     0,     0,   507,   508,
     509,   510,   511,   512,   513,   514,   515,     0,     0,     0,
       0,     0,   516,   517,   518,   519,   520,   521,   522,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   523,     0,   524,     0,
       0,     0,     0,   525,     0,     0,     0,  1061,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   526,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   521,   522,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   523,     0,   524,     0,     0,     0,     0,   525,     0,
       0,   689,  1095,   461,   462,   463,   464,   465,   466,   467,
     468,   469,     0,     0,     0,     0,   526,     0,     0,     0,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
       0,   490,     0,     0,     0,   491,   492,     0,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,     0,     0,     0,   506,     0,     0,   507,   508,   509,
     510,   511,   512,   513,   514,   515,     0,     0,     0,     0,
       0,   516,   517,   518,   519,   520,   689,     0,   461,   462,
     463,   464,   465,   466,   467,   468,   469,     0,     0,     0,
       0,     0,     0,     0,     0,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,     0,   490,     0,     0,     0,
     491,   492,     0,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,     0,     0,     0,   506,
       0,     0,   507,   508,   509,   510,   511,   512,   513,   514,
     515,     0,     0,     0,     0,     0,   516,   517,   518,   519,
     520,   521,   522,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     523,     0,   524,     0,     0,     0,     0,   525,     0,     0,
       0,  1096,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   526,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   521,   522,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   523,     0,   524,     0,     0,
       0,     0,   525,     0,     0,   689,  1097,   461,   462,   463,
     464,   465,   466,   467,   468,   469,     0,     0,     0,     0,
     526,     0,     0,     0,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,     0,   490,     0,     0,     0,   491,
     492,     0,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,     0,     0,     0,   506,     0,
       0,   507,   508,   509,   510,   511,   512,   513,   514,   515,
       0,     0,     0,     0,     0,   516,   517,   518,   519,   520,
     689,     0,   461,   462,   463,   464,   465,   466,   467,   468,
     469,     0,     0,     0,     0,     0,     0,     0,     0,   470,
     471,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,     0,
     490,     0,     0,     0,   491,   492,     0,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
       0,     0,     0,   506,     0,     0,   507,   508,   509,   510,
     511,   512,   513,   514,   515,     0,     0,     0,     0,     0,
     516,   517,   518,   519,   520,   521,   522,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   523,     0,   524,     0,     0,     0,
       0,   525,     0,     0,     0,  1098,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   526,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     521,   522,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   523,
       0,   524,     0,     0,     0,     0,   525,     0,     0,   689,
    1100,   461,   462,   463,   464,   465,   466,   467,   468,   469,
       0,     0,     0,     0,   526,     0,     0,     0,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,     0,   490,
       0,     0,     0,   491,   492,     0,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,     0,
       0,     0,   506,     0,     0,   507,   508,   509,   510,   511,
     512,   513,   514,   515,     0,     0,     0,     0,     0,   516,
     517,   518,   519,   520,   689,     0,   461,   462,   463,   464,
     465,   466,   467,   468,   469,     0,     0,     0,     0,     0,
       0,     0,     0,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,     0,   490,     0,     0,     0,   491,   492,
       0,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,     0,     0,     0,   506,     0,     0,
     507,   508,   509,   510,   511,   512,   513,   514,   515,     0,
       0,     0,     0,     0,   516,   517,   518,   519,   520,   521,
     522,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   523,     0,
     524,     0,     0,     0,     0,   525,     0,     0,     0,  1175,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   526,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   521,   522,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   523,     0,   524,     0,     0,     0,     0,
     525,     0,     0,     0,  -397,   461,   462,   463,   464,   465,
     466,   467,   468,   469,     0,     0,     0,     0,   526,     0,
       0,     0,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,     0,     0,     0,     0,     0,     0,     0,     0,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,     0,     0,     0,   506,     0,     0,   507,
     508,   509,   510,   511,   512,   513,   514,   515,     0,     0,
       0,     0,     0,   516,   517,   518,   519,   520,   461,   462,
     463,   464,   465,   466,   467,   468,   469,     0,     0,     0,
       0,     0,     0,     0,     0,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,     0,   490,     0,     0,     0,
     491,   492,     0,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,     0,     0,     0,   506,
       0,     0,   507,   508,   509,   510,   511,   512,   513,   514,
     515,     0,     0,     0,     0,     0,   516,   517,   518,   519,
     520,     0,     0,   521,   522,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   242,   243,     0,     0,     0,   616,     0,
     244,     0,   523,     0,   524,     0,     0,     0,     0,     0,
       0,   617,   618,     0,   619,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   526,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   521,   522,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   785,
     786,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   523,     0,   524,     0,     0,
       0,     0,   525,     0,     0,   787,   461,   462,   463,   464,
     465,   466,   467,   468,   469,     0,     0,     0,     0,     0,
     526,     0,     0,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,     0,   490,     0,     0,     0,   491,   492,
       0,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,     0,     0,     0,   506,     0,     0,
     507,   508,   509,   510,   511,   512,   513,   514,   515,     0,
       0,     0,     0,     0,   516,   517,   518,   519,   520,   461,
     462,   463,   464,   465,   466,   467,   468,   469,     0,     0,
       0,     0,     0,     0,     0,     0,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,     0,     0,     0,
     506,     0,     0,   507,   508,   509,   510,   511,   512,   513,
     514,   515,     0,     0,     0,     0,     0,   516,   517,   518,
     519,   520,     0,     0,   521,   522,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   523,     0,   524,     0,     0,     0,     0,
     525,     0,     0,     0,   775,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   526,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   521,   522,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   242,   243,     0,
       0,     0,     0,   777,   244,     0,   523,   778,   524,     0,
       0,     0,     0,     0,     0,   779,   461,   462,   463,   464,
     465,   466,   467,   468,   469,     0,     0,     0,     0,     0,
       0,   526,     0,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,     0,   490,     0,     0,     0,   491,   492,
       0,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,     0,     0,     0,   506,     0,     0,
     507,   508,   509,   510,   511,   512,   513,   514,   515,     0,
       0,     0,     0,     0,   516,   517,   518,   519,   520,   461,
     462,   463,   464,   465,   466,   467,   468,   469,     0,     0,
       0,     0,     0,     0,     0,     0,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,     0,   490,     0,     0,
       0,   491,   492,     0,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,     0,     0,     0,
     506,     0,     0,   507,   508,   509,   510,   511,   512,   513,
     514,   515,     0,     0,     0,     0,     0,   516,   517,   518,
     519,   520,     0,     0,   521,   522,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   523,     0,   524,     0,     0,     0,     0,
     525,     0,     0,     0,   949,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   526,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   521,   522,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   523,     0,   524,     0,
       0,     0,     0,   525,     0,     0,   787,   461,   462,   463,
     464,   465,   466,   467,   468,   469,     0,     0,     0,     0,
       0,   526,     0,     0,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,     0,   490,     0,     0,  1200,   491,
     492,     0,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,     0,     0,     0,   506,     0,
       0,   507,   508,   509,   510,   511,   512,   513,   514,   515,
       0,     0,     0,     0,     0,   516,   517,   518,   519,   520,
     461,   462,   463,   464,   465,   466,   467,   468,   469,     0,
       0,     0,     0,     0,     0,     0,     0,   470,   471,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,     0,   490,     0,
       0,  1202,   491,   492,     0,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,     0,     0,
       0,   506,     0,     0,   507,   508,   509,   510,   511,   512,
     513,   514,   515,     0,     0,     0,     0,     0,   516,   517,
     518,   519,   520,     0,     0,   521,   522,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   523,     0,   524,     0,     0,     0,
       0,   525,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   526,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   521,   522,
     461,   462,   463,   464,   465,   466,   467,   468,   469,     0,
       0,     0,     0,     0,     0,     0,     0,   470,   471,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   523,   490,   524,
       0,     0,   491,   492,   525,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,     0,     0,
       0,   506,   526,     0,   507,   508,   509,   510,   511,   512,
     513,   514,   515,     0,     0,     0,     0,     0,   516,   517,
     518,   519,   520,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    -2,   209,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    -8,   -10,
     -12,   -14,   -16,   -18,   -20,   -22,   -24,     0,   521,   522,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   523,     0,   524,
       0,     0,     0,     0,   525,     0,     0,     0,     0,     0,
       0,     0,     0,     2,     3,     4,     5,     6,     0,     0,
       0,     0,   526,     7,     8,     9,    10,    11,    12,    13,
      14,    15,     0,    16,    17,    18,    19,     0,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,    88,     1,     0,     0,
      89,    90,    91,     0,     0,     0,     0,    -8,   -10,   -12,
     -14,   -16,   -18,   -20,   -22,   -24,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    92,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     2,     3,     4,     5,     6,     0,     0,     0,
       0,     0,     7,     8,     9,    10,    11,    12,    13,    14,
      15,     0,    16,    17,    18,    19,     0,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    88,     0,     0,     0,    89,
      90,    91,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    92
};

static const yytype_int16 yycheck[] =
{
     115,   122,   489,   118,   491,   630,   122,   667,   798,   529,
     491,   489,   687,   491,     1,   425,     1,     1,   428,     1,
     430,   541,   427,   705,   544,   545,   546,   432,   438,   434,
     440,   436,   714,   489,     1,   491,   151,   152,   489,     1,
     491,     1,   489,     1,   491,   188,   446,   202,     1,   176,
    1035,     1,     1,   176,     1,   208,   208,     1,     1,   211,
     212,   208,     1,   211,   212,     1,     1,     1,     1,     1,
     176,   218,     1,     1,     1,   230,     1,     1,   176,     1,
     233,   211,     1,   235,     1,     1,   212,   235,   218,   239,
     240,   578,     1,   580,     1,     1,     1,   578,     1,     1,
     578,   621,   777,     1,   779,   206,   176,   176,     1,   235,
     630,   598,   599,     1,     1,     1,  1101,   176,   219,     1,
     176,   176,   578,     1,     1,     1,     1,   578,     1,   616,
     617,   578,   619,     1,     1,   616,   617,     1,   616,   617,
       1,     1,   629,     1,   631,     1,     1,     1,     1,     1,
       1,   208,     1,   176,   211,   212,   176,   557,     1,   210,
     616,   617,     1,   619,     1,   616,   617,   211,     1,   616,
     617,     1,     1,     1,   218,     1,   586,     1,   235,     1,
     176,     1,   233,     1,   671,     1,     1,     1,     1,   676,
       1,     1,     1,   875,     1,     1,     1,     1,     1,   176,
     687,     1,     1,     1,     1,   176,     1,     1,   208,     0,
     210,     1,     1,   618,    15,     1,     1,     1,     1,     1,
     176,   208,     1,   208,   208,     1,   176,   211,   212,   176,
       1,   687,   216,     1,   218,     1,     1,     1,   220,     1,
     222,     1,   176,   176,    11,  1035,   233,   208,   233,   210,
     208,   235,   219,   211,   212,   208,   776,   219,   216,   219,
     218,   936,   937,   938,   939,   940,   941,   942,   943,   944,
     945,   210,   211,   222,   213,   214,   220,   235,   222,   222,
     233,   210,   211,   222,   213,   214,   222,   222,   220,   216,
     777,   219,   779,   222,   221,   220,   220,   219,   785,   786,
     219,   444,   219,   219,   785,   786,   449,   785,   786,   218,
     453,  1101,   219,   219,   219,   802,   219,   219,   211,   217,
      12,   777,   208,   779,   210,   211,   951,   213,   214,   785,
     786,   219,   219,   208,   785,   786,   222,   219,   785,   786,
       1,   219,   219,   219,  1004,     1,   219,   233,     1,     1,
       1,   219,   219,     1,     1,   219,     1,   208,   219,   219,
     211,   219,   211,   219,   219,   219,   219,   219,   211,   218,
     857,   208,   211,     1,   489,   208,   491,   201,   202,   208,
     210,   218,   787,   211,   208,   211,   208,   211,   210,   211,
     210,   211,   210,   211,   210,   211,   211,   211,   211,     1,
     211,   211,   211,     1,   211,   211,   211,   211,   211,   552,
       1,   211,   211,   211,   211,   902,   211,   211,   208,   208,
     210,   210,   208,   208,   210,   210,   210,   210,   210,   208,
     950,   951,   208,   201,   202,   201,   202,   208,     1,     1,
     208,     1,   208,   208,   208,     1,   208,     1,   208,   936,
     937,   938,   939,   940,   941,   942,   943,   944,   945,   864,
     865,   866,   867,   578,   869,   580,     1,   582,  1150,     1,
       1,     1,     1,   960,   176,     1,     1,   208,     1,   210,
     936,   937,   938,   939,   940,   941,   942,   943,   944,   945,
     633,     1,  1117,     1,  1176,     1,     1,     1,     1,     1,
       1,   616,   617,     1,  1024,  1025,  1026,  1027,     1,  1029,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
    1007,   637,     1,     1,  1011,    17,     1,  1014,   208,   194,
     195,   100,   208,     1,   176,  1022,   212,   201,   202,   208,
     194,   195,   208,   212,   208,    66,   212,   208,   212,   208,
     176,   216,   208,   212,   218,   208,   208,   208,   176,   235,
     208,   208,   176,   208,   218,   176,   235,    66,   211,   235,
     176,   235,   201,   202,   176,   218,   235,   211,   212,   208,
     208,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   211,   211,   212,   176,   211,   717,  1117,   218,   176,
     715,   235,   218,   176,    66,  1015,  1016,    13,   223,   208,
     208,   210,   211,    14,   213,   214,   235,   208,    42,    43,
     100,  1108,    16,   222,   213,   214,   215,    18,  1148,   204,
     211,   176,   176,   222,   233,   210,   211,   218,   213,   214,
    1127,  1128,   176,  1130,  1131,   208,   208,   222,   208,  1136,
     211,   176,   208,    19,   208,   224,   225,   226,   227,   176,
     210,   211,   211,   213,   214,   234,   208,   216,   210,   218,
     785,   786,   222,   208,   211,   208,   208,   208,   208,   208,
     176,  1201,   208,  1203,  1204,   208,   801,   208,   208,   208,
     211,   212,   208,   208,  1099,   210,  1183,   208,   208,   210,
     208,   176,   208,   208,   208,   208,   208,   208,   176,   208,
     208,   176,   211,   212,   235,   208,   210,   208,   208,   208,
     208,   208,   208,   208,   208,   208,   208,   176,   176,   208,
     208,   208,   232,   210,   211,  1222,   235,  1224,   176,  1226,
     216,  1228,   218,   176,   224,   225,   226,   227,   176,   211,
     212,   213,   214,   215,   234,   216,   216,   218,   218,   880,
     222,     1,  1249,     3,     4,     5,     6,     7,     8,     9,
      10,    11,   216,   235,   218,  1180,  1181,  1182,   176,   176,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    39,
     176,    41,    42,    43,    44,    45,    46,   176,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,   100,   176,   216,    64,   218,   176,    67,    68,    69,
      70,    71,    72,    73,    74,    75,   201,   202,   203,   204,
     205,    81,    82,    83,    84,    85,     1,   176,     3,     4,
       5,     6,     7,     8,     9,    10,    11,   177,   178,   179,
     180,   181,   182,   183,   184,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,   176,    41,    42,    43,    44,
      45,    46,   176,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,   216,   176,   218,    64,
     208,   208,    67,    68,    69,    70,    71,    72,    73,    74,
      75,   216,   216,   218,   218,   176,    81,    82,    83,    84,
      85,   171,   172,   176,   196,   197,   198,   199,   200,   201,
     202,   203,   204,   205,   176,   224,   225,   226,   227,   176,
     216,   216,   218,   218,   208,   234,   218,   176,   185,   186,
     187,   188,   189,   190,   191,   192,   193,   208,   201,   202,
     210,   208,   212,   201,   202,   208,   176,   217,   211,   176,
     208,   221,   176,   211,   196,   197,   198,   199,   200,   201,
     202,   203,   204,   205,   216,   235,   218,   208,  1113,   210,
     208,   208,   210,   210,   208,   208,   216,   216,   218,   218,
     216,   216,   218,   218,   176,   176,   171,   172,   176,   177,
     178,   179,   180,   181,   182,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   216,   216,   218,   218,
     216,   216,   218,   218,   216,   216,   218,   218,   216,   176,
     218,   176,   176,   176,   176,   210,   176,   212,   176,   176,
     176,   176,   217,   176,   176,     1,   221,     3,     4,     5,
       6,     7,     8,     9,    10,    11,   176,   176,   176,   176,
     235,   176,   176,   176,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    37,    38,    39,   176,    41,   176,   176,   176,    45,
      46,   176,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,   176,   176,   208,    64,     1,
     232,    67,    68,    69,    70,    71,    72,    73,    74,    75,
     232,   232,   213,   232,   227,    81,    82,    83,    84,    85,
       1,   227,     3,     4,     5,     6,     7,     8,     9,    10,
      11,   216,   236,   227,   223,   232,   210,   210,   210,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    35,    36,    37,    38,    39,   211,
      41,   220,   208,   210,    45,    46,   219,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
     219,   219,   219,    64,   219,   219,    67,    68,    69,    70,
      71,    72,    73,    74,    75,   219,   219,   219,   219,   219,
      81,    82,    83,    84,    85,   171,   172,   219,   219,   219,
     219,   219,   219,   219,   219,   219,   219,   219,   219,   219,
     219,   219,   219,   219,   219,   219,   219,   219,   217,   210,
     216,   208,   223,   223,   208,   223,   223,   210,   223,   211,
     216,   211,   211,   218,   210,    66,   212,   218,   232,   232,
     232,   217,   210,   218,   218,   221,   218,   218,   238,   218,
     211,   211,   211,   211,   211,   211,   211,   211,   211,   235,
     211,   211,    66,   208,    40,   232,   208,    47,   220,    46,
     208,   220,   220,   220,   220,   219,    42,   218,   218,   218,
     171,   172,   218,   218,   218,   218,   216,   218,   216,   218,
     205,   218,   218,   218,   218,   218,   218,   218,   218,   218,
     218,   218,   218,   216,   218,   216,   238,    46,   218,   218,
     218,   218,   218,   218,   218,   218,   218,   218,   218,   210,
     218,   212,   218,   218,   218,   218,   217,   216,   218,     1,
     221,     3,     4,     5,     6,     7,     8,     9,    10,    11,
     218,   218,   218,   218,   235,   218,   218,   218,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    36,    37,    38,    39,   218,    41,
     218,   218,   218,    45,    46,   218,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,   218,
     218,   218,    64,   218,   218,    67,    68,    69,    70,    71,
      72,    73,    74,    75,   216,   216,   216,   216,   216,    81,
      82,    83,    84,    85,     1,   216,     3,     4,     5,     6,
       7,     8,     9,    10,    11,   216,   216,   216,   216,   216,
     223,   216,   218,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
      37,    38,    39,   218,    41,   218,   211,   211,    45,    46,
     211,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,   211,   211,   211,    64,   211,   220,
      67,    68,    69,    70,    71,    72,    73,    74,    75,   211,
     211,   211,   211,   211,    81,    82,    83,    84,    85,   171,
     172,   211,   211,   211,   211,   211,   211,   211,   220,   232,
     221,   237,   237,   216,   238,   232,   218,   218,   218,   218,
     218,   218,   218,   218,   218,   218,   218,   218,   218,   218,
     218,   218,   216,   216,   216,    46,   216,   218,   210,   216,
     212,   216,   218,   216,   218,   217,   208,   218,   218,   221,
     211,   211,   208,   211,   211,   218,   208,   216,    94,   880,
     211,   216,   216,   235,   232,   218,   216,   216,   208,   208,
     218,   218,   218,   216,   218,   216,   208,   208,   216,   208,
     217,   211,   217,   216,   171,   172,   211,   208,   561,   211,
     218,   218,   218,   217,   217,   208,   205,   208,   218,   218,
     218,   218,   218,   205,   216,   208,   885,   208,   218,   276,
    1014,  1115,    -1,   674,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   210,   239,   212,    -1,    -1,   270,    -1,
     217,   239,    -1,     1,   221,     3,     4,     5,     6,     7,
       8,     9,    10,    11,    -1,    -1,    -1,    -1,   235,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    -1,    41,    -1,    -1,    -1,    45,    46,    -1,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    -1,    -1,    -1,    64,    -1,    -1,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    -1,    -1,
      -1,    -1,    -1,    81,    82,    83,    84,    85,     1,    -1,
       3,     4,     5,     6,     7,     8,     9,    10,    11,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    -1,    41,    -1,
      -1,    -1,    45,    46,    -1,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    -1,    -1,
      -1,    64,    -1,    -1,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    -1,    -1,    -1,    -1,    -1,    81,    82,
      83,    84,    85,   171,   172,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   210,    -1,   212,    -1,    -1,    -1,    -1,   217,
      -1,    -1,    -1,   221,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   235,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   171,   172,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   210,    -1,   212,
      -1,    -1,    -1,    -1,   217,    -1,    -1,     1,   221,     3,
       4,     5,     6,     7,     8,     9,    10,    11,    -1,    -1,
      -1,    -1,   235,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    -1,    41,    -1,    -1,
      -1,    45,    46,    -1,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    60,    -1,    -1,    -1,
      64,    -1,    -1,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    -1,    -1,    -1,    -1,    -1,    81,    82,    83,
      84,    85,     1,    -1,     3,     4,     5,     6,     7,     8,
       9,    10,    11,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    -1,    41,    -1,    -1,    -1,    45,    46,    -1,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    60,    -1,    -1,    -1,    64,    -1,    -1,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    -1,    -1,    -1,
      -1,    -1,    81,    82,    83,    84,    85,   171,   172,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   210,    -1,   212,    -1,
      -1,    -1,    -1,   217,    -1,    -1,    -1,   221,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   235,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   171,   172,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   210,    -1,   212,    -1,    -1,    -1,    -1,   217,    -1,
      -1,     1,   221,     3,     4,     5,     6,     7,     8,     9,
      10,    11,    -1,    -1,    -1,    -1,   235,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      -1,    41,    -1,    -1,    -1,    45,    46,    -1,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    -1,    -1,    -1,    64,    -1,    -1,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    -1,    -1,    -1,    -1,
      -1,    81,    82,    83,    84,    85,     1,    -1,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    -1,    41,    -1,    -1,    -1,
      45,    46,    -1,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    -1,    -1,    -1,    64,
      -1,    -1,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    -1,    -1,    -1,    -1,    -1,    81,    82,    83,    84,
      85,   171,   172,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     210,    -1,   212,    -1,    -1,    -1,    -1,   217,    -1,    -1,
      -1,   221,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   235,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   171,   172,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   210,    -1,   212,    -1,    -1,
      -1,    -1,   217,    -1,    -1,     1,   221,     3,     4,     5,
       6,     7,     8,     9,    10,    11,    -1,    -1,    -1,    -1,
     235,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    -1,    41,    -1,    -1,    -1,    45,
      46,    -1,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    -1,    -1,    -1,    64,    -1,
      -1,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      -1,    -1,    -1,    -1,    -1,    81,    82,    83,    84,    85,
       1,    -1,     3,     4,     5,     6,     7,     8,     9,    10,
      11,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    -1,
      41,    -1,    -1,    -1,    45,    46,    -1,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      -1,    -1,    -1,    64,    -1,    -1,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    -1,    -1,    -1,    -1,    -1,
      81,    82,    83,    84,    85,   171,   172,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   210,    -1,   212,    -1,    -1,    -1,
      -1,   217,    -1,    -1,    -1,   221,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   235,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     171,   172,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   210,
      -1,   212,    -1,    -1,    -1,    -1,   217,    -1,    -1,     1,
     221,     3,     4,     5,     6,     7,     8,     9,    10,    11,
      -1,    -1,    -1,    -1,   235,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    -1,    41,
      -1,    -1,    -1,    45,    46,    -1,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    -1,
      -1,    -1,    64,    -1,    -1,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    -1,    -1,    -1,    -1,    -1,    81,
      82,    83,    84,    85,     1,    -1,     3,     4,     5,     6,
       7,     8,     9,    10,    11,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    -1,    41,    -1,    -1,    -1,    45,    46,
      -1,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    -1,    -1,    -1,    64,    -1,    -1,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    -1,
      -1,    -1,    -1,    -1,    81,    82,    83,    84,    85,   171,
     172,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   210,    -1,
     212,    -1,    -1,    -1,    -1,   217,    -1,    -1,    -1,   221,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   235,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   171,   172,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   210,    -1,   212,    -1,    -1,    -1,    -1,
     217,    -1,    -1,    -1,   221,     3,     4,     5,     6,     7,
       8,     9,    10,    11,    -1,    -1,    -1,    -1,   235,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    -1,    -1,    -1,    64,    -1,    -1,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    -1,    -1,
      -1,    -1,    -1,    81,    82,    83,    84,    85,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    -1,    41,    -1,    -1,    -1,
      45,    46,    -1,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    -1,    -1,    -1,    64,
      -1,    -1,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    -1,    -1,    -1,    -1,    -1,    81,    82,    83,    84,
      85,    -1,    -1,   171,   172,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   201,   202,    -1,    -1,    -1,   206,    -1,
     208,    -1,   210,    -1,   212,    -1,    -1,    -1,    -1,    -1,
      -1,   219,   220,    -1,   222,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   235,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   171,   172,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   194,
     195,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   210,    -1,   212,    -1,    -1,
      -1,    -1,   217,    -1,    -1,   220,     3,     4,     5,     6,
       7,     8,     9,    10,    11,    -1,    -1,    -1,    -1,    -1,
     235,    -1,    -1,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    -1,    41,    -1,    -1,    -1,    45,    46,
      -1,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    -1,    -1,    -1,    64,    -1,    -1,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    -1,
      -1,    -1,    -1,    -1,    81,    82,    83,    84,    85,     3,
       4,     5,     6,     7,     8,     9,    10,    11,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    36,    37,    38,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    60,    -1,    -1,    -1,
      64,    -1,    -1,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    -1,    -1,    -1,    -1,    -1,    81,    82,    83,
      84,    85,    -1,    -1,   171,   172,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   210,    -1,   212,    -1,    -1,    -1,    -1,
     217,    -1,    -1,    -1,   221,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   235,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   171,   172,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   201,   202,    -1,
      -1,    -1,    -1,   207,   208,    -1,   210,   211,   212,    -1,
      -1,    -1,    -1,    -1,    -1,   219,     3,     4,     5,     6,
       7,     8,     9,    10,    11,    -1,    -1,    -1,    -1,    -1,
      -1,   235,    -1,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    -1,    41,    -1,    -1,    -1,    45,    46,
      -1,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    -1,    -1,    -1,    64,    -1,    -1,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    -1,
      -1,    -1,    -1,    -1,    81,    82,    83,    84,    85,     3,
       4,     5,     6,     7,     8,     9,    10,    11,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    -1,    41,    -1,    -1,
      -1,    45,    46,    -1,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    60,    -1,    -1,    -1,
      64,    -1,    -1,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    -1,    -1,    -1,    -1,    -1,    81,    82,    83,
      84,    85,    -1,    -1,   171,   172,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   210,    -1,   212,    -1,    -1,    -1,    -1,
     217,    -1,    -1,    -1,   221,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   235,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   171,   172,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   210,    -1,   212,    -1,
      -1,    -1,    -1,   217,    -1,    -1,   220,     3,     4,     5,
       6,     7,     8,     9,    10,    11,    -1,    -1,    -1,    -1,
      -1,   235,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    -1,    41,    -1,    -1,    44,    45,
      46,    -1,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    -1,    -1,    -1,    64,    -1,
      -1,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      -1,    -1,    -1,    -1,    -1,    81,    82,    83,    84,    85,
       3,     4,     5,     6,     7,     8,     9,    10,    11,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    -1,    41,    -1,
      -1,    44,    45,    46,    -1,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    -1,    -1,
      -1,    64,    -1,    -1,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    -1,    -1,    -1,    -1,    -1,    81,    82,
      83,    84,    85,    -1,    -1,   171,   172,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   210,    -1,   212,    -1,    -1,    -1,
      -1,   217,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   235,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   171,   172,
       3,     4,     5,     6,     7,     8,     9,    10,    11,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    35,    36,    37,    38,    39,   210,    41,   212,
      -1,    -1,    45,    46,   217,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    -1,    -1,
      -1,    64,   235,    -1,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    -1,    -1,    -1,    -1,    -1,    81,    82,
      83,    84,    85,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,     0,     1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    11,    12,
      13,    14,    15,    16,    17,    18,    19,    -1,   171,   172,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   210,    -1,   212,
      -1,    -1,    -1,    -1,   217,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    76,    77,    78,    79,    80,    -1,    -1,
      -1,    -1,   235,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    -1,    96,    97,    98,    99,    -1,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
     123,   124,   125,   126,   127,   128,   129,   130,   131,   132,
     133,   134,   135,   136,   137,   138,   139,   140,   141,   142,
     143,   144,   145,   146,   147,   148,   149,   150,   151,   152,
     153,   154,   155,   156,   157,   158,   159,   160,   161,   162,
     163,   164,   165,   166,   167,   168,   169,     1,    -1,    -1,
     173,   174,   175,    -1,    -1,    -1,    -1,    11,    12,    13,
      14,    15,    16,    17,    18,    19,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   231,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    76,    77,    78,    79,    80,    -1,    -1,    -1,
      -1,    -1,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    -1,    96,    97,    98,    99,    -1,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,   123,
     124,   125,   126,   127,   128,   129,   130,   131,   132,   133,
     134,   135,   136,   137,   138,   139,   140,   141,   142,   143,
     144,   145,   146,   147,   148,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   159,   160,   161,   162,   163,
     164,   165,   166,   167,   168,   169,    -1,    -1,    -1,   173,
     174,   175,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   231
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,     1,    76,    77,    78,    79,    80,    86,    87,    88,
      89,    90,    91,    92,    93,    94,    96,    97,    98,    99,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
     141,   142,   143,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   173,
     174,   175,   231,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   276,   277,   176,   176,   176,
     176,   176,   176,   176,   176,   176,   176,   176,   176,   176,
     176,   176,   176,   176,   176,   176,   176,   176,     1,   176,
       1,   176,     1,   176,     1,   176,     1,   176,     1,   176,
     176,   176,   176,   176,   176,   176,   176,   176,   176,   176,
     176,   176,   176,   176,   176,   176,   176,   176,   176,   176,
     176,   176,   176,   176,     1,   211,   176,     1,   219,   176,
     176,   176,   176,   176,   176,   176,   176,   176,   176,   176,
     176,   176,   176,   176,   176,   176,   176,   176,   176,   176,
     176,   176,   176,   176,   176,     1,   176,     1,   176,   176,
     176,   176,   176,   176,   176,   176,   176,   176,     0,     1,
     245,    11,   285,    12,   286,    13,   287,    14,   288,    15,
     289,    16,   290,    17,   291,    18,   292,    19,   293,     1,
     208,     1,   208,     1,   208,     1,   208,     1,   208,   208,
       1,   208,   201,   202,   208,   260,     1,   208,     1,   208,
     260,     1,   208,     1,   210,     1,   211,     1,   208,   210,
     258,   261,   262,   268,   211,     1,   210,   211,   213,   214,
     222,   233,   255,   257,   258,   261,   263,   264,   278,   279,
     280,   281,     1,   208,     1,   208,     1,   208,   208,   208,
     208,   208,   208,   208,     1,   208,     1,   208,     1,   208,
       1,   208,     1,   208,     1,   208,     1,   208,     1,   211,
       1,   208,     1,   211,     1,   208,     1,   260,     1,   260,
       1,   208,     1,   208,     1,   208,     1,   208,     1,   208,
       1,   208,     1,   208,     1,   208,     1,   208,     1,   211,
       1,   211,     1,   211,   211,     1,   208,     1,   210,   211,
       1,   210,   211,     1,   208,     1,   210,   211,     1,   208,
       1,   208,     1,   208,     1,   208,     1,   208,     1,   208,
       1,   208,     1,   208,   210,     1,   210,     1,   208,     1,
     208,     1,   208,     1,   208,     1,   208,     1,   210,   255,
       1,   208,     1,   208,     1,   208,     1,   208,     1,   208,
       1,   208,   210,   208,   208,   210,   208,     1,   211,     1,
     211,     1,   208,     1,   208,     1,   210,   275,     1,   208,
     208,     1,   220,   222,     1,   222,     1,   220,   222,     1,
     222,     1,   220,     1,   220,     1,   220,     1,   222,     1,
     222,   208,   208,     1,   232,   270,   269,   232,   280,   232,
     202,   230,   256,   232,   264,   227,   216,   227,   232,   236,
     227,     3,     4,     5,     6,     7,     8,     9,    10,    11,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      41,    45,    46,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    64,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    81,    82,    83,    84,
      85,   171,   172,   210,   212,   217,   235,   300,   305,   308,
     309,   310,   311,   312,   313,   321,   208,   210,   211,   284,
     284,   308,   284,   284,   308,   308,   308,   284,   284,   204,
     255,   100,   224,   225,   226,   227,   234,   266,   267,   267,
       1,   211,   272,   223,   255,     1,   210,   210,   211,   210,
     220,   208,   210,     1,   219,     1,   219,   219,   219,   219,
     219,     1,   219,     1,   219,     1,   219,     1,   219,     1,
     219,     1,   219,     1,   219,     1,   219,   219,   219,   219,
       1,   219,     1,   219,     1,   219,     1,   219,   219,     1,
     219,   219,   219,   219,   219,   219,   206,   219,   220,   222,
     260,   294,   300,   301,   302,   305,   306,   310,   321,   219,
     294,   219,     1,   219,     1,   219,     1,   219,     1,   219,
       1,   219,     1,   219,     1,   219,     1,   219,     1,   219,
       1,   219,     1,   219,     1,   219,     1,   219,   219,   219,
     219,   219,   219,   219,   219,   219,   219,   219,   219,   219,
     219,   219,   219,   219,   219,     1,   219,   176,   185,   186,
     187,   188,   189,   190,   191,   192,   193,   303,   217,     1,
     221,   309,     1,   217,   223,   223,   221,   223,   223,   221,
     221,   221,   216,   223,   232,   232,   210,   255,   265,   208,
     208,   210,   267,   272,   232,   216,   206,   219,   273,   274,
     238,     1,   211,   218,     1,   211,   218,   294,   218,   218,
     260,   300,     1,   211,   260,     1,   211,     1,   284,     1,
     211,     1,   211,     1,   211,     1,   208,     1,   208,   211,
     218,   208,   300,   211,   300,     1,   211,     1,   211,     1,
     211,     1,   211,   218,     1,   211,   218,   218,   218,   218,
       1,   208,   218,   294,   294,   221,   308,   207,   211,   219,
     260,   300,   302,   304,   321,   194,   195,   220,   307,   309,
     177,   178,   179,   180,   181,   182,   183,   184,   295,   296,
     297,   298,   299,   300,   307,   300,     1,   255,     1,   208,
     211,     1,   261,     1,   208,     1,   218,     1,   211,     1,
     211,   208,   210,   208,   210,   208,   210,   208,   210,   208,
     210,   208,   210,   211,   211,   211,   211,   211,   211,   211,
     211,   211,   283,   211,   283,   211,   211,   211,   300,   208,
     218,   210,   320,   320,     1,   208,   211,   216,   218,   300,
     318,    66,    66,   304,   220,   220,   220,   220,   208,   220,
     208,   233,   259,     1,   259,   232,     1,   259,   211,   260,
     219,   233,   258,   271,     1,   216,   221,   208,   218,   218,
     218,   216,   218,   216,   218,   218,   218,   218,   216,   218,
     216,   218,   216,   218,   218,   218,   218,   218,   218,   218,
     218,   218,   218,   218,   216,   218,   218,   218,   216,   216,
     218,   218,   218,   218,   218,   218,   218,   218,   218,   218,
     218,   218,   218,   221,   304,   304,   196,   197,   198,   199,
     200,   201,   202,   203,   204,   205,   223,   294,   294,   221,
     308,    40,    66,   215,   278,   282,   260,   211,   300,   218,
      47,   218,   218,   218,   218,   218,   218,   218,   218,   216,
     218,   218,   218,   218,   218,   218,   218,   218,   218,   218,
     218,   218,   216,   218,   218,   216,   218,   218,   216,   218,
     218,   216,   218,   216,   216,   216,   216,   216,   216,   216,
     211,   218,   211,   218,   216,   218,   218,   216,   218,   216,
     216,   216,   216,     1,   219,   216,   216,   218,   218,   208,
     211,   300,   216,   218,   308,   308,   308,   308,   223,   308,
       1,   259,   218,   218,   271,   216,   273,   205,   211,   211,
     211,   211,    66,   208,   211,   300,   319,   211,   211,   211,
     218,   304,   304,   304,   304,   304,   304,   304,   304,   304,
     304,   221,   307,   220,   300,   208,   208,   210,   208,   210,
     208,   210,   211,   211,   211,   211,   211,   211,   211,   211,
     211,   283,   300,   211,   211,   300,   211,     1,   218,   318,
     284,   284,   208,   211,   300,   221,   221,   221,   221,   220,
     221,   216,   282,    46,   218,   218,   218,   218,   216,   218,
     218,   218,   218,    42,   314,   315,   316,   218,   218,   218,
     218,   218,   218,   218,   218,   218,   216,   216,   216,   218,
     216,   216,   216,   218,   218,   218,   216,   218,   216,   218,
     216,   218,   216,   218,   218,   218,   218,   218,   308,   282,
     216,   208,    66,   208,   211,   300,   211,   260,   221,    43,
     316,   317,   307,   211,   300,   300,   208,   300,   208,   300,
     211,   300,   208,   211,   211,   221,   216,   259,   239,   240,
     232,   232,   232,   216,   218,   218,   218,   216,   216,   216,
     216,   218,   218,   218,   216,   218,   259,   216,   237,   208,
      44,   308,    44,   308,   308,   208,   300,   208,   208,   208,
     208,   211,   216,   211,   208,   237,   217,    44,   217,    44,
     218,   218,   216,   218,   216,   218,   216,   218,   216,   218,
     216,   211,   218,   238,   208,   217,   217,   300,   300,   300,
     300,   211,   218,   208,   238,   218,   218,   218,   218,   216,
     205,   208,   300,    46,   205,   218,   208,    46,   239,   208,
     239
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   242,   243,   244,   244,   244,   245,   245,   246,   245,
     247,   245,   248,   245,   249,   245,   250,   245,   251,   245,
     252,   245,   253,   245,   254,   245,   245,   255,   255,   255,
     256,   256,   257,   257,   257,   258,   259,   259,   260,   260,
     260,   261,   261,   261,   261,   262,   262,   263,   263,   263,
     263,   263,   264,   264,   265,   265,   265,   266,   266,   266,
     266,   266,   266,   267,   267,   268,   268,   269,   268,   270,
     268,   271,   271,   272,   272,   273,   273,   274,   274,   274,
     275,   275,   275,   275,   276,   276,   276,   276,   276,   276,
     276,   276,   276,   276,   276,   276,   276,   276,   276,   276,
     276,   276,   276,   276,   276,   276,   276,   276,   276,   276,
     276,   276,   276,   276,   276,   276,   276,   276,   276,   276,
     276,   276,   276,   276,   276,   276,   276,   276,   276,   276,
     276,   276,   276,   276,   276,   276,   276,   276,   276,   276,
     276,   276,   276,   276,   276,   276,   276,   276,   276,   276,
     276,   276,   276,   276,   276,   276,   276,   276,   276,   276,
     276,   276,   276,   276,   276,   276,   276,   276,   276,   276,
     276,   276,   276,   276,   276,   276,   276,   276,   276,   276,
     276,   276,   276,   276,   276,   276,   276,   276,   276,   276,
     276,   276,   276,   276,   276,   276,   276,   276,   276,   276,
     276,   276,   276,   276,   276,   276,   276,   276,   276,   276,
     276,   276,   276,   276,   276,   276,   276,   276,   276,   276,
     276,   276,   276,   276,   276,   276,   276,   276,   276,   276,
     276,   276,   276,   276,   276,   276,   276,   276,   276,   276,
     276,   276,   276,   276,   276,   276,   276,   276,   276,   276,
     276,   276,   276,   276,   276,   276,   276,   276,   276,   276,
     276,   276,   276,   277,   277,   277,   277,   277,   278,   278,
     279,   280,   281,   281,   282,   282,   283,   283,   284,   284,
     284,   285,   285,   285,   286,   286,   287,   287,   287,   288,
     288,   289,   289,   290,   290,   291,   291,   292,   292,   293,
     293,   294,   294,   294,   294,   294,   294,   295,   295,   296,
     296,   296,   296,   297,   297,   298,   298,   299,   299,   299,
     300,   300,   301,   301,   301,   301,   302,   302,   302,   302,
     302,   303,   303,   303,   303,   303,   303,   303,   303,   303,
     303,   304,   304,   304,   304,   304,   304,   304,   304,   304,
     304,   304,   304,   304,   304,   304,   304,   304,   305,   305,
     305,   306,   306,   306,   306,   306,   307,   307,   307,   308,
     308,   308,   309,   309,   309,   309,   309,   309,   309,   309,
     310,   310,   311,   312,   313,   314,   314,   315,   315,   316,
     316,   316,   316,   316,   316,   316,   316,   317,   317,   318,
     318,   318,   318,   318,   318,   318,   318,   318,   318,   318,
     319,   319,   319,   319,   319,   319,   319,   319,   320,   320,
     320,   320,   321,   321,   321,   321,   321,   321,   321,   321,
     321,   321,   321,   321,   321,   321,   321,   321,   321,   321,
     321,   321,   321,   321,   321,   321,   321,   321,   321,   321,
     321,   321,   321,   321,   321,   321,   321,   321,   321,   321,
     321,   321,   321,   321,   321,   321,   321,   321,   321,   321,
     321,   321,   321,   321,   321,   321,   321,   321,   321,   321,
     321,   321,   321,   321,   321,   321,   321,   321,   321,   321,
     321,   321,   321,   321,   321,   321,   321,   321,   321,   321,
     321,   321,   321,   321,   321,   321,   321,   321,   321,   321,
     321,   321,   321,   321,   321,   321,   321,   321,   321,   321,
     321,   321,   321,   321,   321,   321,   321,   321,   321,   321,
     321,   321,   321,   321,   321,   321,   321,   321,   321,   321,
     321,   321,   321,   321,   321,   321,   321,   321,   321,   321,
     321,   321,   321,   321,   321,   321,   321,   321,   321,   321,
     321,   321,   321,   321,   321,   321,   321,   321,   321,   321,
     321,   321,   321,   321,   321,   321,   321,   321,   321,   321,
     321,   321,   321,   321,   321,   321,   321,   321,   321,   321
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     2,     1,     2,     1,     1,     0,     2,
       0,     2,     0,     2,     0,     2,     0,     2,     0,     2,
       0,     2,     0,     2,     0,     2,     1,     1,     1,     1,
       1,     1,     1,     3,     3,     1,     1,     1,     1,     2,
       2,     3,     5,     5,     2,     3,     5,     1,     3,     5,
       5,     1,     1,     2,     1,     3,     3,     1,     2,     2,
       2,     2,     2,     1,     2,     1,     1,     0,     3,     0,
       3,     1,     1,     1,     2,     9,    10,     3,     1,     2,
      18,    17,    10,     9,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     2,     3,     2,     3,     2,     3,
       2,     3,     2,     3,     2,     3,     3,     3,     3,     3,
       3,     3,     5,     3,     3,     5,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     5,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     5,     5,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     2,     3,     2,     7,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     2,     2,     2,     8,     8,     2,     1,     1,
       1,     1,     1,     3,     1,     1,     2,     2,     1,     1,
       1,     4,     7,     2,     7,     2,     4,     7,     2,     7,
       2,     4,     2,     4,     2,     4,     2,     9,     2,     7,
       2,     3,     3,     2,     3,     3,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     3,     3,     3,     3,
       3,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     2,     3,     3,     3,
       3,     1,     1,     1,     3,     2,     1,     3,     2,     2,
       1,     2,     2,     1,     1,     1,     1,     2,     1,     2,
       3,     5,     3,     7,     7,     2,     1,     2,     1,     6,
       5,     4,     3,     6,     5,     4,     3,     3,     2,     1,
       3,     1,     2,     2,     1,     2,     3,     1,     2,     3,
       1,     1,     1,     1,     3,     3,     3,     3,     3,     4,
       4,     2,     4,     3,     2,     4,     4,     6,     2,     4,
       6,     3,     1,     3,     1,     4,     4,     3,     1,     4,
       6,     2,     4,     4,     4,     2,     4,     4,     2,     4,
       4,     2,     6,     6,     4,     4,     2,     6,     6,     4,
       4,     2,     6,     6,     4,     4,     2,     6,     2,     4,
       4,     6,     2,     4,     4,     2,     4,     4,     2,     4,
       4,     2,     4,     4,     2,     4,     6,     4,     3,     1,
       4,     4,     6,     6,     4,     2,     4,     4,     2,     4,
       4,     2,     4,     4,     2,     4,     4,     2,     4,     3,
       1,     4,     2,     4,     3,     1,     3,     1,     3,     1,
       3,     1,     4,     3,     1,     4,     4,     4,     2,     4,
       4,     4,     2,     4,     4,     2,     4,     6,     4,     2,
       3,     4,     2,     4,     4,     2,     4,     4,     2,     8,
      10,    10,     6,     8,     8,    10,    10,    12,    12,    10,
      10,    12,    12,     8,     6,     3,     4,     4,     2,     4,
       4,     4,     4,     6,     6,     4,     6,     8,     6,     8,
      14,     6,     3,     6,     8,     6,     6,     4,     4,     6
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256



/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo, int yytype, YYSTYPE const * const yyvaluep)
{
  FILE *yyoutput = yyo;
  YYUSE (yyoutput);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyo, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo, int yytype, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyo, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  yy_symbol_value_print (yyo, yytype, yyvaluep);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, int yyrule)
{
  unsigned long yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &yyvsp[(yyi + 1) - (yynrhs)]
                                              );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            else
              goto append;

          append:
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return (YYSIZE_T) (yystpcpy (yyres, yystr) - yyres);
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM)
                    yysize = yysize1;
                  else
                    return 2;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
    default: /* Avoid compiler warnings. */
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM)
      yysize = yysize1;
    else
      return 2;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
{
  YYUSE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yynewstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  *yyssp = (yytype_int16) yystate;

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    goto yyexhaustedlab;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = (YYSIZE_T) (yyssp - yyss + 1);

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
# undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 3:
#line 522 "cfg.y" /* yacc.c:1652  */
    {}
#line 3246 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 4:
#line 523 "cfg.y" /* yacc.c:1652  */
    {}
#line 3252 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 5:
#line 524 "cfg.y" /* yacc.c:1652  */
    { yyerror(""); YYABORT;}
#line 3258 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 8:
#line 529 "cfg.y" /* yacc.c:1652  */
    {rt=REQUEST_ROUTE;}
#line 3264 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 10:
#line 530 "cfg.y" /* yacc.c:1652  */
    {rt=FAILURE_ROUTE;}
#line 3270 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 12:
#line 531 "cfg.y" /* yacc.c:1652  */
    {rt=ONREPLY_ROUTE;}
#line 3276 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 14:
#line 532 "cfg.y" /* yacc.c:1652  */
    {rt=BRANCH_ROUTE;}
#line 3282 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 16:
#line 533 "cfg.y" /* yacc.c:1652  */
    {rt=ERROR_ROUTE;}
#line 3288 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 18:
#line 534 "cfg.y" /* yacc.c:1652  */
    {rt=LOCAL_ROUTE;}
#line 3294 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 20:
#line 535 "cfg.y" /* yacc.c:1652  */
    {rt=STARTUP_ROUTE;}
#line 3300 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 22:
#line 536 "cfg.y" /* yacc.c:1652  */
    {rt=TIMER_ROUTE;}
#line 3306 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 24:
#line 537 "cfg.y" /* yacc.c:1652  */
    {rt=EVENT_ROUTE;}
#line 3312 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 27:
#line 542 "cfg.y" /* yacc.c:1652  */
    { IFOR();
							tmp=ip_addr2a((yyvsp[0].ipaddr));
							if(tmp==0){
								LM_CRIT("cfg. parser: bad ip address.\n");
								(yyval.strval)=0;
							}else{
								(yyval.strval)=pkg_malloc(strlen(tmp)+1);
								if ((yyval.strval)==0){
									LM_CRIT("cfg. parser: out of memory.\n");
									YYABORT;
								}else{
									memcpy((yyval.strval), tmp, strlen(tmp)+1);
								}
							}
						}
#line 3332 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 28:
#line 557 "cfg.y" /* yacc.c:1652  */
    { IFOR();
							(yyval.strval)=pkg_malloc(strlen((yyvsp[0].strval))+1);
							if ((yyval.strval)==0){
									LM_CRIT("cfg. parser: out of memory.\n");
									YYABORT;
							}else{
									memcpy((yyval.strval), (yyvsp[0].strval), strlen((yyvsp[0].strval))+1);
							}
						}
#line 3346 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 29:
#line 566 "cfg.y" /* yacc.c:1652  */
    { IFOR();
							if ((yyvsp[0].strval)==0) {
								(yyval.strval) = 0;
							} else {
								(yyval.strval)=pkg_malloc(strlen((yyvsp[0].strval))+1);
								if ((yyval.strval)==0){
									LM_CRIT("cfg. parser: out of memory.\n");
									YYABORT;
								}else{
									memcpy((yyval.strval), (yyvsp[0].strval), strlen((yyvsp[0].strval))+1);
								}
							}
						}
#line 3364 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 30:
#line 581 "cfg.y" /* yacc.c:1652  */
    {(yyval.strval)=".";}
#line 3370 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 31:
#line 582 "cfg.y" /* yacc.c:1652  */
    {(yyval.strval)="-"; }
#line 3376 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 32:
#line 585 "cfg.y" /* yacc.c:1652  */
    { (yyval.strval)=(yyvsp[0].strval); }
#line 3382 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 33:
#line 586 "cfg.y" /* yacc.c:1652  */
    { IFOR();
						(yyval.strval)=(char*)pkg_malloc(strlen((yyvsp[-2].strval))+1+strlen((yyvsp[0].strval))+1);
						if ((yyval.strval)==0){
							LM_CRIT("cfg. parser: memory allocation"
										" failure while parsing host\n");
							YYABORT;
						}else{
							memcpy((yyval.strval), (yyvsp[-2].strval), strlen((yyvsp[-2].strval)));
							(yyval.strval)[strlen((yyvsp[-2].strval))]=*(yyvsp[-1].strval);
							memcpy((yyval.strval)+strlen((yyvsp[-2].strval))+1, (yyvsp[0].strval), strlen((yyvsp[0].strval)));
							(yyval.strval)[strlen((yyvsp[-2].strval))+1+strlen((yyvsp[0].strval))]=0;
						}
						pkg_free((yyvsp[-2].strval)); pkg_free((yyvsp[0].strval));
					}
#line 3401 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 34:
#line 600 "cfg.y" /* yacc.c:1652  */
    { (yyval.strval)=0; pkg_free((yyvsp[-2].strval));
					yyerror("invalid hostname (use quotes if hostname "
						"has config keywords)"); }
#line 3409 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 35:
#line 605 "cfg.y" /* yacc.c:1652  */
    { IFOR();
		if (parse_proto((unsigned char *)(yyvsp[0].strval), strlen((yyvsp[0].strval)), &i_tmp) < 0) {
			yyerrorf("cannot handle protocol <%s>\n", (yyvsp[0].strval));
			YYABORT;
		}
		pkg_free((yyvsp[0].strval));
		(yyval.intval) = i_tmp;
	 }
#line 3422 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 36:
#line 615 "cfg.y" /* yacc.c:1652  */
    { (yyval.intval)=(yyvsp[0].intval); }
#line 3428 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 37:
#line 616 "cfg.y" /* yacc.c:1652  */
    { (yyval.intval)=0; }
#line 3434 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 38:
#line 619 "cfg.y" /* yacc.c:1652  */
    { (yyval.intval)=(yyvsp[0].intval); }
#line 3440 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 39:
#line 620 "cfg.y" /* yacc.c:1652  */
    { (yyval.intval)=(yyvsp[0].intval); }
#line 3446 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 40:
#line 621 "cfg.y" /* yacc.c:1652  */
    { (yyval.intval)=-(yyvsp[0].intval); }
#line 3452 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 41:
#line 625 "cfg.y" /* yacc.c:1652  */
    { IFOR();
				(yyval.sockid)=mk_listen_id((yyvsp[0].strval), (yyvsp[-2].intval), 0); }
#line 3459 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 42:
#line 627 "cfg.y" /* yacc.c:1652  */
    { IFOR();
				(yyval.sockid)=mk_listen_id((yyvsp[-2].strval), (yyvsp[-4].intval), (yyvsp[0].intval));}
#line 3466 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 43:
#line 629 "cfg.y" /* yacc.c:1652  */
    {
				(yyval.sockid)=0;
				yyerror("port number expected");
				YYABORT;
				}
#line 3476 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 44:
#line 634 "cfg.y" /* yacc.c:1652  */
    { (yyval.sockid)=0;
				yyerror("protocol expected");
				YYABORT;
			}
#line 3485 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 45:
#line 640 "cfg.y" /* yacc.c:1652  */
    { IFOR();
				(yyval.sockid)=mk_listen_id(0, (yyvsp[-2].intval), 0); }
#line 3492 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 46:
#line 642 "cfg.y" /* yacc.c:1652  */
    { IFOR();
				(yyval.sockid)=mk_listen_id(0, (yyvsp[-4].intval), (yyvsp[0].intval)); }
#line 3499 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 47:
#line 646 "cfg.y" /* yacc.c:1652  */
    { IFOR();
				(yyval.sockid)=mk_listen_id((yyvsp[0].strval), PROTO_NONE, 0); }
#line 3506 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 48:
#line 648 "cfg.y" /* yacc.c:1652  */
    { IFOR();
		 		(yyval.sockid)=mk_listen_id((yyvsp[0].strval), PROTO_NONE, 0); }
#line 3513 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 49:
#line 650 "cfg.y" /* yacc.c:1652  */
    { IFOR();
		 		(yyval.sockid)=mk_listen_id((yyvsp[-2].strval), PROTO_NONE, (yyvsp[0].intval)); }
#line 3520 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 50:
#line 652 "cfg.y" /* yacc.c:1652  */
    {
				(yyval.sockid)=0;
				yyerror(" port number expected");
				}
#line 3529 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 52:
#line 659 "cfg.y" /* yacc.c:1652  */
    { IFOR();  (yyval.sockid)=(yyvsp[0].sockid) ; }
#line 3535 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 53:
#line 660 "cfg.y" /* yacc.c:1652  */
    { IFOR(); (yyval.sockid)=(yyvsp[-1].sockid); (yyval.sockid)->next=(yyvsp[0].sockid); }
#line 3541 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 54:
#line 663 "cfg.y" /* yacc.c:1652  */
    { IFOR();
					(yyval.sockid)=mk_listen_id((yyvsp[0].strval), PROTO_NONE, 0); }
#line 3548 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 55:
#line 665 "cfg.y" /* yacc.c:1652  */
    { IFOR();
			 		(yyval.sockid)=mk_listen_id((yyvsp[-2].strval), PROTO_NONE, (yyvsp[0].intval)); }
#line 3555 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 56:
#line 667 "cfg.y" /* yacc.c:1652  */
    {
					(yyval.sockid)=0;
					yyerror(" port number expected");
					}
#line 3564 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 57:
#line 673 "cfg.y" /* yacc.c:1652  */
    { IFOR();
					p_tmp.flags |= SI_IS_ANYCAST;
					}
#line 3572 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 58:
#line 676 "cfg.y" /* yacc.c:1652  */
    { IFOR();
					warn("'USE_CHILDREN' syntax is deprecated, use "
						"'USE_WORKERS' instead");
					p_tmp.workers=(yyvsp[0].intval);
					}
#line 3582 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 59:
#line 681 "cfg.y" /* yacc.c:1652  */
    { IFOR();
					p_tmp.workers=(yyvsp[0].intval);
					}
#line 3590 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 60:
#line 684 "cfg.y" /* yacc.c:1652  */
    { IFOR();
					p_tmp.socket = (yyvsp[0].sockid);
					}
#line 3598 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 61:
#line 687 "cfg.y" /* yacc.c:1652  */
    { IFOR();
					p_tmp.tag = (yyvsp[0].strval);
					}
#line 3606 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 62:
#line 690 "cfg.y" /* yacc.c:1652  */
    { IFOR();
					p_tmp.auto_scaling_profile=(yyvsp[0].strval);
					}
#line 3614 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 65:
#line 699 "cfg.y" /* yacc.c:1652  */
    { (yyval.sockid)=(yyvsp[0].sockid); }
#line 3620 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 66:
#line 700 "cfg.y" /* yacc.c:1652  */
    { (yyval.sockid)=(yyvsp[0].sockid); }
#line 3626 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 67:
#line 701 "cfg.y" /* yacc.c:1652  */
    { IFOR();
					memset(&p_tmp, 0, sizeof(p_tmp));
				}
#line 3634 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 68:
#line 703 "cfg.y" /* yacc.c:1652  */
    { IFOR();
					(yyval.sockid)=(yyvsp[-2].sockid); fill_socket_id(&p_tmp, (yyval.sockid));
				}
#line 3642 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 69:
#line 706 "cfg.y" /* yacc.c:1652  */
    { IFOR();
					memset(&p_tmp, 0, sizeof(p_tmp));
				}
#line 3650 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 70:
#line 708 "cfg.y" /* yacc.c:1652  */
    { IFOR();
					(yyval.sockid)=(yyvsp[-2].sockid); fill_socket_id(&p_tmp, (yyval.sockid));
				}
#line 3658 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 71:
#line 713 "cfg.y" /* yacc.c:1652  */
    { (yyval.intval)=PROTO_NONE; }
#line 3664 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 72:
#line 714 "cfg.y" /* yacc.c:1652  */
    { (yyval.intval)=(yyvsp[0].intval); }
#line 3670 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 73:
#line 716 "cfg.y" /* yacc.c:1652  */
    {  IFOR(); (yyval.multistr)=new_string((yyvsp[0].strval)); }
#line 3676 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 74:
#line 717 "cfg.y" /* yacc.c:1652  */
    { IFOR(); (yyval.multistr)=new_string((yyvsp[-1].strval)); (yyval.multistr)->next=(yyvsp[0].multistr); }
#line 3682 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 75:
#line 720 "cfg.y" /* yacc.c:1652  */
    {
				IFOR(pkg_free((yyvsp[-5].ipnet)));
				s_tmp.s=(yyvsp[-1].strval);
				s_tmp.len=strlen((yyvsp[-1].strval));
				if (add_rule_to_list(&bl_head,&bl_tail,(yyvsp[-5].ipnet),&s_tmp,(yyvsp[-3].intval),(yyvsp[-7].intval),0)) {
					yyerror("failed to add backlist element\n");YYABORT;
				}
			}
#line 3695 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 76:
#line 728 "cfg.y" /* yacc.c:1652  */
    {
				IFOR(pkg_free((yyvsp[-5].ipnet)));
				s_tmp.s=(yyvsp[-1].strval);
				s_tmp.len=strlen((yyvsp[-1].strval));
				if (add_rule_to_list(&bl_head,&bl_tail,(yyvsp[-5].ipnet),&s_tmp,
				(yyvsp[-3].intval),(yyvsp[-7].intval),BLR_APPLY_CONTRARY)) {
					yyerror("failed to add backlist element\n");YYABORT;
				}
			}
#line 3709 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 77:
#line 739 "cfg.y" /* yacc.c:1652  */
    {}
#line 3715 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 78:
#line 740 "cfg.y" /* yacc.c:1652  */
    {}
#line 3721 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 79:
#line 741 "cfg.y" /* yacc.c:1652  */
    { yyerror("bad black list element");}
#line 3727 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 80:
#line 748 "cfg.y" /* yacc.c:1652  */
    { IFOR();
			if (create_auto_scaling_profile((yyvsp[-17].strval),(yyvsp[-15].intval),(yyvsp[-13].intval),(yyvsp[-10].intval),(yyvsp[-8].intval),
			(yyvsp[-6].intval), (yyvsp[-4].intval), (yyvsp[-1].intval),10*(yyvsp[-1].intval))<0)
				yyerror("failed to create auto scaling profile");
		 }
#line 3737 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 81:
#line 756 "cfg.y" /* yacc.c:1652  */
    { IFOR();
			if (create_auto_scaling_profile((yyvsp[-16].strval),(yyvsp[-14].intval),(yyvsp[-12].intval),(yyvsp[-9].intval),(yyvsp[-9].intval),
			(yyvsp[-6].intval), (yyvsp[-4].intval), (yyvsp[-1].intval), 10*(yyvsp[-1].intval))<0)
				yyerror("failed to create auto scaling profile");
		 }
#line 3747 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 82:
#line 762 "cfg.y" /* yacc.c:1652  */
    { IFOR();
			if (create_auto_scaling_profile((yyvsp[-9].strval),(yyvsp[-7].intval),(yyvsp[-5].intval),(yyvsp[-2].intval),(yyvsp[0].intval),
			0, 0, 0, 0)<0)
				yyerror("failed to create auto scaling profile");
		}
#line 3757 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 83:
#line 768 "cfg.y" /* yacc.c:1652  */
    { IFOR();
			if (create_auto_scaling_profile((yyvsp[-8].strval),(yyvsp[-6].intval),(yyvsp[-4].intval),(yyvsp[-1].intval),(yyvsp[-1].intval),
			0, 0, 0, 0)<0)
				yyerror("failed to create auto scaling profile");
		}
#line 3767 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 84:
#line 776 "cfg.y" /* yacc.c:1652  */
    { yyerror("\'debug\' is deprecated, use \'log_level\' instead\n");}
#line 3773 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 85:
#line 778 "cfg.y" /* yacc.c:1652  */
    {yyerror("fork is deprecated, use debug_mode\n");}
#line 3779 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 86:
#line 779 "cfg.y" /* yacc.c:1652  */
    { IFOR();
			/* in debug mode, force logging to DEBUG level*/
			*log_level = debug_mode?L_DBG:(yyvsp[0].intval);
			}
#line 3788 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 87:
#line 783 "cfg.y" /* yacc.c:1652  */
    { IFOR(); enable_asserts=(yyvsp[0].intval); }
#line 3794 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 88:
#line 784 "cfg.y" /* yacc.c:1652  */
    { yyerror("boolean value expected"); }
#line 3800 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 89:
#line 785 "cfg.y" /* yacc.c:1652  */
    { IFOR(); abort_on_assert=(yyvsp[0].intval); }
#line 3806 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 90:
#line 786 "cfg.y" /* yacc.c:1652  */
    { yyerror("boolean value expected"); }
#line 3812 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 91:
#line 787 "cfg.y" /* yacc.c:1652  */
    { IFOR();
			debug_mode=(yyvsp[0].intval);
			if (debug_mode) { *log_level = L_DBG;log_stderr=1;}
			}
#line 3821 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 92:
#line 792 "cfg.y" /* yacc.c:1652  */
    { yyerror("boolean value expected for debug_mode"); }
#line 3827 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 93:
#line 796 "cfg.y" /* yacc.c:1652  */
    { IFOR(); if (!config_check && !debug_mode) log_stderr=(yyvsp[0].intval); }
#line 3833 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 94:
#line 797 "cfg.y" /* yacc.c:1652  */
    { yyerror("boolean value expected"); }
#line 3839 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 95:
#line 798 "cfg.y" /* yacc.c:1652  */
    { IFOR();
			if ( (i_tmp=str2facility((yyvsp[0].strval)))==-1)
				yyerror("bad facility (see syslog(3) man page)");
			if (!config_check)
				log_facility=i_tmp;
			}
#line 3850 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 96:
#line 804 "cfg.y" /* yacc.c:1652  */
    { yyerror("ID expected"); }
#line 3856 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 97:
#line 805 "cfg.y" /* yacc.c:1652  */
    { IFOR(); log_name=(yyvsp[0].strval); }
#line 3862 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 98:
#line 806 "cfg.y" /* yacc.c:1652  */
    { yyerror("string value expected"); }
#line 3868 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 99:
#line 807 "cfg.y" /* yacc.c:1652  */
    { IFOR(); received_dns|= ((yyvsp[0].intval))?DO_DNS:0; }
#line 3874 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 100:
#line 808 "cfg.y" /* yacc.c:1652  */
    { yyerror("boolean value expected"); }
#line 3880 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 101:
#line 809 "cfg.y" /* yacc.c:1652  */
    { IFOR(); received_dns|= ((yyvsp[0].intval))?DO_REV_DNS:0; }
#line 3886 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 102:
#line 810 "cfg.y" /* yacc.c:1652  */
    { yyerror("boolean value expected"); }
#line 3892 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 103:
#line 811 "cfg.y" /* yacc.c:1652  */
    { IFOR(); dns_try_ipv6=(yyvsp[0].intval); }
#line 3898 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 104:
#line 812 "cfg.y" /* yacc.c:1652  */
    { yyerror("boolean value expected"); }
#line 3904 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 105:
#line 813 "cfg.y" /* yacc.c:1652  */
    { IFOR(); dns_try_naptr=(yyvsp[0].intval); }
#line 3910 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 106:
#line 814 "cfg.y" /* yacc.c:1652  */
    { yyerror("boolean value expected"); }
#line 3916 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 107:
#line 815 "cfg.y" /* yacc.c:1652  */
    { IFOR(); dns_retr_time=(yyvsp[0].intval); }
#line 3922 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 108:
#line 816 "cfg.y" /* yacc.c:1652  */
    { yyerror("number expected"); }
#line 3928 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 109:
#line 817 "cfg.y" /* yacc.c:1652  */
    { IFOR(); dns_retr_no=(yyvsp[0].intval); }
#line 3934 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 110:
#line 818 "cfg.y" /* yacc.c:1652  */
    { yyerror("number expected"); }
#line 3940 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 111:
#line 819 "cfg.y" /* yacc.c:1652  */
    { IFOR(); dns_servers_no=(yyvsp[0].intval); }
#line 3946 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 112:
#line 820 "cfg.y" /* yacc.c:1652  */
    { yyerror("number expected"); }
#line 3952 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 113:
#line 821 "cfg.y" /* yacc.c:1652  */
    { IFOR(); dns_search_list=(yyvsp[0].intval); }
#line 3958 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 114:
#line 822 "cfg.y" /* yacc.c:1652  */
    { yyerror("boolean value expected"); }
#line 3964 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 115:
#line 823 "cfg.y" /* yacc.c:1652  */
    { IFOR(); max_while_loops=(yyvsp[0].intval); }
#line 3970 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 116:
#line 824 "cfg.y" /* yacc.c:1652  */
    { yyerror("number expected"); }
#line 3976 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 117:
#line 825 "cfg.y" /* yacc.c:1652  */
    { IFOR(); maxbuffer=(yyvsp[0].intval); }
#line 3982 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 118:
#line 826 "cfg.y" /* yacc.c:1652  */
    { yyerror("number expected"); }
#line 3988 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 119:
#line 827 "cfg.y" /* yacc.c:1652  */
    { IFOR();
			warn("'children' option is deprecated, "
				"use 'udp_workers' instead");
			udp_workers_no=(yyvsp[0].intval); }
#line 3997 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 120:
#line 831 "cfg.y" /* yacc.c:1652  */
    { yyerror("number expected"); }
#line 4003 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 121:
#line 832 "cfg.y" /* yacc.c:1652  */
    { IFOR(); udp_workers_no=(yyvsp[0].intval); }
#line 4009 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 122:
#line 833 "cfg.y" /* yacc.c:1652  */
    { IFOR();
				udp_workers_no=(yyvsp[-2].intval);
				udp_auto_scaling_profile=(yyvsp[0].strval);
		}
#line 4018 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 123:
#line 837 "cfg.y" /* yacc.c:1652  */
    { yyerror("number expected"); }
#line 4024 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 124:
#line 838 "cfg.y" /* yacc.c:1652  */
    { IFOR();
				timer_workers_no=(yyvsp[0].intval);
		}
#line 4032 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 125:
#line 841 "cfg.y" /* yacc.c:1652  */
    { IFOR();
				timer_workers_no=(yyvsp[-2].intval);
				timer_auto_scaling_profile=(yyvsp[0].strval);
		}
#line 4041 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 126:
#line 845 "cfg.y" /* yacc.c:1652  */
    { check_via=(yyvsp[0].intval); }
#line 4047 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 127:
#line 846 "cfg.y" /* yacc.c:1652  */
    { yyerror("boolean value expected"); }
#line 4053 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 128:
#line 847 "cfg.y" /* yacc.c:1652  */
    { IFOR();
			#ifdef HP_MALLOC
			shm_hash_split_percentage=(yyvsp[0].intval);
			#else
			LM_ERR("Cannot set parameter; Please recompile with support "
				"for HP_MALLOC\n");
			#endif
			}
#line 4066 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 129:
#line 855 "cfg.y" /* yacc.c:1652  */
    {
			#ifdef HP_MALLOC
			yyerror("number expected");
			#else
			LM_ERR("Cannot set parameter; Please recompile with support "
				"for HP_MALLOC\n");
			#endif
				}
#line 4079 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 130:
#line 863 "cfg.y" /* yacc.c:1652  */
    { IFOR();
			#ifdef HP_MALLOC
			shm_secondary_hash_size=(yyvsp[0].intval);
			#else
			LM_ERR("Cannot set parameter; Please recompile with support"
				" for HP_MALLOC\n");
			#endif
			}
#line 4092 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 131:
#line 871 "cfg.y" /* yacc.c:1652  */
    {
			#ifdef HP_MALLOC
			yyerror("number expected");
			#else
			LM_ERR("Cannot set parameter; Please recompile with support "
				"for HP_MALLOC\n");
			#endif
			}
#line 4105 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 132:
#line 879 "cfg.y" /* yacc.c:1652  */
    { IFOR();
			#ifdef HP_MALLOC
			mem_warming_enabled = (yyvsp[0].intval);
			#else
			LM_ERR("Cannot set parameter; Please recompile with support"
				" for HP_MALLOC\n");
			#endif
			}
#line 4118 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 133:
#line 887 "cfg.y" /* yacc.c:1652  */
    {
			#ifdef HP_MALLOC
			yyerror("number expected");
			#else
			LM_ERR("Cannot set parameter; Please recompile with support "
				"for HP_MALLOC\n");
			#endif
			}
#line 4131 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 134:
#line 895 "cfg.y" /* yacc.c:1652  */
    { IFOR();
			#ifdef HP_MALLOC
			mem_warming_pattern_file = (yyvsp[0].strval);
			#else
			LM_ERR("Cannot set parameter; Please recompile with "
				"support for HP_MALLOC\n");
			#endif
			}
#line 4144 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 135:
#line 903 "cfg.y" /* yacc.c:1652  */
    {
			#ifdef HP_MALLOC
			yyerror("string expected");
			#else
			LM_ERR("Cannot set parameter; Please recompile with support "
				"for HP_MALLOC\n");
			#endif
			}
#line 4157 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 136:
#line 911 "cfg.y" /* yacc.c:1652  */
    { IFOR();
			#ifdef HP_MALLOC
			mem_warming_percentage = (yyvsp[0].intval);
			#else
			LM_ERR("Cannot set parameter; Please recompile with "
				"support for HP_MALLOC\n");
			#endif
			}
#line 4170 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 137:
#line 919 "cfg.y" /* yacc.c:1652  */
    {
			#ifdef HP_MALLOC
			yyerror("number expected");
			#else
			LM_ERR("Cannot set parameter; Please recompile with support "
				"for HP_MALLOC\n");
			#endif
			}
#line 4183 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 138:
#line 927 "cfg.y" /* yacc.c:1652  */
    { IFOR();
			rpm_mem_file = (yyvsp[0].strval);
			}
#line 4191 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 139:
#line 930 "cfg.y" /* yacc.c:1652  */
    { yyerror("string value expected"); }
#line 4197 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 140:
#line 931 "cfg.y" /* yacc.c:1652  */
    { IFOR();
			rpm_mem_size = (yyvsp[0].intval) * 1024 * 1024;
			}
#line 4205 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 141:
#line 934 "cfg.y" /* yacc.c:1652  */
    { yyerror("int value expected"); }
#line 4211 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 142:
#line 935 "cfg.y" /* yacc.c:1652  */
    { IFOR(); memlog=(yyvsp[0].intval); memdump=(yyvsp[0].intval); }
#line 4217 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 143:
#line 936 "cfg.y" /* yacc.c:1652  */
    { yyerror("int value expected"); }
#line 4223 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 144:
#line 937 "cfg.y" /* yacc.c:1652  */
    { IFOR(); memdump=(yyvsp[0].intval); }
#line 4229 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 145:
#line 938 "cfg.y" /* yacc.c:1652  */
    { yyerror("int value expected"); }
#line 4235 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 146:
#line 939 "cfg.y" /* yacc.c:1652  */
    {  IFOR();execmsgthreshold=(yyvsp[0].intval); }
#line 4241 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 147:
#line 940 "cfg.y" /* yacc.c:1652  */
    { yyerror("int value expected"); }
#line 4247 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 148:
#line 941 "cfg.y" /* yacc.c:1652  */
    { IFOR(); execdnsthreshold=(yyvsp[0].intval); }
#line 4253 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 149:
#line 942 "cfg.y" /* yacc.c:1652  */
    { yyerror("int value expected"); }
#line 4259 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 150:
#line 943 "cfg.y" /* yacc.c:1652  */
    { IFOR(); tcpthreshold=(yyvsp[0].intval); }
#line 4265 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 151:
#line 944 "cfg.y" /* yacc.c:1652  */
    { yyerror("int value expected"); }
#line 4271 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 152:
#line 945 "cfg.y" /* yacc.c:1652  */
    { IFOR();
			#ifdef STATISTICS
			if ((yyvsp[0].intval) < 0 || (yyvsp[0].intval) > 100)
				yyerror("SHM threshold has to be a percentage between"
					" 0 and 100");
			event_shm_threshold=(yyvsp[0].intval);
			#else
			yyerror("statistics support not compiled in");
			#endif /* STATISTICS */
			}
#line 4286 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 153:
#line 955 "cfg.y" /* yacc.c:1652  */
    { yyerror("int value expected"); }
#line 4292 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 154:
#line 956 "cfg.y" /* yacc.c:1652  */
    { IFOR();
			#ifdef PKG_MALLOC
			#ifdef STATISTICS
			if ((yyvsp[0].intval) < 0 || (yyvsp[0].intval) > 100)
				yyerror("PKG threshold has to be a percentage between "
					"0 and 100");
			event_pkg_threshold=(yyvsp[0].intval);
			#else
			yyerror("statistics support not compiled in");
			#endif
			#else
			yyerror("pkg_malloc support not compiled in");
			#endif
			}
#line 4311 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 155:
#line 970 "cfg.y" /* yacc.c:1652  */
    { yyerror("int value expected"); }
#line 4317 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 156:
#line 971 "cfg.y" /* yacc.c:1652  */
    { IFOR(); query_buffer_size=(yyvsp[0].intval); }
#line 4323 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 157:
#line 972 "cfg.y" /* yacc.c:1652  */
    { yyerror("int value expected"); }
#line 4329 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 158:
#line 973 "cfg.y" /* yacc.c:1652  */
    { IFOR(); query_flush_time=(yyvsp[0].intval); }
#line 4335 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 159:
#line 974 "cfg.y" /* yacc.c:1652  */
    { yyerror("int value expected"); }
#line 4341 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 160:
#line 975 "cfg.y" /* yacc.c:1652  */
    { IFOR(); sip_warning=(yyvsp[0].intval); }
#line 4347 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 161:
#line 976 "cfg.y" /* yacc.c:1652  */
    { yyerror("boolean value expected"); }
#line 4353 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 162:
#line 977 "cfg.y" /* yacc.c:1652  */
    { IFOR(); chroot_dir=(yyvsp[0].strval); }
#line 4359 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 163:
#line 978 "cfg.y" /* yacc.c:1652  */
    { IFOR(); chroot_dir=(yyvsp[0].strval); }
#line 4365 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 164:
#line 979 "cfg.y" /* yacc.c:1652  */
    { yyerror("string value expected"); }
#line 4371 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 165:
#line 980 "cfg.y" /* yacc.c:1652  */
    { IFOR(); working_dir=(yyvsp[0].strval); }
#line 4377 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 166:
#line 981 "cfg.y" /* yacc.c:1652  */
    { IFOR(); working_dir=(yyvsp[0].strval); }
#line 4383 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 167:
#line 982 "cfg.y" /* yacc.c:1652  */
    { yyerror("string value expected"); }
#line 4389 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 168:
#line 983 "cfg.y" /* yacc.c:1652  */
    { IFOR(); mhomed=(yyvsp[0].intval); }
#line 4395 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 169:
#line 984 "cfg.y" /* yacc.c:1652  */
    { yyerror("boolean value expected"); }
#line 4401 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 170:
#line 985 "cfg.y" /* yacc.c:1652  */
    { IFOR();
									io_poll_method=get_poll_type((yyvsp[0].strval));
									if (io_poll_method==POLL_NONE){
										LM_CRIT("bad poll method name:"
											" %s\n, try one of %s.\n",
											(yyvsp[0].strval), poll_support);
										yyerror("bad poll_method "
											"value");
									}
								}
#line 4416 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 171:
#line 995 "cfg.y" /* yacc.c:1652  */
    { IFOR();
									io_poll_method=get_poll_type((yyvsp[0].strval));
									if (io_poll_method==POLL_NONE){
										LM_CRIT("bad poll method name:"
											" %s\n, try one of %s.\n",
											(yyvsp[0].strval), poll_support);
										yyerror("bad poll_method "
											"value");
									}
									}
#line 4431 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 172:
#line 1005 "cfg.y" /* yacc.c:1652  */
    { yyerror("poll method name expected"); }
#line 4437 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 173:
#line 1006 "cfg.y" /* yacc.c:1652  */
    { IFOR();
				tcp_accept_aliases=(yyvsp[0].intval);
		}
#line 4445 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 174:
#line 1009 "cfg.y" /* yacc.c:1652  */
    { yyerror("boolean value expected"); }
#line 4451 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 175:
#line 1010 "cfg.y" /* yacc.c:1652  */
    { IFOR();
				warn("'tcp_children' option is deprecated, "
					"use 'tcp_workers' instead");
				tcp_workers_no=(yyvsp[0].intval);
		}
#line 4461 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 176:
#line 1015 "cfg.y" /* yacc.c:1652  */
    { yyerror("number expected"); }
#line 4467 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 177:
#line 1016 "cfg.y" /* yacc.c:1652  */
    { IFOR();
				tcp_workers_no=(yyvsp[0].intval);
		}
#line 4475 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 178:
#line 1019 "cfg.y" /* yacc.c:1652  */
    { IFOR();
				tcp_workers_no=(yyvsp[-2].intval);
				tcp_auto_scaling_profile=(yyvsp[0].strval);
		}
#line 4484 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 179:
#line 1023 "cfg.y" /* yacc.c:1652  */
    { yyerror("number expected"); }
#line 4490 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 180:
#line 1024 "cfg.y" /* yacc.c:1652  */
    { IFOR();
				tcp_connect_timeout=(yyvsp[0].intval);
		}
#line 4498 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 181:
#line 1027 "cfg.y" /* yacc.c:1652  */
    { yyerror("number expected"); }
#line 4504 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 182:
#line 1028 "cfg.y" /* yacc.c:1652  */
    { IFOR();
				tcp_con_lifetime=(yyvsp[0].intval);
		}
#line 4512 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 183:
#line 1031 "cfg.y" /* yacc.c:1652  */
    { yyerror("number expected"); }
#line 4518 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 184:
#line 1032 "cfg.y" /* yacc.c:1652  */
    { IFOR();
				tcp_listen_backlog=(yyvsp[0].intval);
		}
#line 4526 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 185:
#line 1035 "cfg.y" /* yacc.c:1652  */
    { yyerror("number expected"); }
#line 4532 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 186:
#line 1036 "cfg.y" /* yacc.c:1652  */
    { IFOR();
				tcp_max_connections=(yyvsp[0].intval);
		}
#line 4540 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 187:
#line 1039 "cfg.y" /* yacc.c:1652  */
    { yyerror("number expected"); }
#line 4546 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 188:
#line 1040 "cfg.y" /* yacc.c:1652  */
    { IFOR();
				tmp = NULL;
				fix_flag_name(tmp, (yyvsp[0].intval));
				tcp_no_new_conn_bflag =
					get_flag_id_by_name(FLAG_TYPE_BRANCH, tmp);
				if (!flag_in_range( (flag_t)tcp_no_new_conn_bflag ) )
					yyerror("invalid TCP no_new_conn Branch Flag");
				flag_idx2mask( &tcp_no_new_conn_bflag );
		}
#line 4560 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 189:
#line 1049 "cfg.y" /* yacc.c:1652  */
    { IFOR();
				tcp_no_new_conn_bflag =
					get_flag_id_by_name(FLAG_TYPE_BRANCH, (yyvsp[0].strval));
				if (!flag_in_range( (flag_t)tcp_no_new_conn_bflag ) )
					yyerror("invalid TCP no_new_conn Branch Flag");
				flag_idx2mask( &tcp_no_new_conn_bflag );
		}
#line 4572 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 190:
#line 1056 "cfg.y" /* yacc.c:1652  */
    { yyerror("number value expected"); }
#line 4578 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 191:
#line 1057 "cfg.y" /* yacc.c:1652  */
    { IFOR();
				tcp_no_new_conn_rplflag =
					get_flag_id_by_name(FLAG_TYPE_MSG, (yyvsp[0].strval));
				if (!flag_in_range( (flag_t)tcp_no_new_conn_rplflag ) )
					yyerror("invalid TCP no_new_conn RePLy Flag");
				flag_idx2mask( &tcp_no_new_conn_rplflag );
		}
#line 4590 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 192:
#line 1064 "cfg.y" /* yacc.c:1652  */
    { yyerror("number value expected"); }
#line 4596 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 193:
#line 1066 "cfg.y" /* yacc.c:1652  */
    { IFOR();
				tcp_keepalive=(yyvsp[0].intval);
		}
#line 4604 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 194:
#line 1069 "cfg.y" /* yacc.c:1652  */
    { yyerror("boolean value expected"); }
#line 4610 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 195:
#line 1070 "cfg.y" /* yacc.c:1652  */
    { IFOR();
				tcp_max_msg_time=(yyvsp[0].intval);
		}
#line 4618 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 196:
#line 1073 "cfg.y" /* yacc.c:1652  */
    { yyerror("boolean value expected"); }
#line 4624 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 197:
#line 1074 "cfg.y" /* yacc.c:1652  */
    { IFOR();
			#ifndef HAVE_TCP_KEEPCNT
				warn("cannot be enabled TCP_KEEPCOUNT (no OS support)");
			#else
				tcp_keepcount=(yyvsp[0].intval);
			#endif
		}
#line 4636 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 198:
#line 1081 "cfg.y" /* yacc.c:1652  */
    { yyerror("int value expected"); }
#line 4642 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 199:
#line 1082 "cfg.y" /* yacc.c:1652  */
    { IFOR();
			#ifndef HAVE_TCP_KEEPIDLE
				warn("cannot be enabled TCP_KEEPIDLE (no OS support)");
			#else
				tcp_keepidle=(yyvsp[0].intval);
			#endif
		}
#line 4654 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 200:
#line 1089 "cfg.y" /* yacc.c:1652  */
    { yyerror("int value expected"); }
#line 4660 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 201:
#line 1090 "cfg.y" /* yacc.c:1652  */
    { IFOR();
			#ifndef HAVE_TCP_KEEPINTVL
				warn("cannot be enabled TCP_KEEPINTERVAL (no OS support)");
			#else
				tcp_keepinterval=(yyvsp[0].intval);
			 #endif
		}
#line 4672 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 202:
#line 1097 "cfg.y" /* yacc.c:1652  */
    { yyerror("int value expected"); }
#line 4678 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 203:
#line 1098 "cfg.y" /* yacc.c:1652  */
    { IFOR();
							server_signature=(yyvsp[0].intval); }
#line 4685 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 204:
#line 1100 "cfg.y" /* yacc.c:1652  */
    { yyerror("boolean value expected"); }
#line 4691 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 205:
#line 1101 "cfg.y" /* yacc.c:1652  */
    { IFOR();
							server_header.s=(yyvsp[0].strval);
							server_header.len=strlen((yyvsp[0].strval));
							}
#line 4700 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 206:
#line 1105 "cfg.y" /* yacc.c:1652  */
    { yyerror("string value expected"); }
#line 4706 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 207:
#line 1106 "cfg.y" /* yacc.c:1652  */
    { user_agent_header.s=(yyvsp[0].strval);
									user_agent_header.len=strlen((yyvsp[0].strval));
									}
#line 4714 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 208:
#line 1109 "cfg.y" /* yacc.c:1652  */
    { yyerror("string value expected"); }
#line 4720 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 209:
#line 1110 "cfg.y" /* yacc.c:1652  */
    { IFOR();
							pv_print_buf_size = (yyvsp[0].intval); }
#line 4727 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 210:
#line 1112 "cfg.y" /* yacc.c:1652  */
    { yyerror("number expected"); }
#line 4733 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 211:
#line 1113 "cfg.y" /* yacc.c:1652  */
    { IFOR();
							xlog_buf_size = (yyvsp[0].intval); }
#line 4740 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 212:
#line 1115 "cfg.y" /* yacc.c:1652  */
    { IFOR();
							xlog_force_color = (yyvsp[0].intval); }
#line 4747 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 213:
#line 1117 "cfg.y" /* yacc.c:1652  */
    { IFOR();
							xlog_print_level = (yyvsp[0].intval); }
#line 4754 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 214:
#line 1119 "cfg.y" /* yacc.c:1652  */
    { yyerror("number expected"); }
#line 4760 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 215:
#line 1120 "cfg.y" /* yacc.c:1652  */
    { yyerror("boolean value expected"); }
#line 4766 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 216:
#line 1121 "cfg.y" /* yacc.c:1652  */
    { yyerror("number expected"); }
#line 4772 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 217:
#line 1122 "cfg.y" /* yacc.c:1652  */
    { IFOR();
							*xlog_level = (yyvsp[0].intval); }
#line 4779 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 218:
#line 1124 "cfg.y" /* yacc.c:1652  */
    { yyerror("number expected"); }
#line 4785 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 219:
#line 1125 "cfg.y" /* yacc.c:1652  */
    { IFOR();
							if (add_listener((yyvsp[0].sockid))!=0){
								LM_CRIT("cfg. parser: failed"
										" to add listen address\n");
								break;
							}
						}
#line 4797 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 220:
#line 1132 "cfg.y" /* yacc.c:1652  */
    { yyerror("ip address or hostname "
						"expected (use quotes if the hostname includes"
						" config keywords)"); }
#line 4805 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 221:
#line 1135 "cfg.y" /* yacc.c:1652  */
    { IFOR();
							/* convert STIRNG ($3) to an ID */
							/* update the memstats type for each module */
							#ifndef SHM_EXTRA_STATS
								LM_CRIT("SHM_EXTRA_STATS not defined");
								YYABORT;
							#else

							#ifdef SHM_SHOW_DEFAULT_GROUP
							if(strcmp((yyvsp[-2].strval), "default") == 0){
								LM_CRIT("default group  name is not allowed");
								YYABORT;
							}
							#endif

							for(tmp_mod = mod_names; tmp_mod; tmp_mod=tmp_mod->next){
								if(strcmp((yyvsp[-2].strval), tmp_mod->s) == 0){
									LM_CRIT("The same mem-group name is used twice: [%s] [%s]\n", (yyvsp[-2].strval), tmp_mod->s);
									YYABORT;
								}
							}

							tmp_mod = pkg_malloc(sizeof(struct multi_str));
							if(!tmp_mod){
								LM_CRIT("out of pkg memory");
								YYABORT;
							}

							tmp_mod->s = (yyvsp[-2].strval);
							tmp_mod->next = mod_names;
							mod_names = tmp_mod;
							for (tmp_mod = (yyvsp[0].multistr); tmp_mod; tmp_mod = tmp_mod->next){
								if(set_mem_idx(tmp_mod->s, mem_free_idx)){
									YYABORT;
								}
							}

							mem_free_idx++;	

							if(alloc_group_stat()){
								YYABORT;
							}
							#endif
						}
#line 4854 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 222:
#line 1179 "cfg.y" /* yacc.c:1652  */
    { yyerror("invalid or no module specified"); }
#line 4860 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 223:
#line 1180 "cfg.y" /* yacc.c:1652  */
    { IFOR();
							for(lst_tmp=(yyvsp[0].sockid); lst_tmp; lst_tmp=lst_tmp->next)
								add_alias(lst_tmp->name, strlen(lst_tmp->name),
											lst_tmp->port, lst_tmp->proto);
							  }
#line 4870 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 224:
#line 1185 "cfg.y" /* yacc.c:1652  */
    { yyerror("hostname expected (use quotes"
							" if the hostname includes config keywords)"); }
#line 4877 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 225:
#line 1187 "cfg.y" /* yacc.c:1652  */
    { IFOR();
								auto_aliases=(yyvsp[0].intval); }
#line 4884 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 226:
#line 1189 "cfg.y" /* yacc.c:1652  */
    { yyerror("number  expected"); }
#line 4890 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 227:
#line 1190 "cfg.y" /* yacc.c:1652  */
    { IFOR();
								if ((yyvsp[0].strval)) {
									default_global_address.s=(yyvsp[0].strval);
									default_global_address.len=strlen((yyvsp[0].strval));
								}
								}
#line 4901 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 228:
#line 1196 "cfg.y" /* yacc.c:1652  */
    {yyerror("ip address or hostname "
												"expected"); }
#line 4908 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 229:
#line 1198 "cfg.y" /* yacc.c:1652  */
    { IFOR();
								tmp = int2str((yyvsp[0].intval), &i_tmp);
								if (i_tmp > default_global_port.len)
									default_global_port.s =
									pkg_realloc(default_global_port.s, i_tmp);
								if (!default_global_port.s) {
									LM_CRIT("cfg. parser: out of memory.\n");
									YYABORT;
								} else {
									default_global_port.len = i_tmp;
									memcpy(default_global_port.s, tmp,
											default_global_port.len);
								}
								}
#line 4927 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 230:
#line 1212 "cfg.y" /* yacc.c:1652  */
    {yyerror("ip address or hostname "
												"expected"); }
#line 4934 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 231:
#line 1214 "cfg.y" /* yacc.c:1652  */
    { IFOR();
										disable_core_dump=(yyvsp[0].intval);
									}
#line 4942 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 232:
#line 1217 "cfg.y" /* yacc.c:1652  */
    { yyerror("boolean value expected"); }
#line 4948 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 233:
#line 1218 "cfg.y" /* yacc.c:1652  */
    { IFOR();
										open_files_limit=(yyvsp[0].intval);
									}
#line 4956 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 234:
#line 1221 "cfg.y" /* yacc.c:1652  */
    { yyerror("number expected"); }
#line 4962 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 235:
#line 1222 "cfg.y" /* yacc.c:1652  */
    { IFOR();
								#ifdef USE_MCAST
										mcast_loopback=(yyvsp[0].intval);
								#else
									warn("no multicast support compiled in");
								#endif
		  }
#line 4974 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 236:
#line 1229 "cfg.y" /* yacc.c:1652  */
    { yyerror("boolean value expected"); }
#line 4980 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 237:
#line 1230 "cfg.y" /* yacc.c:1652  */
    { IFOR();
								#ifdef USE_MCAST
										mcast_ttl=(yyvsp[0].intval);
								#else
									warn("no multicast support compiled in");
								#endif
		  }
#line 4992 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 238:
#line 1237 "cfg.y" /* yacc.c:1652  */
    { yyerror("number expected as tos"); }
#line 4998 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 239:
#line 1238 "cfg.y" /* yacc.c:1652  */
    { IFOR(); tos = (yyvsp[0].intval);
							if (tos<=0)
								yyerror("invalid tos value");
		 }
#line 5007 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 240:
#line 1242 "cfg.y" /* yacc.c:1652  */
    { IFOR();
							if (strcasecmp((yyvsp[0].strval),"IPTOS_LOWDELAY")) {
								tos=IPTOS_LOWDELAY;
							} else if (strcasecmp((yyvsp[0].strval),"IPTOS_THROUGHPUT")) {
								tos=IPTOS_THROUGHPUT;
							} else if (strcasecmp((yyvsp[0].strval),"IPTOS_RELIABILITY")) {
								tos=IPTOS_RELIABILITY;
#if defined(IPTOS_MINCOST)
							} else if (strcasecmp((yyvsp[0].strval),"IPTOS_MINCOST")) {
								tos=IPTOS_MINCOST;
#endif
#if defined(IPTOS_LOWCOST)
							} else if (strcasecmp((yyvsp[0].strval),"IPTOS_LOWCOST")) {
								tos=IPTOS_LOWCOST;
#endif
							} else {
								yyerror("invalid tos value - allowed: "
									"IPTOS_LOWDELAY,IPTOS_THROUGHPUT,"
									"IPTOS_RELIABILITY"
#if defined(IPTOS_LOWCOST)
									",IPTOS_LOWCOST"
#endif
#if defined(IPTOS_MINCOST)
									",IPTOS_MINCOST"
#endif
									"\n");
							}
		 }
#line 5040 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 241:
#line 1270 "cfg.y" /* yacc.c:1652  */
    { yyerror("number expected"); }
#line 5046 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 242:
#line 1271 "cfg.y" /* yacc.c:1652  */
    {IFOR();
				set_mpath((yyvsp[0].strval)); }
#line 5053 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 243:
#line 1273 "cfg.y" /* yacc.c:1652  */
    { yyerror("string value expected"); }
#line 5059 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 244:
#line 1274 "cfg.y" /* yacc.c:1652  */
    { IFOR();
										disable_dns_failover=(yyvsp[0].intval);
									}
#line 5067 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 245:
#line 1277 "cfg.y" /* yacc.c:1652  */
    { yyerror("boolean value expected"); }
#line 5073 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 246:
#line 1278 "cfg.y" /* yacc.c:1652  */
    { IFOR();
										disable_dns_blacklist=(yyvsp[0].intval);
									}
#line 5081 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 247:
#line 1281 "cfg.y" /* yacc.c:1652  */
    { yyerror("boolean value expected"); }
#line 5087 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 248:
#line 1282 "cfg.y" /* yacc.c:1652  */
    { IFOR();
				s_tmp.s = (yyvsp[-4].strval);
				s_tmp.len = strlen((yyvsp[-4].strval));
				if (create_bl_head( BL_CORE_ID, BL_READONLY_LIST,
				    bl_head, bl_tail, &s_tmp)==0) {
					yyerror("failed to create blacklist\n");
					YYABORT;
				}
				bl_head = bl_tail = NULL;
				}
#line 5102 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 249:
#line 1292 "cfg.y" /* yacc.c:1652  */
    { IFOR();
				sl_fwd_disabled=(yyvsp[0].intval); }
#line 5109 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 250:
#line 1294 "cfg.y" /* yacc.c:1652  */
    { IFOR();
				db_version_table=(yyvsp[0].strval); }
#line 5116 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 251:
#line 1296 "cfg.y" /* yacc.c:1652  */
    { yyerror("string value expected"); }
#line 5122 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 252:
#line 1297 "cfg.y" /* yacc.c:1652  */
    { IFOR();
				db_default_url=(yyvsp[0].strval); }
#line 5129 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 253:
#line 1299 "cfg.y" /* yacc.c:1652  */
    { yyerror("string value expected"); }
#line 5135 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 254:
#line 1300 "cfg.y" /* yacc.c:1652  */
    { IFOR();
				db_max_async_connections=(yyvsp[0].intval); }
#line 5142 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 255:
#line 1302 "cfg.y" /* yacc.c:1652  */
    {
				yyerror("integer value expected");
				}
#line 5150 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 256:
#line 1305 "cfg.y" /* yacc.c:1652  */
    { IFOR();
				disable_503_translation=(yyvsp[0].intval); }
#line 5157 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 257:
#line 1307 "cfg.y" /* yacc.c:1652  */
    {
				yyerror("integer value expected");
				}
#line 5165 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 258:
#line 1310 "cfg.y" /* yacc.c:1652  */
    {}
#line 5171 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 259:
#line 1311 "cfg.y" /* yacc.c:1652  */
    {
				yyerror("bad auto-scaling profile definition");
				}
#line 5179 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 260:
#line 1314 "cfg.y" /* yacc.c:1652  */
    { IFOR();
				auto_scaling_cycle=(yyvsp[0].intval); }
#line 5186 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 261:
#line 1316 "cfg.y" /* yacc.c:1652  */
    {
				yyerror("integer value expected");
				}
#line 5194 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 262:
#line 1319 "cfg.y" /* yacc.c:1652  */
    { yyerror("unknown config variable"); }
#line 5200 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 263:
#line 1322 "cfg.y" /* yacc.c:1652  */
    { IFOR();
			if (load_module((yyvsp[0].strval)) < 0)
				yyerrorf("failed to load module %s\n", (yyvsp[0].strval));
		}
#line 5209 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 264:
#line 1326 "cfg.y" /* yacc.c:1652  */
    { yyerror("string expected");  }
#line 5215 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 265:
#line 1327 "cfg.y" /* yacc.c:1652  */
    { IFOR();
				if (set_mod_param_regex((yyvsp[-5].strval), (yyvsp[-3].strval), STR_PARAM, (yyvsp[-1].strval)) != 0) {
					yyerrorf("Parameter <%s> not found in module <%s> - "
						"can't set", (yyvsp[-3].strval), (yyvsp[-5].strval));
				}
			}
#line 5226 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 266:
#line 1333 "cfg.y" /* yacc.c:1652  */
    { IFOR();
				if (set_mod_param_regex((yyvsp[-5].strval), (yyvsp[-3].strval), INT_PARAM, (void*)(yyvsp[-1].intval)) != 0) {
					yyerrorf("Parameter <%s> not found in module <%s> - "
						"can't set", (yyvsp[-3].strval), (yyvsp[-5].strval));
				}
			}
#line 5237 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 267:
#line 1339 "cfg.y" /* yacc.c:1652  */
    { yyerror("Invalid arguments"); }
#line 5243 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 268:
#line 1343 "cfg.y" /* yacc.c:1652  */
    { (yyval.ipaddr)=(yyvsp[0].ipaddr); }
#line 5249 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 269:
#line 1344 "cfg.y" /* yacc.c:1652  */
    { (yyval.ipaddr)=(yyvsp[0].ipaddr); }
#line 5255 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 270:
#line 1347 "cfg.y" /* yacc.c:1652  */
    {
					(yyval.ipaddr)=pkg_malloc(sizeof(struct ip_addr));
					if ((yyval.ipaddr)==0){
						LM_CRIT("ERROR: cfg. parser: out of memory.\n");
						YYABORT;
					}else{
						memset((yyval.ipaddr), 0, sizeof(struct ip_addr));
						(yyval.ipaddr)->af=AF_INET;
						(yyval.ipaddr)->len=16;
						if (inet_pton(AF_INET, (yyvsp[0].strval), (yyval.ipaddr)->u.addr)<=0){
							yyerror("bad ipv4 address");
						}
					}
				}
#line 5274 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 271:
#line 1363 "cfg.y" /* yacc.c:1652  */
    {
					(yyval.ipaddr)=pkg_malloc(sizeof(struct ip_addr));
					if ((yyval.ipaddr)==0){
						LM_CRIT("ERROR: cfg. parser: out of memory.\n");
						YYABORT;
					}else{
						memset((yyval.ipaddr), 0, sizeof(struct ip_addr));
						(yyval.ipaddr)->af=AF_INET6;
						(yyval.ipaddr)->len=16;
						if (inet_pton(AF_INET6, (yyvsp[0].strval), (yyval.ipaddr)->u.addr)<=0){
							yyerror("bad ipv6 address");
						}
					}
				}
#line 5293 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 272:
#line 1379 "cfg.y" /* yacc.c:1652  */
    { (yyval.ipaddr)=(yyvsp[0].ipaddr); }
#line 5299 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 273:
#line 1380 "cfg.y" /* yacc.c:1652  */
    {(yyval.ipaddr)=(yyvsp[-1].ipaddr); }
#line 5305 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 274:
#line 1383 "cfg.y" /* yacc.c:1652  */
    {
				if (parse_ipnet((yyvsp[0].strval), strlen((yyvsp[0].strval)), &net_tmp) < 0)
					yyerror("unable to parse ip and/or netmask\n");

				(yyval.ipnet) = net_tmp;
			}
#line 5316 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 275:
#line 1389 "cfg.y" /* yacc.c:1652  */
    {
				(yyval.ipnet)=mk_net_bitlen((yyvsp[0].ipaddr), (yyvsp[0].ipaddr)->len*8);
				pkg_free((yyvsp[0].ipaddr));
			}
#line 5325 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 276:
#line 1399 "cfg.y" /* yacc.c:1652  */
    {
				(yyval.strval) = pkg_malloc( strlen((yyvsp[-1].strval)) + strlen((yyvsp[0].strval)) + 1);
				if ((yyval.strval)==0){
					yyerror("cfg. parser: out of memory");
					YYABORT;
				} else {
					strcpy((yyval.strval),(yyvsp[-1].strval)); strcat((yyval.strval),(yyvsp[0].strval));
					pkg_free((yyvsp[-1].strval)); pkg_free((yyvsp[0].strval));
				}
			}
#line 5340 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 277:
#line 1409 "cfg.y" /* yacc.c:1652  */
    {
				(yyval.strval) = pkg_malloc( strlen((yyvsp[-1].strval)) + strlen((yyvsp[0].strval)) + 1);
				if ((yyval.strval)==0){
					LM_CRIT("ERROR: cfg. parser: out of memory.\n");
					YYABORT;
				} else {
					strcpy((yyval.strval),(yyvsp[-1].strval)); strcat((yyval.strval),(yyvsp[0].strval));
					pkg_free((yyvsp[-1].strval)); pkg_free((yyvsp[0].strval));
				}
			}
#line 5355 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 278:
#line 1420 "cfg.y" /* yacc.c:1652  */
    {
				(yyval.strval) = (yyvsp[0].strval);
				}
#line 5363 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 279:
#line 1423 "cfg.y" /* yacc.c:1652  */
    {
				tmp=int2str((yyvsp[0].intval), &i_tmp);
				if (((yyval.strval)=pkg_malloc(i_tmp+1))==0) {
					yyerror("cfg. parser: out of memory.\n");
					YYABORT;
				}
				memcpy( (yyval.strval), tmp, i_tmp);
				(yyval.strval)[i_tmp] = 0;
				}
#line 5377 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 280:
#line 1432 "cfg.y" /* yacc.c:1652  */
    {
				(yyval.strval) = (yyvsp[0].strval);
		}
#line 5385 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 281:
#line 1437 "cfg.y" /* yacc.c:1652  */
    {
						if (sroutes->request[DEFAULT_RT].a!=0) {
							yyerror("overwriting default "
								"request routing table");
							YYABORT;
						}
						push((yyvsp[-1].action), &sroutes->request[DEFAULT_RT].a);
					}
#line 5398 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 282:
#line 1445 "cfg.y" /* yacc.c:1652  */
    {
						if ( strtol((yyvsp[-4].strval),&tmp,10)==0 && *tmp==0) {
							/* route[0] detected */
							if (sroutes->request[DEFAULT_RT].a!=0) {
								yyerror("overwriting(2) default "
									"request routing table");
								YYABORT;
							}
							push((yyvsp[-1].action), &sroutes->request[DEFAULT_RT].a);
						} else {
							i_tmp = get_script_route_idx( (yyvsp[-4].strval),
								sroutes->request, RT_NO,1);
							if (i_tmp==-1) YYABORT;
							push((yyvsp[-1].action), &sroutes->request[i_tmp].a);
						}
					}
#line 5419 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 283:
#line 1461 "cfg.y" /* yacc.c:1652  */
    { yyerror("invalid  route  statement"); }
#line 5425 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 284:
#line 1464 "cfg.y" /* yacc.c:1652  */
    {
						i_tmp = get_script_route_idx( (yyvsp[-4].strval), sroutes->failure,
							FAILURE_RT_NO,1);
						if (i_tmp==-1) YYABORT;
						push((yyvsp[-1].action), &sroutes->failure[i_tmp].a);
					}
#line 5436 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 285:
#line 1470 "cfg.y" /* yacc.c:1652  */
    { yyerror("invalid failure_route statement"); }
#line 5442 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 286:
#line 1473 "cfg.y" /* yacc.c:1652  */
    {
						if (sroutes->onreply[DEFAULT_RT].a!=0) {
							yyerror("overwriting default "
								"onreply routing table");
							YYABORT;
						}
						push((yyvsp[-1].action), &sroutes->onreply[DEFAULT_RT].a);
					}
#line 5455 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 287:
#line 1481 "cfg.y" /* yacc.c:1652  */
    {
						i_tmp = get_script_route_idx( (yyvsp[-4].strval), sroutes->onreply,
							ONREPLY_RT_NO,1);
						if (i_tmp==-1) YYABORT;
						push((yyvsp[-1].action), &sroutes->onreply[i_tmp].a);
					}
#line 5466 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 288:
#line 1487 "cfg.y" /* yacc.c:1652  */
    { yyerror("invalid onreply_route statement"); }
#line 5472 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 289:
#line 1490 "cfg.y" /* yacc.c:1652  */
    {
						i_tmp = get_script_route_idx( (yyvsp[-4].strval), sroutes->branch,
							BRANCH_RT_NO,1);
						if (i_tmp==-1) YYABORT;
						push((yyvsp[-1].action), &sroutes->branch[i_tmp].a);
					}
#line 5483 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 290:
#line 1496 "cfg.y" /* yacc.c:1652  */
    { yyerror("invalid branch_route statement"); }
#line 5489 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 291:
#line 1499 "cfg.y" /* yacc.c:1652  */
    {
						if (sroutes->error.a!=0) {
							yyerror("overwriting default "
								"error routing table");
							YYABORT;
						}
						push((yyvsp[-1].action), &sroutes->error.a);
					}
#line 5502 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 292:
#line 1507 "cfg.y" /* yacc.c:1652  */
    { yyerror("invalid error_route statement"); }
#line 5508 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 293:
#line 1510 "cfg.y" /* yacc.c:1652  */
    {
						if (sroutes->local.a!=0) {
							yyerror("re-definition of local "
								"route detected");
							YYABORT;
						}
						push((yyvsp[-1].action), &sroutes->local.a);
					}
#line 5521 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 294:
#line 1518 "cfg.y" /* yacc.c:1652  */
    { yyerror("invalid local_route statement"); }
#line 5527 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 295:
#line 1521 "cfg.y" /* yacc.c:1652  */
    {
						if (sroutes->startup.a!=0) {
							yyerror("re-definition of startup "
								"route detected");
							YYABORT;
						}
						push((yyvsp[-1].action), &sroutes->startup.a);
					}
#line 5540 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 296:
#line 1529 "cfg.y" /* yacc.c:1652  */
    { yyerror("invalid startup_route statement"); }
#line 5546 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 297:
#line 1532 "cfg.y" /* yacc.c:1652  */
    {
						i_tmp = 0;
						while(sroutes->timer[i_tmp].a!=0 && i_tmp<TIMER_RT_NO){
							i_tmp++;
						}
						if(i_tmp == TIMER_RT_NO) {
							yyerror("Too many timer routes defined\n");
							YYABORT;
						}
						sroutes->timer[i_tmp].interval = (yyvsp[-4].intval);
						push((yyvsp[-1].action), &sroutes->timer[i_tmp].a);
					}
#line 5563 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 298:
#line 1544 "cfg.y" /* yacc.c:1652  */
    { yyerror("invalid timer_route statement"); }
#line 5569 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 299:
#line 1547 "cfg.y" /* yacc.c:1652  */
    {
						i_tmp = get_script_route_idx((yyvsp[-4].strval), sroutes->event,
								EVENT_RT_NO,1);
						if (i_tmp==-1) YYABORT;
						push((yyvsp[-1].action), &sroutes->event[i_tmp].a);
					}
#line 5580 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 300:
#line 1553 "cfg.y" /* yacc.c:1652  */
    { yyerror("invalid timer_route statement"); }
#line 5586 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 301:
#line 1558 "cfg.y" /* yacc.c:1652  */
    { (yyval.expr)=mk_exp(AND_OP, (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 5592 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 302:
#line 1559 "cfg.y" /* yacc.c:1652  */
    { (yyval.expr)=mk_exp(OR_OP, (yyvsp[-2].expr), (yyvsp[0].expr));  }
#line 5598 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 303:
#line 1560 "cfg.y" /* yacc.c:1652  */
    { (yyval.expr)=mk_exp(NOT_OP, (yyvsp[0].expr), 0);  }
#line 5604 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 304:
#line 1561 "cfg.y" /* yacc.c:1652  */
    { (yyval.expr)=mk_exp(EVAL_OP, (yyvsp[-1].expr), 0); }
#line 5610 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 305:
#line 1562 "cfg.y" /* yacc.c:1652  */
    { (yyval.expr)=(yyvsp[-1].expr); }
#line 5616 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 306:
#line 1563 "cfg.y" /* yacc.c:1652  */
    { (yyval.expr)=(yyvsp[0].expr); }
#line 5622 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 307:
#line 1566 "cfg.y" /* yacc.c:1652  */
    {(yyval.intval)=EQUAL_OP; }
#line 5628 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 308:
#line 1567 "cfg.y" /* yacc.c:1652  */
    {(yyval.intval)=DIFF_OP; }
#line 5634 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 309:
#line 1570 "cfg.y" /* yacc.c:1652  */
    {(yyval.intval)=GT_OP; }
#line 5640 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 310:
#line 1571 "cfg.y" /* yacc.c:1652  */
    {(yyval.intval)=LT_OP; }
#line 5646 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 311:
#line 1572 "cfg.y" /* yacc.c:1652  */
    {(yyval.intval)=GTE_OP; }
#line 5652 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 312:
#line 1573 "cfg.y" /* yacc.c:1652  */
    {(yyval.intval)=LTE_OP; }
#line 5658 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 313:
#line 1575 "cfg.y" /* yacc.c:1652  */
    {(yyval.intval)=MATCH_OP; }
#line 5664 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 314:
#line 1576 "cfg.y" /* yacc.c:1652  */
    {(yyval.intval)=NOTMATCH_OP; }
#line 5670 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 315:
#line 1579 "cfg.y" /* yacc.c:1652  */
    {(yyval.intval)=(yyvsp[0].intval); }
#line 5676 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 316:
#line 1580 "cfg.y" /* yacc.c:1652  */
    {(yyval.intval)=(yyvsp[0].intval); }
#line 5682 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 317:
#line 1583 "cfg.y" /* yacc.c:1652  */
    {(yyval.intval)=(yyvsp[0].intval); }
#line 5688 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 318:
#line 1584 "cfg.y" /* yacc.c:1652  */
    {(yyval.intval)=(yyvsp[0].intval); }
#line 5694 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 319:
#line 1585 "cfg.y" /* yacc.c:1652  */
    {(yyval.intval)=(yyvsp[0].intval); }
#line 5700 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 320:
#line 1588 "cfg.y" /* yacc.c:1652  */
    {
				spec = (pv_spec_t*)pkg_malloc(sizeof(pv_spec_t));
				if (spec==NULL){
					yyerror("no more pkg memory\n");
					YYABORT;
				}
				memset(spec, 0, sizeof(pv_spec_t));
				tstr.s = (yyvsp[0].strval);
				tstr.len = strlen(tstr.s);
				if(pv_parse_spec(&tstr, spec)==NULL)
				{
					yyerror("unknown script variable");
				}

				(yyval.specval) = spec;
			}
#line 5721 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 321:
#line 1604 "cfg.y" /* yacc.c:1652  */
    {
			(yyval.specval)=0; yyerror("invalid script variable name");
		}
#line 5729 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 322:
#line 1609 "cfg.y" /* yacc.c:1652  */
    {(yyval.expr)=(yyvsp[0].expr); }
#line 5735 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 323:
#line 1610 "cfg.y" /* yacc.c:1652  */
    {(yyval.expr)=mk_elem( NO_OP, ACTION_O, 0, ACTIONS_ST, (yyvsp[0].action) ); }
#line 5741 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 324:
#line 1611 "cfg.y" /* yacc.c:1652  */
    {(yyval.expr)=mk_elem( NO_OP, NUMBER_O, 0, NUMBER_ST,
											(void*)(yyvsp[0].intval) ); }
#line 5748 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 325:
#line 1613 "cfg.y" /* yacc.c:1652  */
    {
				(yyval.expr)=mk_elem(NO_OP, SCRIPTVAR_O,0,SCRIPTVAR_ST,(void*)(yyvsp[0].specval));
			}
#line 5756 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 326:
#line 1618 "cfg.y" /* yacc.c:1652  */
    {
				(yyval.expr)=mk_elem( (yyvsp[-1].intval), SCRIPTVAR_O,(void*)(yyvsp[-2].specval),SCRIPTVAR_ST,(void*)(yyvsp[0].specval));
			}
#line 5764 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 327:
#line 1621 "cfg.y" /* yacc.c:1652  */
    {
				(yyval.expr)=mk_elem( (yyvsp[-1].intval), SCRIPTVAR_O,(void*)(yyvsp[-2].specval),STR_ST,(yyvsp[0].strval));
			}
#line 5772 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 328:
#line 1624 "cfg.y" /* yacc.c:1652  */
    {
				(yyval.expr)=mk_elem( (yyvsp[-1].intval), SCRIPTVAR_O,(void*)(yyvsp[-2].specval),NUMBER_ST,(void *)(yyvsp[0].intval));
			}
#line 5780 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 329:
#line 1627 "cfg.y" /* yacc.c:1652  */
    {
				(yyval.expr)=mk_elem( (yyvsp[-1].intval), SCRIPTVAR_O,(void*)(yyvsp[-2].specval), NULLV_ST, 0);
			}
#line 5788 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 330:
#line 1630 "cfg.y" /* yacc.c:1652  */
    {
				(yyval.expr)=mk_elem((yyvsp[-1].intval), SCRIPTVAR_O, (void*)(yyvsp[-2].specval), NET_ST, (yyvsp[0].ipnet));
			}
#line 5796 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 331:
#line 1636 "cfg.y" /* yacc.c:1652  */
    { (yyval.intval) = EQ_T; }
#line 5802 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 332:
#line 1637 "cfg.y" /* yacc.c:1652  */
    { (yyval.intval) = COLONEQ_T; }
#line 5808 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 333:
#line 1638 "cfg.y" /* yacc.c:1652  */
    { (yyval.intval) = PLUSEQ_T; }
#line 5814 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 334:
#line 1639 "cfg.y" /* yacc.c:1652  */
    { (yyval.intval) = MINUSEQ_T;}
#line 5820 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 335:
#line 1640 "cfg.y" /* yacc.c:1652  */
    { (yyval.intval) = DIVEQ_T; }
#line 5826 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 336:
#line 1641 "cfg.y" /* yacc.c:1652  */
    { (yyval.intval) = MULTEQ_T; }
#line 5832 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 337:
#line 1642 "cfg.y" /* yacc.c:1652  */
    { (yyval.intval) = MODULOEQ_T; }
#line 5838 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 338:
#line 1643 "cfg.y" /* yacc.c:1652  */
    { (yyval.intval) = BANDEQ_T; }
#line 5844 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 339:
#line 1644 "cfg.y" /* yacc.c:1652  */
    { (yyval.intval) = BOREQ_T; }
#line 5850 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 340:
#line 1645 "cfg.y" /* yacc.c:1652  */
    { (yyval.intval) = BXOREQ_T; }
#line 5856 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 341:
#line 1649 "cfg.y" /* yacc.c:1652  */
    { (yyval.expr) = mk_elem(VALUE_OP, NUMBERV_O, (void*)(yyvsp[0].intval), 0, 0); }
#line 5862 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 342:
#line 1650 "cfg.y" /* yacc.c:1652  */
    { (yyval.expr) = mk_elem(VALUE_OP, STRINGV_O, (yyvsp[0].strval), 0, 0); }
#line 5868 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 343:
#line 1651 "cfg.y" /* yacc.c:1652  */
    { (yyval.expr) = mk_elem(VALUE_OP, SCRIPTVAR_O, (yyvsp[0].specval), 0, 0); }
#line 5874 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 344:
#line 1652 "cfg.y" /* yacc.c:1652  */
    { (yyval.expr)= (yyvsp[0].expr); }
#line 5880 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 345:
#line 1653 "cfg.y" /* yacc.c:1652  */
    { (yyval.expr)=mk_elem( NO_OP, ACTION_O, 0, ACTIONS_ST, (yyvsp[0].action) ); }
#line 5886 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 346:
#line 1654 "cfg.y" /* yacc.c:1652  */
    {
				(yyval.expr) = mk_elem(PLUS_OP, EXPR_O, (yyvsp[-2].expr), EXPR_ST, (yyvsp[0].expr));
			}
#line 5894 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 347:
#line 1657 "cfg.y" /* yacc.c:1652  */
    {
				(yyval.expr) = mk_elem(MINUS_OP, EXPR_O, (yyvsp[-2].expr), EXPR_ST, (yyvsp[0].expr));
			}
#line 5902 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 348:
#line 1660 "cfg.y" /* yacc.c:1652  */
    {
				(yyval.expr) = mk_elem(MULT_OP, EXPR_O, (yyvsp[-2].expr), EXPR_ST, (yyvsp[0].expr));
			}
#line 5910 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 349:
#line 1663 "cfg.y" /* yacc.c:1652  */
    {
				(yyval.expr) = mk_elem(DIV_OP, EXPR_O, (yyvsp[-2].expr), EXPR_ST, (yyvsp[0].expr));
			}
#line 5918 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 350:
#line 1666 "cfg.y" /* yacc.c:1652  */
    {
				(yyval.expr) = mk_elem(MODULO_OP, EXPR_O, (yyvsp[-2].expr), EXPR_ST, (yyvsp[0].expr));
			}
#line 5926 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 351:
#line 1669 "cfg.y" /* yacc.c:1652  */
    {
				(yyval.expr) = mk_elem(BAND_OP, EXPR_O, (yyvsp[-2].expr), EXPR_ST, (yyvsp[0].expr));
			}
#line 5934 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 352:
#line 1672 "cfg.y" /* yacc.c:1652  */
    {
				(yyval.expr) = mk_elem(BOR_OP, EXPR_O, (yyvsp[-2].expr), EXPR_ST, (yyvsp[0].expr));
			}
#line 5942 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 353:
#line 1675 "cfg.y" /* yacc.c:1652  */
    {
				(yyval.expr) = mk_elem(BXOR_OP, EXPR_O, (yyvsp[-2].expr), EXPR_ST, (yyvsp[0].expr));
			}
#line 5950 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 354:
#line 1678 "cfg.y" /* yacc.c:1652  */
    {
				(yyval.expr) = mk_elem(BLSHIFT_OP, EXPR_O, (yyvsp[-2].expr), EXPR_ST, (yyvsp[0].expr));
			}
#line 5958 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 355:
#line 1681 "cfg.y" /* yacc.c:1652  */
    {
				(yyval.expr) = mk_elem(BRSHIFT_OP, EXPR_O, (yyvsp[-2].expr), EXPR_ST, (yyvsp[0].expr));
			}
#line 5966 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 356:
#line 1684 "cfg.y" /* yacc.c:1652  */
    {
				(yyval.expr) = mk_elem(BNOT_OP, EXPR_O, (yyvsp[0].expr), 0, 0);
			}
#line 5974 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 357:
#line 1687 "cfg.y" /* yacc.c:1652  */
    { (yyval.expr) = (yyvsp[-1].expr); }
#line 5980 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 358:
#line 1690 "cfg.y" /* yacc.c:1652  */
    {
			if(!pv_is_w((yyvsp[-2].specval)))
				yyerror("invalid left operand in assignment");
			if((yyvsp[-2].specval)->trans!=0)
				yyerror("transformations not accepted in left side "
					"of assignment");

			mk_action2( (yyval.action), (yyvsp[-1].intval),
					SCRIPTVAR_ST,
					EXPR_ST,
					(yyvsp[-2].specval),
					(yyvsp[0].expr));
		}
#line 5998 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 359:
#line 1703 "cfg.y" /* yacc.c:1652  */
    {
			if(!pv_is_w((yyvsp[-2].specval)))
				yyerror("invalid left operand in assignment");
			if((yyvsp[-2].specval)->trans!=0)
				yyerror("transformations not accepted in left side "
					"of assignment");

			mk_action2( (yyval.action), EQ_T,
					SCRIPTVAR_ST,
					NULLV_ST,
					(yyvsp[-2].specval),
					0);
		}
#line 6016 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 360:
#line 1716 "cfg.y" /* yacc.c:1652  */
    {
			if(!pv_is_w((yyvsp[-2].specval)))
				yyerror("invalid left operand in assignment");
			/* not all can get NULL with := */
			switch((yyvsp[-2].specval)->type) {
				case PVT_AVP:
				break;
				default:
					yyerror("invalid left operand in NULL assignment");
			}
			if((yyvsp[-2].specval)->trans!=0)
				yyerror("transformations not accepted in left side "
					"of assignment");

			mk_action2( (yyval.action), COLONEQ_T,
					SCRIPTVAR_ST,
					NULLV_ST,
					(yyvsp[-2].specval),
					0);
		}
#line 6041 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 361:
#line 1738 "cfg.y" /* yacc.c:1652  */
    { (yyval.action)=(yyvsp[0].action); }
#line 6047 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 362:
#line 1739 "cfg.y" /* yacc.c:1652  */
    { (yyval.action)=(yyvsp[0].action); }
#line 6053 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 363:
#line 1740 "cfg.y" /* yacc.c:1652  */
    { (yyval.action)=(yyvsp[0].action); }
#line 6059 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 364:
#line 1741 "cfg.y" /* yacc.c:1652  */
    { (yyval.action)=(yyvsp[-1].action); }
#line 6065 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 365:
#line 1742 "cfg.y" /* yacc.c:1652  */
    { (yyval.action)=0; }
#line 6071 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 366:
#line 1745 "cfg.y" /* yacc.c:1652  */
    { (yyval.action)=(yyvsp[0].action); }
#line 6077 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 367:
#line 1746 "cfg.y" /* yacc.c:1652  */
    { (yyval.action)=(yyvsp[-1].action); }
#line 6083 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 368:
#line 1747 "cfg.y" /* yacc.c:1652  */
    { (yyval.action)=0; }
#line 6089 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 369:
#line 1750 "cfg.y" /* yacc.c:1652  */
    {(yyval.action)=append_action((yyvsp[-1].action), (yyvsp[0].action)); }
#line 6095 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 370:
#line 1751 "cfg.y" /* yacc.c:1652  */
    {(yyval.action)=(yyvsp[0].action);}
#line 6101 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 371:
#line 1752 "cfg.y" /* yacc.c:1652  */
    { (yyval.action)=0; yyerror("bad command!)"); }
#line 6107 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 372:
#line 1755 "cfg.y" /* yacc.c:1652  */
    {(yyval.action)=(yyvsp[-1].action);}
#line 6113 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 373:
#line 1756 "cfg.y" /* yacc.c:1652  */
    {(yyval.action)=(yyvsp[0].action);}
#line 6119 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 374:
#line 1757 "cfg.y" /* yacc.c:1652  */
    { (yyval.action)=(yyvsp[0].action);}
#line 6125 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 375:
#line 1758 "cfg.y" /* yacc.c:1652  */
    { (yyval.action)=(yyvsp[0].action);}
#line 6131 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 376:
#line 1759 "cfg.y" /* yacc.c:1652  */
    {(yyval.action)=(yyvsp[0].action);}
#line 6137 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 377:
#line 1760 "cfg.y" /* yacc.c:1652  */
    {(yyval.action)=(yyvsp[-1].action);}
#line 6143 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 378:
#line 1761 "cfg.y" /* yacc.c:1652  */
    {(yyval.action)=0;}
#line 6149 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 379:
#line 1762 "cfg.y" /* yacc.c:1652  */
    { (yyval.action)=0; yyerror("bad command: missing ';'?"); }
#line 6155 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 380:
#line 1765 "cfg.y" /* yacc.c:1652  */
    { mk_action3( (yyval.action), IF_T,
													 EXPR_ST,
													 ACTIONS_ST,
													 NOSUBTYPE,
													 (yyvsp[-1].expr),
													 (yyvsp[0].action),
													 0);
									}
#line 6168 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 381:
#line 1773 "cfg.y" /* yacc.c:1652  */
    { mk_action3( (yyval.action), IF_T,
													 EXPR_ST,
													 ACTIONS_ST,
													 ACTIONS_ST,
													 (yyvsp[-3].expr),
													 (yyvsp[-2].action),
													 (yyvsp[0].action));
									}
#line 6181 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 382:
#line 1783 "cfg.y" /* yacc.c:1652  */
    { mk_action2( (yyval.action), WHILE_T,
													 EXPR_ST,
													 ACTIONS_ST,
													 (yyvsp[-1].expr),
													 (yyvsp[0].action));
									}
#line 6192 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 383:
#line 1791 "cfg.y" /* yacc.c:1652  */
    {
					if ((yyvsp[-4].specval)->type != PVT_SCRIPTVAR &&
					    (yyvsp[-4].specval)->type != PVT_AVP &&
						pv_type((yyvsp[-4].specval)->type) != PVT_JSON) {
						yyerror("\nfor-each statement: only \"var\", \"avp\" "
					            "and \"json\" iterators are supported!");
					}

					mk_action3( (yyval.action), FOR_EACH_T,
					            SCRIPTVAR_ST,
					            SCRIPTVAR_ST,
					            ACTIONS_ST,
					            (yyvsp[-4].specval),
					            (yyvsp[-2].specval),
					            (yyvsp[0].action));
					}
#line 6213 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 384:
#line 1809 "cfg.y" /* yacc.c:1652  */
    {
											mk_action2( (yyval.action), SWITCH_T,
														SCRIPTVAR_ST,
														ACTIONS_ST,
														(yyvsp[-4].specval),
														(yyvsp[-1].action));
									}
#line 6225 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 385:
#line 1818 "cfg.y" /* yacc.c:1652  */
    { (yyval.action)=append_action((yyvsp[-1].action), (yyvsp[0].action)); }
#line 6231 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 386:
#line 1819 "cfg.y" /* yacc.c:1652  */
    { (yyval.action)=(yyvsp[0].action); }
#line 6237 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 387:
#line 1821 "cfg.y" /* yacc.c:1652  */
    {(yyval.action)=append_action((yyvsp[-1].action), (yyvsp[0].action)); }
#line 6243 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 388:
#line 1822 "cfg.y" /* yacc.c:1652  */
    {(yyval.action)=(yyvsp[0].action);}
#line 6249 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 389:
#line 1826 "cfg.y" /* yacc.c:1652  */
    { mk_action3( (yyval.action), CASE_T,
													NUMBER_ST,
													ACTIONS_ST,
													NUMBER_ST,
													(void*)(yyvsp[-4].intval),
													(yyvsp[-2].action),
													(void*)1);
											}
#line 6262 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 390:
#line 1835 "cfg.y" /* yacc.c:1652  */
    { mk_action3( (yyval.action), CASE_T,
													NUMBER_ST,
													ACTIONS_ST,
													NUMBER_ST,
													(void*)(yyvsp[-3].intval),
													0,
													(void*)1);
											}
#line 6275 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 391:
#line 1843 "cfg.y" /* yacc.c:1652  */
    { mk_action3( (yyval.action), CASE_T,
													NUMBER_ST,
													ACTIONS_ST,
													NUMBER_ST,
													(void*)(yyvsp[-2].intval),
													(yyvsp[0].action),
													(void*)0);
									}
#line 6288 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 392:
#line 1851 "cfg.y" /* yacc.c:1652  */
    { mk_action3( (yyval.action), CASE_T,
													NUMBER_ST,
													ACTIONS_ST,
													NUMBER_ST,
													(void*)(yyvsp[-1].intval),
													0,
													(void*)0);
							}
#line 6301 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 393:
#line 1860 "cfg.y" /* yacc.c:1652  */
    { mk_action3( (yyval.action), CASE_T,
													STR_ST,
													ACTIONS_ST,
													NUMBER_ST,
													(void*)(yyvsp[-4].strval),
													(yyvsp[-2].action),
													(void*)1);
											}
#line 6314 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 394:
#line 1869 "cfg.y" /* yacc.c:1652  */
    { mk_action3( (yyval.action), CASE_T,
													STR_ST,
													ACTIONS_ST,
													NUMBER_ST,
													(void*)(yyvsp[-3].strval),
													0,
													(void*)1);
											}
#line 6327 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 395:
#line 1877 "cfg.y" /* yacc.c:1652  */
    { mk_action3( (yyval.action), CASE_T,
													STR_ST,
													ACTIONS_ST,
													NUMBER_ST,
													(void*)(yyvsp[-2].strval),
													(yyvsp[0].action),
													(void*)0);
									}
#line 6340 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 396:
#line 1885 "cfg.y" /* yacc.c:1652  */
    { mk_action3( (yyval.action), CASE_T,
													STR_ST,
													ACTIONS_ST,
													NUMBER_ST,
													(void*)(yyvsp[-1].strval),
													0,
													(void*)0);
							}
#line 6353 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 397:
#line 1896 "cfg.y" /* yacc.c:1652  */
    { mk_action2( (yyval.action), DEFAULT_T,
													ACTIONS_ST,
													0,
													(yyvsp[0].action),
													0);
									}
#line 6364 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 398:
#line 1902 "cfg.y" /* yacc.c:1652  */
    { mk_action2( (yyval.action), DEFAULT_T,
													ACTIONS_ST,
													0,
													0,
													0);
									}
#line 6375 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 399:
#line 1910 "cfg.y" /* yacc.c:1652  */
    {
										elems[1].type = STR_ST;
										elems[1].u.data = (yyvsp[0].strval);
										(yyval.intval)=1;
										}
#line 6385 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 400:
#line 1915 "cfg.y" /* yacc.c:1652  */
    {
										if ((yyvsp[-2].intval)+1>=MAX_ACTION_ELEMS) {
											yyerror("too many arguments "
												"in function\n");
											(yyval.intval)=0;
										}
										elems[(yyvsp[-2].intval)+1].type = STR_ST;
										elems[(yyvsp[-2].intval)+1].u.data = (yyvsp[0].strval);
										(yyval.intval)=(yyvsp[-2].intval)+1;
										}
#line 6400 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 401:
#line 1925 "cfg.y" /* yacc.c:1652  */
    {
										elems[1].type = NULLV_ST;
										elems[1].u.data = NULL;
										elems[2].type = NULLV_ST;
										elems[2].u.data = NULL;
										(yyval.intval)=2;
										}
#line 6412 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 402:
#line 1932 "cfg.y" /* yacc.c:1652  */
    {
										elems[1].type = NULLV_ST;
										elems[1].u.data = NULL;
										elems[2].type = STR_ST;
										elems[2].u.data = (yyvsp[0].strval);
										(yyval.intval)=2;
										}
#line 6424 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 403:
#line 1939 "cfg.y" /* yacc.c:1652  */
    {
										if ((yyvsp[-1].intval)+1>=MAX_ACTION_ELEMS) {
											yyerror("too many arguments "
												"in function\n");
											(yyval.intval)=0;
										}
										elems[(yyvsp[-1].intval)+1].type = NULLV_ST;
										elems[(yyvsp[-1].intval)+1].u.data = NULL;
										(yyval.intval)=(yyvsp[-1].intval)+1;
										}
#line 6439 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 404:
#line 1949 "cfg.y" /* yacc.c:1652  */
    {
										elems[1].type = NUMBER_ST;
										elems[1].u.number = (yyvsp[0].intval);
										(yyval.intval)=1;
										}
#line 6449 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 405:
#line 1954 "cfg.y" /* yacc.c:1652  */
    {
										elems[1].type = NULLV_ST;
										elems[1].u.data = NULL;
										elems[2].type = NUMBER_ST;
										elems[2].u.number = (yyvsp[0].intval);
										(yyval.intval)=2;
										}
#line 6461 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 406:
#line 1961 "cfg.y" /* yacc.c:1652  */
    {
										if ((yyvsp[-2].intval)+1>=MAX_ACTION_ELEMS) {
											yyerror("too many arguments "
												"in function\n");
											(yyval.intval)=0;
										}
										elems[(yyvsp[-2].intval)+1].type = NUMBER_ST;
										elems[(yyvsp[-2].intval)+1].u.number = (yyvsp[0].intval);
										(yyval.intval)=(yyvsp[-2].intval)+1;
										}
#line 6476 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 407:
#line 1971 "cfg.y" /* yacc.c:1652  */
    {
										elems[1].type = SCRIPTVAR_ST;
										elems[1].u.data = (yyvsp[0].specval);
										(yyval.intval)=1;
										}
#line 6486 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 408:
#line 1976 "cfg.y" /* yacc.c:1652  */
    {
										elems[1].type = NULLV_ST;
										elems[1].u.data = NULL;
										elems[2].type = SCRIPTVAR_ST;
										elems[2].u.data = (yyvsp[0].specval);
										(yyval.intval)=2;
										}
#line 6498 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 409:
#line 1983 "cfg.y" /* yacc.c:1652  */
    {
										if ((yyvsp[-2].intval)+1>=MAX_ACTION_ELEMS) {
											yyerror("too many arguments "
												"in function\n");
											(yyval.intval)=0;
										}
										elems[(yyvsp[-2].intval)+1].type = SCRIPTVAR_ST;
										elems[(yyvsp[-2].intval)+1].u.data = (yyvsp[0].specval);
										(yyval.intval)=(yyvsp[-2].intval)+1;
										}
#line 6513 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 410:
#line 1995 "cfg.y" /* yacc.c:1652  */
    {
						route_elems[0].type = STRING_ST;
						route_elems[0].u.data = (yyvsp[0].strval);
						(yyval.intval)=1;
			}
#line 6523 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 411:
#line 2000 "cfg.y" /* yacc.c:1652  */
    {
						route_elems[0].type = NUMBER_ST;
						route_elems[0].u.data = (void*)(long)(yyvsp[0].intval);
						(yyval.intval)=1;
			}
#line 6533 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 412:
#line 2005 "cfg.y" /* yacc.c:1652  */
    {
						route_elems[0].type = NULLV_ST;
						route_elems[0].u.data = 0;
						(yyval.intval)=1;
			}
#line 6543 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 413:
#line 2010 "cfg.y" /* yacc.c:1652  */
    {
						route_elems[0].type = SCRIPTVAR_ST;
						route_elems[0].u.data = (yyvsp[0].specval);
						(yyval.intval)=1;
			}
#line 6553 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 414:
#line 2015 "cfg.y" /* yacc.c:1652  */
    {
						if ((yyvsp[-2].intval)>=MAX_ACTION_ELEMS) {
							yyerror("too many arguments in function\n");
							(yyval.intval)=-1;
						} else {
							route_elems[(yyvsp[-2].intval)].type = STRING_ST;
							route_elems[(yyvsp[-2].intval)].u.data = (yyvsp[0].strval);
							(yyval.intval)=(yyvsp[-2].intval)+1;
						}
			}
#line 6568 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 415:
#line 2025 "cfg.y" /* yacc.c:1652  */
    {
						if ((yyvsp[-2].intval)>=MAX_ACTION_ELEMS) {
							yyerror("too many arguments in function\n");
							(yyval.intval)=-1;
						} else {
							route_elems[(yyvsp[-2].intval)].type = NUMBER_ST;
							route_elems[(yyvsp[-2].intval)].u.data = (void*)(long)(yyvsp[0].intval);
							(yyval.intval)=(yyvsp[-2].intval)+1;
						}
			}
#line 6583 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 416:
#line 2035 "cfg.y" /* yacc.c:1652  */
    {
						if ((yyvsp[-2].intval)+1>=MAX_ACTION_ELEMS) {
							yyerror("too many arguments in function\n");
							(yyval.intval)=-1;
						} else {
							route_elems[(yyvsp[-2].intval)].type = SCRIPTVAR_ST;
							route_elems[(yyvsp[-2].intval)].u.data = (yyvsp[0].specval);
							(yyval.intval)=(yyvsp[-2].intval)+1;
						}
			}
#line 6598 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 417:
#line 2045 "cfg.y" /* yacc.c:1652  */
    {
						if ((yyvsp[-2].intval)+1>=MAX_ACTION_ELEMS) {
							yyerror("too many arguments in function\n");
							(yyval.intval)=-1;
						} else {
							route_elems[(yyvsp[-2].intval)].type = NULLV_ST;
							route_elems[(yyvsp[-2].intval)].u.data = 0;
							(yyval.intval)=(yyvsp[-2].intval)+1;
						}
			}
#line 6613 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 418:
#line 2057 "cfg.y" /* yacc.c:1652  */
    {
				cmd_tmp=(void*)find_acmd_export_t((yyvsp[-2].strval));
				if (cmd_tmp==0){
					yyerrorf("unknown async command <%s>, "
						"missing loadmodule?", (yyvsp[-2].strval));
					(yyval.action)=0;
				}else{
					if (check_acmd_call_params(cmd_tmp,elems,0)<0) {
						yyerrorf("too few parameters "
							"for command <%s>\n", (yyvsp[-2].strval));
						(yyval.action)=0;
					} else {
						elems[0].type = ACMD_ST;
						elems[0].u.data = cmd_tmp;
						mk_action_((yyval.action), AMODULE_T, 1, elems);
					}
				}
			}
#line 6636 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 419:
#line 2075 "cfg.y" /* yacc.c:1652  */
    {
				cmd_tmp=(void*)find_acmd_export_t((yyvsp[-3].strval));
				if (cmd_tmp==0){
					yyerrorf("unknown async command <%s>, "
						"missing loadmodule?", (yyvsp[-3].strval));
					(yyval.action)=0;
				}else{
					rc = check_acmd_call_params(cmd_tmp,elems,(yyvsp[-1].intval));
					switch (rc) {
					case -1:
						yyerrorf("too few parameters "
							"for async command <%s>\n", (yyvsp[-3].strval));
						(yyval.action)=0;
						break;
					case -2:
						yyerrorf("too many parameters "
							"for async command <%s>\n", (yyvsp[-3].strval));
						(yyval.action)=0;
						break;
					case -3:
						yyerrorf("mandatory parameter "
							" omitted for async command <%s>\n", (yyvsp[-3].strval));
						(yyval.action)=0;
						break;
					default:
						elems[0].type = ACMD_ST;
						elems[0].u.data = cmd_tmp;
						mk_action_((yyval.action), AMODULE_T, (yyvsp[-1].intval)+1, elems);
					}
				}
			}
#line 6672 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 420:
#line 2106 "cfg.y" /* yacc.c:1652  */
    {
				(yyval.action)=0;
				yyerrorf("bad arguments for command <%s>", (yyvsp[-3].strval));
			}
#line 6681 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 421:
#line 2110 "cfg.y" /* yacc.c:1652  */
    {
				(yyval.action)=0;
				yyerrorf("bare word <%s> found, command calls need '()'", (yyvsp[-1].strval));
			}
#line 6690 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 422:
#line 2116 "cfg.y" /* yacc.c:1652  */
    { mk_action2( (yyval.action), FORWARD_T,
											STRING_ST,
											0,
											(yyvsp[-1].strval),
											0);
										}
#line 6701 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 423:
#line 2122 "cfg.y" /* yacc.c:1652  */
    {
										mk_action2( (yyval.action), FORWARD_T,
											0,
											0,
											0,
											0);
										}
#line 6713 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 424:
#line 2129 "cfg.y" /* yacc.c:1652  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 6719 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 425:
#line 2130 "cfg.y" /* yacc.c:1652  */
    { (yyval.action)=0; yyerror("bad forward "
										"argument"); }
#line 6726 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 426:
#line 2133 "cfg.y" /* yacc.c:1652  */
    { mk_action2( (yyval.action), SEND_T,
											STRING_ST,
											0,
											(yyvsp[-1].strval),
											0);
										}
#line 6737 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 427:
#line 2139 "cfg.y" /* yacc.c:1652  */
    { mk_action2( (yyval.action), SEND_T,
											STRING_ST,
											STRING_ST,
											(yyvsp[-3].strval),
											(yyvsp[-1].strval));
										}
#line 6748 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 428:
#line 2145 "cfg.y" /* yacc.c:1652  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 6754 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 429:
#line 2146 "cfg.y" /* yacc.c:1652  */
    { (yyval.action)=0; yyerror("bad send"
													"argument"); }
#line 6761 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 430:
#line 2148 "cfg.y" /* yacc.c:1652  */
    {
			mk_action2( (yyval.action), ASSERT_T, EXPR_ST, STRING_ST, (yyvsp[-3].expr), (yyvsp[-1].strval));
			}
#line 6769 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 431:
#line 2151 "cfg.y" /* yacc.c:1652  */
    {mk_action2( (yyval.action), DROP_T,0, 0, 0, 0); }
#line 6775 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 432:
#line 2152 "cfg.y" /* yacc.c:1652  */
    {mk_action2( (yyval.action), DROP_T,0, 0, 0, 0); }
#line 6781 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 433:
#line 2153 "cfg.y" /* yacc.c:1652  */
    {mk_action2( (yyval.action), EXIT_T,0, 0, 0, 0); }
#line 6787 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 434:
#line 2154 "cfg.y" /* yacc.c:1652  */
    {mk_action2( (yyval.action), EXIT_T,0, 0, 0, 0); }
#line 6793 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 435:
#line 2155 "cfg.y" /* yacc.c:1652  */
    {mk_action2( (yyval.action), RETURN_T,
																NUMBER_ST,
																0,
																(void*)(yyvsp[-1].intval),
																0);
												}
#line 6804 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 436:
#line 2161 "cfg.y" /* yacc.c:1652  */
    {mk_action2( (yyval.action), RETURN_T,
																SCRIPTVAR_ST,
																0,
																(void*)(yyvsp[-1].specval),
																0);
												}
#line 6815 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 437:
#line 2167 "cfg.y" /* yacc.c:1652  */
    {mk_action2( (yyval.action), RETURN_T,
																NUMBER_ST,
																0,
																(void*)1,
																0);
												}
#line 6826 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 438:
#line 2173 "cfg.y" /* yacc.c:1652  */
    {mk_action2( (yyval.action), RETURN_T,
																NUMBER_ST,
																0,
																(void*)1,
																0);
												}
#line 6837 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 439:
#line 2179 "cfg.y" /* yacc.c:1652  */
    {mk_action2( (yyval.action), LOG_T, NUMBER_ST,
													STRING_ST,(void*)4,(yyvsp[-1].strval));
									}
#line 6845 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 440:
#line 2182 "cfg.y" /* yacc.c:1652  */
    {mk_action2( (yyval.action), LOG_T,
																NUMBER_ST,
																STRING_ST,
																(void*)(yyvsp[-3].intval),
																(yyvsp[-1].strval));
												}
#line 6856 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 441:
#line 2188 "cfg.y" /* yacc.c:1652  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 6862 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 442:
#line 2189 "cfg.y" /* yacc.c:1652  */
    { (yyval.action)=0; yyerror("bad log"
									"argument"); }
#line 6869 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 443:
#line 2191 "cfg.y" /* yacc.c:1652  */
    {
			mk_action2((yyval.action), SETFLAG_T, NUMBER_ST, 0, (void *)(yyvsp[-1].intval), 0 );
			}
#line 6877 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 444:
#line 2194 "cfg.y" /* yacc.c:1652  */
    {mk_action2((yyval.action), SETFLAG_T, STR_ST, 0,
													(void *)(yyvsp[-1].strval), 0 ); }
#line 6884 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 445:
#line 2196 "cfg.y" /* yacc.c:1652  */
    { (yyval.action)=0; yyerror("missing '(' or ')'?"); }
#line 6890 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 446:
#line 2197 "cfg.y" /* yacc.c:1652  */
    {mk_action2( (yyval.action), RESETFLAG_T,
										NUMBER_ST, 0, (void *)(yyvsp[-1].intval), 0 ); }
#line 6897 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 447:
#line 2199 "cfg.y" /* yacc.c:1652  */
    {mk_action2( (yyval.action), RESETFLAG_T,
										STR_ST, 0, (void *)(yyvsp[-1].strval), 0 ); }
#line 6904 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 448:
#line 2201 "cfg.y" /* yacc.c:1652  */
    { (yyval.action)=0; yyerror("missing '(' or ')'?"); }
#line 6910 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 449:
#line 2202 "cfg.y" /* yacc.c:1652  */
    {mk_action2( (yyval.action), ISFLAGSET_T,
										NUMBER_ST, 0, (void *)(yyvsp[-1].intval), 0 ); }
#line 6917 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 450:
#line 2204 "cfg.y" /* yacc.c:1652  */
    {mk_action2( (yyval.action), ISFLAGSET_T,
										STR_ST, 0, (void *)(yyvsp[-1].strval), 0 ); }
#line 6924 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 451:
#line 2206 "cfg.y" /* yacc.c:1652  */
    { (yyval.action)=0; yyerror("missing '(' or ')'?"); }
#line 6930 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 452:
#line 2207 "cfg.y" /* yacc.c:1652  */
    {mk_action2( (yyval.action),
													SETBFLAG_T,
													NUMBER_ST, NUMBER_ST,
													(void *)(yyvsp[-3].intval), (void *)(yyvsp[-1].intval) ); }
#line 6939 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 453:
#line 2211 "cfg.y" /* yacc.c:1652  */
    {mk_action2( (yyval.action),
													SETBFLAG_T,
													NUMBER_ST, STR_ST,
													(void *)(yyvsp[-3].intval), (void *)(yyvsp[-1].strval) ); }
#line 6948 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 454:
#line 2215 "cfg.y" /* yacc.c:1652  */
    {mk_action2( (yyval.action), SETBFLAG_T,
													NUMBER_ST, NUMBER_ST,
													0, (void *)(yyvsp[-1].intval) ); }
#line 6956 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 455:
#line 2218 "cfg.y" /* yacc.c:1652  */
    {mk_action2( (yyval.action), SETBFLAG_T,
													NUMBER_ST, STR_ST,
													0, (void *)(yyvsp[-1].strval) ); }
#line 6964 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 456:
#line 2221 "cfg.y" /* yacc.c:1652  */
    { (yyval.action)=0; yyerror("missing '(' or ')'?"); }
#line 6970 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 457:
#line 2222 "cfg.y" /* yacc.c:1652  */
    {mk_action2( (yyval.action),
													RESETBFLAG_T,
													NUMBER_ST, NUMBER_ST,
													(void *)(yyvsp[-3].intval), (void *)(yyvsp[-1].intval) ); }
#line 6979 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 458:
#line 2226 "cfg.y" /* yacc.c:1652  */
    {mk_action2( (yyval.action),
													RESETBFLAG_T,
													NUMBER_ST, STR_ST,
													(void *)(yyvsp[-3].intval), (void *)(yyvsp[-1].strval) ); }
#line 6988 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 459:
#line 2230 "cfg.y" /* yacc.c:1652  */
    {mk_action2( (yyval.action),
													RESETBFLAG_T,
													NUMBER_ST, NUMBER_ST,
													0, (void *)(yyvsp[-1].intval) ); }
#line 6997 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 460:
#line 2234 "cfg.y" /* yacc.c:1652  */
    {mk_action2( (yyval.action),
													RESETBFLAG_T,
													NUMBER_ST, STR_ST,
													0, (void *)(yyvsp[-1].strval) ); }
#line 7006 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 461:
#line 2238 "cfg.y" /* yacc.c:1652  */
    { (yyval.action)=0; yyerror("missing '(' or ')'?"); }
#line 7012 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 462:
#line 2239 "cfg.y" /* yacc.c:1652  */
    {mk_action2( (yyval.action),
													ISBFLAGSET_T,
													NUMBER_ST, NUMBER_ST,
													(void *)(yyvsp[-3].intval), (void *)(yyvsp[-1].intval) ); }
#line 7021 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 463:
#line 2243 "cfg.y" /* yacc.c:1652  */
    {mk_action2( (yyval.action),
													ISBFLAGSET_T,
													NUMBER_ST, STR_ST,
													(void *)(yyvsp[-3].intval), (void *)(yyvsp[-1].strval) ); }
#line 7030 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 464:
#line 2247 "cfg.y" /* yacc.c:1652  */
    {mk_action2( (yyval.action),
													ISBFLAGSET_T,
													NUMBER_ST, NUMBER_ST,
													0, (void *)(yyvsp[-1].intval) ); }
#line 7039 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 465:
#line 2251 "cfg.y" /* yacc.c:1652  */
    {mk_action2( (yyval.action),
													ISBFLAGSET_T,
													NUMBER_ST, STR_ST,
													0, (void *)(yyvsp[-1].strval) ); }
#line 7048 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 466:
#line 2255 "cfg.y" /* yacc.c:1652  */
    { (yyval.action)=0; yyerror("missing '(' or ')'?"); }
#line 7054 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 467:
#line 2256 "cfg.y" /* yacc.c:1652  */
    {mk_action2( (yyval.action), ERROR_T,
																STRING_ST,
																STRING_ST,
																(yyvsp[-3].strval),
																(yyvsp[-1].strval));
												  }
#line 7065 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 468:
#line 2262 "cfg.y" /* yacc.c:1652  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 7071 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 469:
#line 2263 "cfg.y" /* yacc.c:1652  */
    { (yyval.action)=0; yyerror("bad error"
														"argument"); }
#line 7078 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 470:
#line 2265 "cfg.y" /* yacc.c:1652  */
    {
						i_tmp = get_script_route_idx( (yyvsp[-1].strval), sroutes->request,
							RT_NO, 0);
						if (i_tmp==-1) yyerror("too many script routes");
						mk_action2( (yyval.action), ROUTE_T, NUMBER_ST,
							0, (void*)(long)i_tmp, 0);
					}
#line 7090 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 471:
#line 2273 "cfg.y" /* yacc.c:1652  */
    {
						i_tmp = get_script_route_idx( (yyvsp[-3].strval), sroutes->request,
							RT_NO, 0);
						if (i_tmp==-1) yyerror("too many script routes");
						if ((yyvsp[-1].intval) <= 0) yyerror("too many route parameters");

						/* duplicate the list */
						a_tmp = pkg_malloc((yyvsp[-1].intval) * sizeof(action_elem_t));
						if (!a_tmp) {
							yyerror("no more pkg memory");
							YYABORT;
						}
						memcpy(a_tmp, route_elems, (yyvsp[-1].intval)*sizeof(action_elem_t));

						mk_action3( (yyval.action), ROUTE_T, NUMBER_ST,	/* route idx */
							NUMBER_ST,					/* number of params */
							SCRIPTVAR_ELEM_ST,			/* parameters */
							(void*)(long)i_tmp,
							(void*)(long)(yyvsp[-1].intval),
							(void*)a_tmp);
					}
#line 7116 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 472:
#line 2295 "cfg.y" /* yacc.c:1652  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 7122 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 473:
#line 2296 "cfg.y" /* yacc.c:1652  */
    { (yyval.action)=0; yyerror("bad route"
						"argument"); }
#line 7129 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 474:
#line 2298 "cfg.y" /* yacc.c:1652  */
    { mk_action2( (yyval.action), SET_HOST_T, STR_ST,
														0, (yyvsp[-1].strval), 0); }
#line 7136 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 475:
#line 2300 "cfg.y" /* yacc.c:1652  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 7142 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 476:
#line 2301 "cfg.y" /* yacc.c:1652  */
    { (yyval.action)=0; yyerror("bad argument, "
														"string expected"); }
#line 7149 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 477:
#line 2304 "cfg.y" /* yacc.c:1652  */
    { mk_action2( (yyval.action), PREFIX_T, STR_ST,
														0, (yyvsp[-1].strval), 0); }
#line 7156 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 478:
#line 2306 "cfg.y" /* yacc.c:1652  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 7162 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 479:
#line 2307 "cfg.y" /* yacc.c:1652  */
    { (yyval.action)=0; yyerror("bad argument, "
														"string expected"); }
#line 7169 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 480:
#line 2309 "cfg.y" /* yacc.c:1652  */
    { mk_action2( (yyval.action), STRIP_TAIL_T,
									NUMBER_ST, 0, (void *) (yyvsp[-1].intval), 0); }
#line 7176 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 481:
#line 2311 "cfg.y" /* yacc.c:1652  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 7182 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 482:
#line 2312 "cfg.y" /* yacc.c:1652  */
    { (yyval.action)=0; yyerror("bad argument, "
														"number expected"); }
#line 7189 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 483:
#line 2315 "cfg.y" /* yacc.c:1652  */
    { mk_action2( (yyval.action), STRIP_T, NUMBER_ST,
														0, (void *) (yyvsp[-1].intval), 0); }
#line 7196 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 484:
#line 2317 "cfg.y" /* yacc.c:1652  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 7202 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 485:
#line 2318 "cfg.y" /* yacc.c:1652  */
    { (yyval.action)=0; yyerror("bad argument, "
														"number expected"); }
#line 7209 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 486:
#line 2320 "cfg.y" /* yacc.c:1652  */
    {
			{
				qvalue_t q;

				rc = str2q(&q, (yyvsp[-1].strval), strlen((yyvsp[-1].strval)));
				if (rc < 0)
					yyerrorf("bad qvalue (%.*s): %s",
							 strlen((yyvsp[-1].strval)), (yyvsp[-1].strval), qverr2str(rc));

				mk_action2( (yyval.action), APPEND_BRANCH_T, STR_ST, NUMBER_ST, (yyvsp[-3].strval),
						(void *)(long)q);
			}
		}
#line 7227 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 487:
#line 2333 "cfg.y" /* yacc.c:1652  */
    { mk_action2( (yyval.action), APPEND_BRANCH_T,
						STR_ST, NUMBER_ST, (yyvsp[-1].strval), (void *)Q_UNSPECIFIED) ; }
#line 7234 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 488:
#line 2335 "cfg.y" /* yacc.c:1652  */
    { mk_action2( (yyval.action), APPEND_BRANCH_T,
						STR_ST, NUMBER_ST, 0, (void *)Q_UNSPECIFIED) ; }
#line 7241 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 489:
#line 2337 "cfg.y" /* yacc.c:1652  */
    { mk_action2( (yyval.action), APPEND_BRANCH_T,
						STR_ST, NUMBER_ST, 0, (void *)Q_UNSPECIFIED ) ; }
#line 7248 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 490:
#line 2339 "cfg.y" /* yacc.c:1652  */
    {
						mk_action1((yyval.action), REMOVE_BRANCH_T, NUMBER_ST, (void*)(yyvsp[-1].intval));}
#line 7255 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 491:
#line 2341 "cfg.y" /* yacc.c:1652  */
    {
						mk_action1( (yyval.action), REMOVE_BRANCH_T, SCRIPTVAR_ST, (yyvsp[-1].specval));}
#line 7262 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 492:
#line 2343 "cfg.y" /* yacc.c:1652  */
    {
				spec = (pv_spec_t*)pkg_malloc(sizeof(pv_spec_t));
				memset(spec, 0, sizeof(pv_spec_t));
				tstr.s = (yyvsp[-3].strval);
				tstr.len = strlen(tstr.s);
				if(pv_parse_spec(&tstr, spec)==NULL)
				{
					yyerror("unknown script variable in first parameter");
				}
				if(!pv_is_w(spec))
					yyerror("read-only script variable in first parameter");

				pvmodel = 0;
				tstr.s = (yyvsp[-1].strval);
				tstr.len = strlen(tstr.s);
				if(pv_parse_format(&tstr, &pvmodel)<0)
				{
					yyerror("error in second parameter");
				}

				mk_action2( (yyval.action), PV_PRINTF_T,
						SCRIPTVAR_ST, SCRIPTVAR_ELEM_ST, spec, pvmodel) ;
			}
#line 7290 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 493:
#line 2366 "cfg.y" /* yacc.c:1652  */
    {
				if(!pv_is_w((yyvsp[-3].specval)))
					yyerror("read-only script variable in first parameter");
				pvmodel = 0;
				tstr.s = (yyvsp[-1].strval);
				tstr.len = strlen(tstr.s);
				if(pv_parse_format(&tstr, &pvmodel)<0)
				{
					yyerror("error in second parameter");
				}

				mk_action2( (yyval.action), PV_PRINTF_T,
						SCRIPTVAR_ST, SCRIPTVAR_ELEM_ST, (yyvsp[-3].specval), pvmodel) ;
			}
#line 7309 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 494:
#line 2381 "cfg.y" /* yacc.c:1652  */
    { mk_action2( (yyval.action), SET_HOSTPORT_T,
														STR_ST, 0, (yyvsp[-1].strval), 0); }
#line 7316 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 495:
#line 2383 "cfg.y" /* yacc.c:1652  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 7322 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 496:
#line 2384 "cfg.y" /* yacc.c:1652  */
    { (yyval.action)=0; yyerror("bad argument,"
												" string expected"); }
#line 7329 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 497:
#line 2386 "cfg.y" /* yacc.c:1652  */
    { mk_action2( (yyval.action), SET_PORT_T, STR_ST,
														0, (yyvsp[-1].strval), 0); }
#line 7336 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 498:
#line 2388 "cfg.y" /* yacc.c:1652  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 7342 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 499:
#line 2389 "cfg.y" /* yacc.c:1652  */
    { (yyval.action)=0; yyerror("bad argument, "
														"string expected"); }
#line 7349 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 500:
#line 2391 "cfg.y" /* yacc.c:1652  */
    { mk_action2( (yyval.action), SET_USER_T,
														STR_ST, 0, (yyvsp[-1].strval), 0); }
#line 7356 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 501:
#line 2393 "cfg.y" /* yacc.c:1652  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 7362 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 502:
#line 2394 "cfg.y" /* yacc.c:1652  */
    { (yyval.action)=0; yyerror("bad argument, "
														"string expected"); }
#line 7369 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 503:
#line 2396 "cfg.y" /* yacc.c:1652  */
    { mk_action2( (yyval.action), SET_USERPASS_T,
														STR_ST, 0, (yyvsp[-1].strval), 0); }
#line 7376 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 504:
#line 2398 "cfg.y" /* yacc.c:1652  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 7382 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 505:
#line 2399 "cfg.y" /* yacc.c:1652  */
    { (yyval.action)=0; yyerror("bad argument, "
														"string expected"); }
#line 7389 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 506:
#line 2401 "cfg.y" /* yacc.c:1652  */
    { mk_action2( (yyval.action), SET_URI_T, STR_ST,
														0, (yyvsp[-1].strval), 0); }
#line 7396 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 507:
#line 2403 "cfg.y" /* yacc.c:1652  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 7402 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 508:
#line 2404 "cfg.y" /* yacc.c:1652  */
    { (yyval.action)=0; yyerror("bad argument, "
										"string expected"); }
#line 7409 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 509:
#line 2406 "cfg.y" /* yacc.c:1652  */
    { mk_action2( (yyval.action), REVERT_URI_T, 0,0,0,0); }
#line 7415 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 510:
#line 2407 "cfg.y" /* yacc.c:1652  */
    { mk_action2( (yyval.action), REVERT_URI_T, 0,0,0,0); }
#line 7421 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 511:
#line 2408 "cfg.y" /* yacc.c:1652  */
    { mk_action2( (yyval.action), SET_DSTURI_T,
													STR_ST, 0, (yyvsp[-1].strval), 0); }
#line 7428 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 512:
#line 2410 "cfg.y" /* yacc.c:1652  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 7434 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 513:
#line 2411 "cfg.y" /* yacc.c:1652  */
    { (yyval.action)=0; yyerror("bad argument, "
										"string expected"); }
#line 7441 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 514:
#line 2413 "cfg.y" /* yacc.c:1652  */
    { mk_action2( (yyval.action), RESET_DSTURI_T,
															0,0,0,0); }
#line 7448 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 515:
#line 2415 "cfg.y" /* yacc.c:1652  */
    { mk_action2( (yyval.action), RESET_DSTURI_T, 0,0,0,0); }
#line 7454 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 516:
#line 2416 "cfg.y" /* yacc.c:1652  */
    { mk_action2( (yyval.action), ISDSTURISET_T, 0,0,0,0);}
#line 7460 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 517:
#line 2417 "cfg.y" /* yacc.c:1652  */
    { mk_action2( (yyval.action), ISDSTURISET_T, 0,0,0,0); }
#line 7466 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 518:
#line 2418 "cfg.y" /* yacc.c:1652  */
    { mk_action2( (yyval.action), FORCE_RPORT_T,
															0, 0, 0, 0); }
#line 7473 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 519:
#line 2420 "cfg.y" /* yacc.c:1652  */
    { mk_action2( (yyval.action), FORCE_RPORT_T,0, 0, 0, 0); }
#line 7479 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 520:
#line 2421 "cfg.y" /* yacc.c:1652  */
    {
					mk_action2( (yyval.action), FORCE_LOCAL_RPORT_T,0, 0, 0, 0); }
#line 7486 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 521:
#line 2423 "cfg.y" /* yacc.c:1652  */
    {
					mk_action2( (yyval.action), FORCE_LOCAL_RPORT_T,0, 0, 0, 0); }
#line 7493 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 522:
#line 2425 "cfg.y" /* yacc.c:1652  */
    {
				mk_action2( (yyval.action), FORCE_TCP_ALIAS_T,NUMBER_ST, 0,
					(void*)(yyvsp[-1].intval), 0);
		}
#line 7502 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 523:
#line 2429 "cfg.y" /* yacc.c:1652  */
    {
				mk_action2( (yyval.action), FORCE_TCP_ALIAS_T,0, 0, 0, 0);
		}
#line 7510 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 524:
#line 2432 "cfg.y" /* yacc.c:1652  */
    {
				mk_action2( (yyval.action), FORCE_TCP_ALIAS_T,0, 0, 0, 0);
		}
#line 7518 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 525:
#line 2435 "cfg.y" /* yacc.c:1652  */
    {(yyval.action)=0;
					yyerror("bad argument, number expected");
					}
#line 7526 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 526:
#line 2438 "cfg.y" /* yacc.c:1652  */
    {
								mk_action2( (yyval.action), SET_ADV_ADDR_T, STR_ST,
											0, (yyvsp[-1].strval), 0);
								}
#line 7535 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 527:
#line 2442 "cfg.y" /* yacc.c:1652  */
    { (yyval.action)=0; yyerror("bad argument, "
														"string expected"); }
#line 7542 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 528:
#line 2444 "cfg.y" /* yacc.c:1652  */
    {(yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 7548 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 529:
#line 2445 "cfg.y" /* yacc.c:1652  */
    {
								tstr.s = int2str((yyvsp[-1].intval), &tstr.len);
								if (!(tmp = pkg_malloc(tstr.len + 1))) {
										LM_CRIT("out of pkg memory\n");
										(yyval.action) = 0;
										YYABORT;
								} else {
									memcpy(tmp, tstr.s, tstr.len);
									tmp[tstr.len] = '\0';
									mk_action2((yyval.action), SET_ADV_PORT_T, STR_ST,
											   0, tmp, 0);
								}
								            }
#line 7566 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 530:
#line 2458 "cfg.y" /* yacc.c:1652  */
    {
								mk_action2((yyval.action), SET_ADV_PORT_T,
										   STR_ST, NOSUBTYPE,
										   (yyvsp[-1].strval), NULL);
								}
#line 7576 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 531:
#line 2463 "cfg.y" /* yacc.c:1652  */
    { (yyval.action)=0; yyerror("bad argument "
						"(string or integer expected)"); }
#line 7583 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 532:
#line 2465 "cfg.y" /* yacc.c:1652  */
    {(yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 7589 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 533:
#line 2466 "cfg.y" /* yacc.c:1652  */
    {
								mk_action2( (yyval.action), FORCE_SEND_SOCKET_T,
									SOCKID_ST, 0, (yyvsp[-1].sockid), 0);
								}
#line 7598 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 534:
#line 2470 "cfg.y" /* yacc.c:1652  */
    { (yyval.action)=0; yyerror("bad argument,"
								" proto:host[:port] expected");
								}
#line 7606 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 535:
#line 2473 "cfg.y" /* yacc.c:1652  */
    {(yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 7612 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 536:
#line 2474 "cfg.y" /* yacc.c:1652  */
    {
								mk_action1( (yyval.action), SERIALIZE_BRANCHES_T,
									NUMBER_ST, (void*)(long)(yyvsp[-1].intval));
								}
#line 7621 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 537:
#line 2478 "cfg.y" /* yacc.c:1652  */
    {
								mk_action2( (yyval.action), SERIALIZE_BRANCHES_T,
									NUMBER_ST, NUMBER_ST,
									(void*)(long)(yyvsp[-3].intval), (void*)(long)(yyvsp[-1].intval));
								}
#line 7631 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 538:
#line 2483 "cfg.y" /* yacc.c:1652  */
    {(yyval.action)=0; yyerror("bad argument,"
								" number expected");
								}
#line 7639 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 539:
#line 2486 "cfg.y" /* yacc.c:1652  */
    {(yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 7645 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 540:
#line 2487 "cfg.y" /* yacc.c:1652  */
    {
								mk_action2( (yyval.action), NEXT_BRANCHES_T, 0, 0, 0, 0);
								}
#line 7653 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 541:
#line 2490 "cfg.y" /* yacc.c:1652  */
    {(yyval.action)=0; yyerror("no argument is"
								" expected");
								}
#line 7661 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 542:
#line 2493 "cfg.y" /* yacc.c:1652  */
    {(yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 7667 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 543:
#line 2494 "cfg.y" /* yacc.c:1652  */
    {
								mk_action2( (yyval.action), USE_BLACKLIST_T,
									STRING_ST, 0, (yyvsp[-1].strval), 0);
								}
#line 7676 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 544:
#line 2498 "cfg.y" /* yacc.c:1652  */
    {(yyval.action)=0; yyerror("bad argument,"
								" string expected");
								}
#line 7684 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 545:
#line 2501 "cfg.y" /* yacc.c:1652  */
    {(yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 7690 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 546:
#line 2502 "cfg.y" /* yacc.c:1652  */
    {
								mk_action2( (yyval.action), UNUSE_BLACKLIST_T,
									STRING_ST, 0, (yyvsp[-1].strval), 0);
								}
#line 7699 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 547:
#line 2506 "cfg.y" /* yacc.c:1652  */
    {(yyval.action)=0; yyerror("bad argument,"
								" string expected");
								}
#line 7707 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 548:
#line 2509 "cfg.y" /* yacc.c:1652  */
    {(yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 7713 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 549:
#line 2510 "cfg.y" /* yacc.c:1652  */
    {
									mk_action3( (yyval.action), CACHE_STORE_T,
													STR_ST,
													STR_ST,
													STR_ST,
													(yyvsp[-5].strval),
													(yyvsp[-3].strval),
													(yyvsp[-1].strval));
							}
#line 7727 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 550:
#line 2520 "cfg.y" /* yacc.c:1652  */
    {
								elems[0].type = STR_ST;
								elems[0].u.data = (yyvsp[-7].strval);
								elems[1].type = STR_ST;
								elems[1].u.data = (yyvsp[-5].strval);
								elems[2].type = STR_ST;
								elems[2].u.data = (yyvsp[-3].strval);
								elems[3].type = NUMBER_ST;
								elems[3].u.number = (yyvsp[-1].intval);
								mk_action_((yyval.action), CACHE_STORE_T, 4, elems);
							}
#line 7743 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 551:
#line 2532 "cfg.y" /* yacc.c:1652  */
    {
								elems[0].type = STR_ST;
								elems[0].u.data = (yyvsp[-7].strval);
								elems[1].type = STR_ST;
								elems[1].u.data = (yyvsp[-5].strval);
								elems[2].type = STR_ST;
								elems[2].u.data = (yyvsp[-3].strval);
								elems[3].type = SCRIPTVAR_ST;
								elems[3].u.data = (yyvsp[-1].specval);
								mk_action_((yyval.action), CACHE_STORE_T, 4, elems);
							}
#line 7759 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 552:
#line 2544 "cfg.y" /* yacc.c:1652  */
    {
									mk_action2( (yyval.action), CACHE_REMOVE_T,
													STR_ST,
													STR_ST,
													(yyvsp[-3].strval),
													(yyvsp[-1].strval));
							}
#line 7771 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 553:
#line 2551 "cfg.y" /* yacc.c:1652  */
    {
									mk_action3( (yyval.action), CACHE_FETCH_T,
													STR_ST,
													STR_ST,
													SCRIPTVAR_ST,
													(yyvsp[-5].strval),
													(yyvsp[-3].strval),
													(yyvsp[-1].specval));
							}
#line 7785 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 554:
#line 2560 "cfg.y" /* yacc.c:1652  */
    {
									mk_action3( (yyval.action), CACHE_COUNTER_FETCH_T,
													STR_ST,
													STR_ST,
													SCRIPTVAR_ST,
													(yyvsp[-5].strval),
													(yyvsp[-3].strval),
													(yyvsp[-1].specval));
							}
#line 7799 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 555:
#line 2569 "cfg.y" /* yacc.c:1652  */
    {
								elems[0].type = STR_ST;
								elems[0].u.data = (yyvsp[-7].strval);
								elems[1].type = STR_ST;
								elems[1].u.data = (yyvsp[-5].strval);
								elems[2].type = NUMBER_ST;
								elems[2].u.number = (yyvsp[-3].intval);
								elems[3].type = NUMBER_ST;
								elems[3].u.number = (yyvsp[-1].intval);
								mk_action_((yyval.action), CACHE_ADD_T, 4, elems);
							}
#line 7815 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 556:
#line 2580 "cfg.y" /* yacc.c:1652  */
    {
								elems[0].type = STR_ST;
								elems[0].u.data = (yyvsp[-7].strval);
								elems[1].type = STR_ST;
								elems[1].u.data = (yyvsp[-5].strval);
								elems[2].type = SCRIPTVAR_ST;
								elems[2].u.data = (yyvsp[-3].specval);
								elems[3].type = NUMBER_ST;
								elems[3].u.number = (yyvsp[-1].intval);
								mk_action_((yyval.action), CACHE_ADD_T, 4, elems);
							}
#line 7831 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 557:
#line 2591 "cfg.y" /* yacc.c:1652  */
    {
								elems[0].type = STR_ST;
								elems[0].u.data = (yyvsp[-9].strval);
								elems[1].type = STR_ST;
								elems[1].u.data = (yyvsp[-7].strval);
								elems[2].type = NUMBER_ST;
								elems[2].u.number = (yyvsp[-5].intval);
								elems[3].type = NUMBER_ST;
								elems[3].u.number = (yyvsp[-3].intval);
								elems[4].type = SCRIPTVAR_ST;
								elems[4].u.data = (yyvsp[-1].specval);
								mk_action_((yyval.action), CACHE_ADD_T, 5, elems);
							}
#line 7849 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 558:
#line 2604 "cfg.y" /* yacc.c:1652  */
    {
								elems[0].type = STR_ST;
								elems[0].u.data = (yyvsp[-9].strval);
								elems[1].type = STR_ST;
								elems[1].u.data = (yyvsp[-7].strval);
								elems[2].type = SCRIPTVAR_ST;
								elems[2].u.data = (yyvsp[-5].specval);
								elems[3].type = NUMBER_ST;
								elems[3].u.number = (yyvsp[-3].intval);
								elems[4].type = SCRIPTVAR_ST;
								elems[4].u.data = (yyvsp[-1].specval);
								mk_action_((yyval.action), CACHE_ADD_T, 5, elems);
							}
#line 7867 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 559:
#line 2617 "cfg.y" /* yacc.c:1652  */
    {
								elems[0].type = STR_ST;
								elems[0].u.data = (yyvsp[-7].strval);
								elems[1].type = STR_ST;
								elems[1].u.data = (yyvsp[-5].strval);
								elems[2].type = NUMBER_ST;
								elems[2].u.number = (yyvsp[-3].intval);
								elems[3].type = NUMBER_ST;
								elems[3].u.number = (yyvsp[-1].intval);
								mk_action_((yyval.action), CACHE_SUB_T, 4, elems);
							}
#line 7883 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 560:
#line 2628 "cfg.y" /* yacc.c:1652  */
    {
								elems[0].type = STR_ST;
								elems[0].u.data = (yyvsp[-7].strval);
								elems[1].type = STR_ST;
								elems[1].u.data = (yyvsp[-5].strval);
								elems[2].type = SCRIPTVAR_ST;
								elems[2].u.data = (yyvsp[-3].specval);
								elems[3].type = NUMBER_ST;
								elems[3].u.number = (yyvsp[-1].intval);
								mk_action_((yyval.action), CACHE_SUB_T, 4, elems);
							}
#line 7899 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 561:
#line 2639 "cfg.y" /* yacc.c:1652  */
    {
								elems[0].type = STR_ST;
								elems[0].u.data = (yyvsp[-9].strval);
								elems[1].type = STR_ST;
								elems[1].u.data = (yyvsp[-7].strval);
								elems[2].type = NUMBER_ST;
								elems[2].u.number = (yyvsp[-5].intval);
								elems[3].type = NUMBER_ST;
								elems[3].u.number = (yyvsp[-3].intval);
								elems[4].type = SCRIPTVAR_ST;
								elems[4].u.data = (yyvsp[-1].specval);
								mk_action_((yyval.action), CACHE_SUB_T, 5, elems);
							}
#line 7917 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 562:
#line 2652 "cfg.y" /* yacc.c:1652  */
    {
								elems[0].type = STR_ST;
								elems[0].u.data = (yyvsp[-9].strval);
								elems[1].type = STR_ST;
								elems[1].u.data = (yyvsp[-7].strval);
								elems[2].type = SCRIPTVAR_ST;
								elems[2].u.data = (yyvsp[-5].specval);
								elems[3].type = NUMBER_ST;
								elems[3].u.number = (yyvsp[-3].intval);
								elems[4].type = SCRIPTVAR_ST;
								elems[4].u.data = (yyvsp[-1].specval);
								mk_action_((yyval.action), CACHE_SUB_T, 5, elems);
							}
#line 7935 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 563:
#line 2665 "cfg.y" /* yacc.c:1652  */
    {
								elems[0].type = STR_ST;
								elems[0].u.data = (yyvsp[-5].strval);
								elems[1].type = STR_ST;
								elems[1].u.data = (yyvsp[-3].strval);
								elems[2].type = STR_ST;
								elems[2].u.data = (yyvsp[-1].strval);
								mk_action_((yyval.action), CACHE_RAW_QUERY_T, 3, elems);
							}
#line 7949 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 564:
#line 2674 "cfg.y" /* yacc.c:1652  */
    {
								elems[0].type = STR_ST;
								elems[0].u.data = (yyvsp[-3].strval);
								elems[1].type = STR_ST;
								elems[1].u.data = (yyvsp[-1].strval);
								mk_action_((yyval.action), CACHE_RAW_QUERY_T, 2, elems);
							}
#line 7961 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 565:
#line 2681 "cfg.y" /* yacc.c:1652  */
    {
								cmd_tmp=(void*)find_cmd_export_t((yyvsp[-2].strval), rt);
								if (cmd_tmp==0){
									if (find_cmd_export_t((yyvsp[-2].strval), 0)) {
										yyerrorf("Command <%s> cannot be "
											"used in the block\n", (yyvsp[-2].strval));
									} else {
										yyerrorf("unknown command <%s>, "
											"missing loadmodule?", (yyvsp[-2].strval));
									}
									(yyval.action)=0;
								}else{
									if (check_cmd_call_params(cmd_tmp,elems,0)<0) {
										yyerrorf("too few parameters "
											"for command <%s>\n", (yyvsp[-2].strval));
										(yyval.action)=0;
									} else {
										elems[0].type = CMD_ST;
										elems[0].u.data = cmd_tmp;
										mk_action_((yyval.action), MODULE_T, 1, elems);
									}
								}
							}
#line 7989 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 566:
#line 2704 "cfg.y" /* yacc.c:1652  */
    {
								cmd_tmp=(void*)find_cmd_export_t((yyvsp[-3].strval), rt);
								if (cmd_tmp==0){
									if (find_cmd_export_t((yyvsp[-3].strval), 0)) {
										yyerrorf("Command <%s> cannot be "
											"used in the block\n", (yyvsp[-3].strval));
									} else {
										yyerrorf("unknown command <%s>, "
											"missing loadmodule?", (yyvsp[-3].strval));
									}
									(yyval.action)=0;
								}else{
									rc = check_cmd_call_params(cmd_tmp,elems,(yyvsp[-1].intval));
									switch (rc) {
									case -1:
										yyerrorf("too few parameters "
											"for command <%s>\n", (yyvsp[-3].strval));
										(yyval.action)=0;
										break;
									case -2:
										yyerrorf("too many parameters "
											"for command <%s>\n", (yyvsp[-3].strval));
										(yyval.action)=0;
										break;
									case -3:
										yyerrorf("mandatory parameter "
											"omitted for command <%s>\n", (yyvsp[-3].strval));
										(yyval.action)=0;
										break;
									default:
										elems[0].type = CMD_ST;
										elems[0].u.data = cmd_tmp;
										mk_action_((yyval.action), MODULE_T, (yyvsp[-1].intval)+1, elems);
									}
								}
							}
#line 8030 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 567:
#line 2740 "cfg.y" /* yacc.c:1652  */
    { (yyval.action)=0; yyerrorf("bad arguments for "
												"command <%s>", (yyvsp[-3].strval)); }
#line 8037 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 568:
#line 2742 "cfg.y" /* yacc.c:1652  */
    { (yyval.action)=0;
			yyerrorf("bare word <%s> found, command calls need '()'", (yyvsp[-1].strval));
			}
#line 8045 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 569:
#line 2745 "cfg.y" /* yacc.c:1652  */
    {
				mk_action1((yyval.action), XDBG_T, STR_ST, (yyvsp[-1].strval));	}
#line 8052 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 570:
#line 2747 "cfg.y" /* yacc.c:1652  */
    {
				mk_action1((yyval.action), XDBG_T, STR_ST, (yyvsp[-1].strval));	}
#line 8059 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 571:
#line 2749 "cfg.y" /* yacc.c:1652  */
    {
				mk_action1((yyval.action), XLOG_T, STR_ST, (yyvsp[-1].strval)); }
#line 8066 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 572:
#line 2751 "cfg.y" /* yacc.c:1652  */
    {
				mk_action1((yyval.action), XLOG_T, STR_ST, (yyvsp[-1].strval)); }
#line 8073 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 573:
#line 2753 "cfg.y" /* yacc.c:1652  */
    {
				mk_action2((yyval.action), XLOG_T, STR_ST, STR_ST, (yyvsp[-3].strval), (yyvsp[-1].strval)); }
#line 8080 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 574:
#line 2755 "cfg.y" /* yacc.c:1652  */
    {
				mk_action2((yyval.action), XLOG_T, STR_ST, STR_ST, (yyvsp[-3].strval), (yyvsp[-1].strval)); }
#line 8087 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 575:
#line 2757 "cfg.y" /* yacc.c:1652  */
    {
				mk_action1((yyval.action), RAISE_EVENT_T, STR_ST, (yyvsp[-1].strval)); }
#line 8094 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 576:
#line 2759 "cfg.y" /* yacc.c:1652  */
    {
				mk_action2((yyval.action), RAISE_EVENT_T, STR_ST, SCRIPTVAR_ST, (yyvsp[-3].strval), (yyvsp[-1].specval)); }
#line 8101 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 577:
#line 2761 "cfg.y" /* yacc.c:1652  */
    {
				mk_action3((yyval.action), RAISE_EVENT_T, STR_ST, SCRIPTVAR_ST,
					SCRIPTVAR_ST, (yyvsp[-5].strval), (yyvsp[-3].specval), (yyvsp[-1].specval)); }
#line 8109 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 578:
#line 2764 "cfg.y" /* yacc.c:1652  */
    {
				mk_action2((yyval.action), SUBSCRIBE_EVENT_T, STR_ST, STR_ST, (yyvsp[-3].strval), (yyvsp[-1].strval)); }
#line 8116 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 579:
#line 2766 "cfg.y" /* yacc.c:1652  */
    {
				mk_action3((yyval.action), SUBSCRIBE_EVENT_T, STR_ST, STR_ST,
					NUMBER_ST, (yyvsp[-5].strval), (yyvsp[-3].strval), (void*)(long)(yyvsp[-1].intval)); }
#line 8124 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 580:
#line 2769 "cfg.y" /* yacc.c:1652  */
    {
				elems[0].type = STR_ST;
				elems[0].u.data = (yyvsp[-11].strval);
				elems[1].type = STR_ST;
				elems[1].u.data = (yyvsp[-9].strval);
				elems[2].type = STR_ST;
				elems[2].u.data = (yyvsp[-7].strval);
				elems[3].type = STR_ST;
				elems[3].u.data = (yyvsp[-5].strval);
				elems[4].type = STR_ST;
				elems[4].u.data = (yyvsp[-3].strval);
				elems[5].type = SCRIPTVAR_ST;
				elems[5].u.data = (yyvsp[-1].specval);
				mk_action_((yyval.action), CONSTRUCT_URI_T,6,elems); }
#line 8143 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 581:
#line 2783 "cfg.y" /* yacc.c:1652  */
    {
				elems[0].type = SCRIPTVAR_ST;
				elems[0].u.data = (yyvsp[-3].specval);
				elems[1].type = SCRIPTVAR_ST;
				elems[1].u.data = (yyvsp[-1].specval);
				mk_action_((yyval.action), GET_TIMESTAMP_T,2,elems); }
#line 8154 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 582:
#line 2789 "cfg.y" /* yacc.c:1652  */
    {
				mk_action2((yyval.action), SCRIPT_TRACE_T, 0, 0, 0, 0); }
#line 8161 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 583:
#line 2791 "cfg.y" /* yacc.c:1652  */
    {
				pvmodel = 0;
				tstr.s = (yyvsp[-1].strval);
				tstr.len = strlen(tstr.s);
				if(pv_parse_format(&tstr, &pvmodel)<0)
					yyerror("error in second parameter");
				mk_action2((yyval.action), SCRIPT_TRACE_T, NUMBER_ST,
						   SCRIPTVAR_ELEM_ST, (void *)(yyvsp[-3].intval), pvmodel); }
#line 8174 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 584:
#line 2799 "cfg.y" /* yacc.c:1652  */
    {
				pvmodel = 0;
				tstr.s = (yyvsp[-3].strval);
				tstr.len = strlen(tstr.s);
				if(pv_parse_format(&tstr, &pvmodel)<0)
					yyerror("error in second parameter");
				mk_action3((yyval.action), SCRIPT_TRACE_T, NUMBER_ST,
						SCRIPTVAR_ELEM_ST, STR_ST, (void *)(yyvsp[-5].intval), pvmodel, (yyvsp[-1].strval)); }
#line 8187 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 585:
#line 2807 "cfg.y" /* yacc.c:1652  */
    {
				i_tmp = get_script_route_idx( (yyvsp[-1].strval), sroutes->request, RT_NO, 0);
				if (i_tmp==-1) yyerror("too many script routes");
				mk_action2((yyval.action), ASYNC_T, ACTIONS_ST, NUMBER_ST,
						(yyvsp[-3].action), (void*)(long)i_tmp);
				}
#line 8198 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 586:
#line 2813 "cfg.y" /* yacc.c:1652  */
    {
				i_tmp = get_script_route_idx( (yyvsp[-1].strval), sroutes->request, RT_NO, 0);
				if (i_tmp==-1) yyerror("too many script routes");
				mk_action2((yyval.action), LAUNCH_T, ACTIONS_ST, NUMBER_ST,
						(yyvsp[-3].action), (void*)(long)i_tmp);
				}
#line 8209 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 587:
#line 2819 "cfg.y" /* yacc.c:1652  */
    {
				mk_action2((yyval.action), LAUNCH_T, ACTIONS_ST, NUMBER_ST,
						(yyvsp[-1].action), (void*)(long)-1);
				}
#line 8218 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 588:
#line 2823 "cfg.y" /* yacc.c:1652  */
    {
				mk_action2((yyval.action), IS_MYSELF_T, STR_ST, 0, (yyvsp[-1].strval), 0);
				}
#line 8226 "cfg.tab.c" /* yacc.c:1652  */
    break;

  case 589:
#line 2826 "cfg.y" /* yacc.c:1652  */
    {
				mk_action2((yyval.action), IS_MYSELF_T, STR_ST, STR_ST, (yyvsp[-3].strval), (yyvsp[-1].strval));
				}
#line 8234 "cfg.tab.c" /* yacc.c:1652  */
    break;


#line 8238 "cfg.tab.c" /* yacc.c:1652  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;


#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif


/*-----------------------------------------------------.
| yyreturn -- parsing is finished, return the result.  |
`-----------------------------------------------------*/
yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 2832 "cfg.y" /* yacc.c:1918  */


static inline void ALLOW_UNUSED warn(char* s)
{
	LM_WARN("warning in config file %s, line %d, column %d-%d: %s\n",
			get_cfg_file_name, line, startcolumn, column, s);
}

static void yyerror(char* s)
{
	cfg_dump_backtrace();
	LM_CRIT("parse error in %s:%d:%d-%d: %s\n",
			get_cfg_file_name, line, startcolumn, column, s);
	cfg_dump_context(get_cfg_file_name, line, startcolumn, column);
	cfg_errors++;
}

#define ERROR_MAXLEN 1024
static void yyerrorf(char *fmt, ...)
{
	char *tmp = pkg_malloc(ERROR_MAXLEN);
	va_list ap;
	va_start(ap, fmt);

	vsnprintf(tmp, ERROR_MAXLEN, fmt, ap);
	yyerror(tmp);

	pkg_free(tmp);
	va_end(ap);
}


static struct socket_id* mk_listen_id(char* host, enum sip_protos proto,
																	int port)
{
	struct socket_id* l;
	l=pkg_malloc(sizeof(struct socket_id));
	if (l==0){
		LM_CRIT("cfg. parser: out of memory.\n");
	}else{
		memset(l, 0, sizeof(*l));
		l->name     = host;
		l->proto    = proto;
		l->port     = port;
	}

	return l;
}

static void fill_socket_id(struct listen_param *param, struct socket_id *s)
{
	s->flags |= param->flags;
	s->workers = param->workers;
	s->auto_scaling_profile = param->auto_scaling_profile;
	if (param->socket)
		set_listen_id_adv(s, param->socket->name, param->socket->port);
	s->tag = param->tag;
}

static struct multi_str *new_string(char *s)
{
	struct multi_str *ms = pkg_malloc(sizeof(struct multi_str));
	if (!ms) {
		LM_CRIT("cfg. parser: out of memory.\n");
	}else{
		ms->s    = s;
		ms->next = NULL;
	}
	return ms;
}

static struct socket_id* set_listen_id_adv(struct socket_id* sock,
											char *adv_name,
											int adv_port)
{
	sock->adv_name=adv_name;
	sock->adv_port=adv_port;
	return sock;
}

static int parse_ipnet(char *in, int len, struct net **ipnet)
{
	char *p = NULL;
	str ip_s, mask_s;
	struct ip_addr *ip = NULL, *mask = NULL, *ip_tmp;
	int af;
	unsigned int bitlen;

	p = q_memchr(in, '.', len);
	if (p)
		af = AF_INET;
	else if (q_memchr(in, ':', len)) {
		af = AF_INET6;
	} else {
		LM_ERR("Not an IP");
		return -1;
	}

	p = q_memchr(in, '/', len);
	if (!p) {
		LM_ERR("No netmask\n");
		return -1;
	}
	ip_s.s = in;
	ip_s.len = p - in;

	mask_s.s = p + 1;
	mask_s.len = len - ip_s.len - 1;
	if (!mask_s.s || mask_s.len == 0) {
		LM_ERR("Empty netmask\n");
		return -1;
	}

	ip_tmp = (af == AF_INET) ? str2ip(&ip_s) : str2ip6(&ip_s);
	if (!ip_tmp) {
		LM_ERR("Invalid IP\n");
		return -1;
	}
	ip = pkg_malloc(sizeof *ip);
	if (!ip) {
		LM_CRIT("No more pkg memory\n");
		return -1;
	}
	memcpy(ip, ip_tmp, sizeof *ip);

	p = (af == AF_INET) ? q_memchr(p, '.', len-(p-in)+1) : q_memchr(p, ':', len-(p-in)+1);
	if (p) {
		ip_tmp = (af == AF_INET) ? str2ip(&mask_s) : str2ip6(&mask_s);
		if (!ip_tmp) {
			LM_ERR("Invalid netmask\n");
			return -1;
		}
		mask = pkg_malloc(sizeof *mask);
		if (!mask) {
			LM_CRIT("No more pkg memory\n");
			return -1;
		}
		memcpy(mask, ip_tmp, sizeof *mask);

		*ipnet = mk_net(ip, mask);
	} else {
		if (str2int(&mask_s, &bitlen) < 0) {
			LM_ERR("Invalid netmask bitlen\n");
			return -1;
		}

		*ipnet = mk_net_bitlen(ip, bitlen);
	}

	pkg_free(ip);
	pkg_free(mask);

	if (*ipnet == NULL)
			return -1;

	return 0;
}
